<?php

// autoresponder module

class mgm_mailchimp extends mgm_autoresponder{

	

	// construct

	function __construct(){

		// php4 construct

		$this->mgm_mailchimp();

	}

	

	// construct

	function mgm_mailchimp(){

		// parent

		parent::mgm_autoresponder();

		// set code

		$this->code = __CLASS__; 

		// set name

		$this->name = 'MailChimp';

		// desc

		$this->description = __('MailChimp Desc.','mgm');

		// endpoint

		$this->_set_endpoint();

		// set path

		parent::set_tmpl_path();	

	}

	

	// settings_box

	function settings_box(){

		global $wpdb;

		// data

		$data = array();	

		// set 

		$data['module'] = mgm_get_option($this->code);

		// load template view

		return $this->load_template('settings_box', array('data'=>$data), true);		

	}

	

	// update

	function settings_update(){

		// form type 

		switch($_POST['setting_form']){

			case 'main':

			// form main

				echo json_encode(array('status'=>'success','message'=>$this->name . ' settings updated'));

			break;			

			case 'box':

			default:

			// from box	

				// set fields

				$this->setting['unique_id'] = $_POST['setting']['mailchimp']['unique_id'];

				$this->setting['apikey']    = $_POST['setting']['mailchimp']['apikey'];

				// call set endpoint for mailChimp, urls are composed by key

				$this->_set_endpoint();	

				// update option

				update_option($this->code, $this);							

				// send message

				echo json_encode(array('status'=>'success','message'=>$this->name . ' settings updated'));

			break;			

		}		

	}

	

	// set endpoint

	function _set_endpoint(){		

		// url

        list($key, $dc) = explode('-', $this->setting['apikey'], 2);

        if (!$dc) $dc = 'us1';

		

		$endpoint = 'https://'.$dc.'.'.'api.mailchimp.com/1.2/?output=php&method=listSubscribe'; 

		

		parent::_set_endpoint('live', $endpoint);

	}

	

	// set postfields

	function _set_postfields($user_id){

		$user         = get_userdata($user_id);			

		$user_email   = stripslashes($user->user_email);		

		$display_name = stripslashes($user->display_name);	

		

		$this->postfields = array(

								  "id"     => trim($this->setting['unique_id']),			

								  "apikey" => trim($this->setting['apikey']),								  

								  "email_address" => $user_email,

								  "merge_vars[FNAME]" => $display_name,

								  "submit" => "Submit"	

							);	

	}

}

// end file