<?php

// payment module
class mgm_2checkout extends mgm_payment{
	
	// construct
	function __construct(){
		// php4 construct
		$this->mgm_2checkout();
	}
	
	// php4 construct
	function mgm_2checkout(){
		// parent
		parent::__construct();
		// set code
		$this->code = __CLASS__; 
		// set name
		$this->name = '2Checkout';	
		// logo
		$this->logo = MGM_PLUGIN_MODULE_URL . 'payment/2checkout/assets/2co.jpg';
		// description
		$this->description = __('2Checkout.com is the authorized reseller for over 1.6 million tangible or digital products and services. Web businesses (suppliers/vendors) agree to sell their goods and services to 2CO for immediate resale.', 'mgm');
		// supported buttons types
	 	$this->supported_buttons = array('subscription', 'buypost');
		// trial support available ?
		$this->supports_trial = 'Y';	
		// cancellation support available ?
		$this->supports_cancellation= 'Y';	
		// do we depend on product mapping	
		$this->requires_product_mapping = 'Y'; 
		// endpoints
		$this->_set_endpoint('test',false); // test
		// $this->_set_endpoint('live','https://www.2checkout.com/checkout/purchase'); // live
		$this->_set_endpoint('live','https://www.2checkout.com/2co/buyer/purchase'); // live 2		
		$this->_set_endpoint('unsubscribe','https://www.2checkout.com/api/sales/stop_lineitem_recurring'); // unsubscribe
		$this->_set_endpoint('saledetail','https://www.2checkout.com/api/sales/detail_sale'); // saledetail
		// default settings
		$this->_default_setting();
		// set path
		parent::set_tmpl_path();	
	}
	
	// settings
	function settings(){
		global $wpdb;
		// data
		$data = array();		
		// set 
		$data['module'] = mgm_get_option($this->code);
		// load template view
		$this->load_template('settings', array('data'=>$data, 'ajax'=>true));
	}	
	
	// settings box api hook
	function settings_box(){
		global $wpdb;
		// data
		$data = array();	
		// set 
		$data['module'] = mgm_get_option($this->code);	
		// load template view
		return $this->load_template('settings_box', array('data'=>$data), true);		
	}
	
	// settings update
	function settings_update(){
		// form type 
		switch($_POST['setting_form']){
			case 'box':
			// from box			
				switch($_POST['act']){
					case 'logo_update':
						// logo if uploaded
						if(isset($_POST['logo_new_'.$this->code]) && !empty($_POST['logo_new_'.$this->code])){
							$this->logo = $_POST['logo_new_'.$this->code];
							// update option
							update_option($this->code, $this);
						}
						// message
						$message = $this->name . ' logo updated';			
						$extra   = array();
					break;
					case 'status_update':
					default:
						// enable
						$enable_state = ($_POST['payment']['enable'] == 'Y') ? 'Y' : 'N';
						// enable
						if($enable_state == 'Y'){
							$this->install();
							$stat = ' enabled.';
						}else{
						// disable
							$this->uninstall();	
							$stat = ' disabled.';
						}	
						
						# message
						$message = __($this->name . ' module is '. $stat, 'mgm');							
						$extra   = array('enable' => $enable_state);	
					break;
				}							
				// print message
				echo json_encode(array_merge(array('status'=>'success','message'=>$message,'module'=>array('name'=>$this->name,'code'=>$this->code,'tab'=>$this->settings_tab)), $extra));
			break;
			case 'main':
			default:
			// from main				
				// 2Checkout specific
				$this->setting['sid']          = $_POST['setting']['sid'];
				$this->setting['secret_word']  = $_POST['setting']['secret_word'];
				$this->setting['apiusername']  = $_POST['setting']['apiusername'];
				$this->setting['apipassword']  = $_POST['setting']['apipassword'];
				$this->setting['currency']     = $_POST['setting']['currency'];		
				$this->setting['lang']         = $_POST['setting']['lang'];							
				// purchase price
				if(isset($_POST['setting']['purchase_price'])){
					$this->setting['purchase_price']  = $_POST['setting']['purchase_price'];
				}
				// setup callback messages				
				$this->_setup_callback_messages($_POST['setting']);
				// re setup callback urls
				$this->_setup_callback_urls($_POST['setting']);
				// common
				$this->description = $_POST['description'];
				$this->status      = $_POST['status'];
				// logo if uploaded
				if(isset($_POST['logo_new_'.$this->code]) && !empty($_POST['logo_new_'.$this->code])){
					$this->logo = $_POST['logo_new_'.$this->code];
				}				
				// update option
				update_option($this->code, $this);
				//  message
				echo json_encode(array('status'=>'success','message'=> $this->name . ' settings updated'));
			break;
		}		
	}	
	
	// hook for post purchase setting
	function settings_post_purchase($data){
		// overwrite this
		$html=' <li>
					<label>'.__('2Checkout Product ID','mgm').' <input type="text" style="width: 50px;" name="mgm_post[product][2checkout_product_id]" value="'. $data->product['2checkout_product_id'].'" /></label>
				</li>';
		// return
		return $html;
	}
	
	// hook for post pack purchase setting
	function settings_postpack_purchase($data=false){
		// overwrite this
		$html=' <tr>
					<td colspan="2" align="left" height="30" valign="top"><div class="subscription-heading">'.__('2Checkout Settings','mgm').'</div></td>
				</tr>
				<tr>
					<td valign="top" align="left">'. __('Product ID','mgm').'</td>
					<td valign="top" align="left">
						<input type="text" name="product[2checkout_product_id]" value="'.esc_html($data['2checkout_product_id']).'" />
					</td>
				</tr>';
		// return
		return $html;
	}
	
	// hook for subscription package setting
	function settings_subscription_package($data){
		// overwrite this
		$html=' <tr>
					<td colspan="3" align="left" height="30" valign="top"><div class="subscription-heading">'.__('2Checkout Settings','mgm').'</div></td>
				</tr>
				<tr>
					<td valign="top" align="left">'. __('Product ID','mgm').'</td>
					<td valign="top" align="center">:</td>
					<td valign="top" align="left">
						<input type="text" name="packs['.($data['pack_ctr']-1).'][product][2checkout_product_id]" value="'.esc_html($data['pack']['product']['2checkout_product_id']).'" />
					</td>
				</tr>';
		// return
		return $html;
	}	
	
	// return process api hook, link back to site after payment is made
	function process_return() {				
		// check and show message
		if((isset($_REQUEST['custom']) && !empty($_REQUEST['custom']))){
			// process notify, internally called
			$this->process_notify();
			// redirect as success if not already redirected
			// query arg
			$query_arg = array('status'=>'success');
			// is a post redirect?
			$post_redirect =$this->_get_post_redirect($_REQUEST['custom']);
			// yes redirect argument passed
			if($post_redirect !==false){
				$query_arg['post_redirect'] = $post_redirect;
			}			
			// redirect
			wp_redirect(add_query_arg($query_arg, $this->setting['processed_url']));
		}else{			
			wp_redirect(add_query_arg(array('status'=>'error'), $this->setting['processed_url']));
		}
	}	
	
	// notify process api hook, background IPN url
	function process_notify() {				
		// verify 
		if ($this->_verify_callback()) {			
			// payment type
			$payment_type = $this->_get_payment_type($_POST['custom']);			
			// check
			switch($payment_type){
				// buypost 
				case 'buypost':
					$this->_buy_post(); //run the code to process a purchased post/page
				break;
				// subscription	
				case 'subscription':
					// cancellation
					if(isset($_POST['message_type']) && $_POST['message_type']=='RECURRING_STOPPED') {						
						$this->_cancel_membership(); //run the code to process a membership cancellation
					}else{
						$this->_buy_membership(); //run the code to process a new/extended membership
					}	
				break;	
				// other		
				default:					
					// bad 
					// mgm_log('error in payment_type : '.$payment_type);					
				break;							
			}			
		}
	}
	
	// process cancel api hook 
	function process_cancel(){
		// redirect to cancel page
		wp_redirect(add_query_arg(array('status'=>'cancel'), $this->setting['processed_url']));
	}	
	
	// unsubscribe process, IPN for unsubscribe 
	function process_unsubscribe(){
		// set auth
		$auth = $this->setting['apiusername']  . ':' . $this->setting['apipassword'];
		
		// get user id
		$user_id = $_POST['user_id'];
		
		// get user
		$user = get_userdata($user_id); 		
				
		// item id
		$sale_id = $user->mgm_member->payment_info->txn_id; 
		
		// endpoint
		$saledetail_url = $this->_get_endpoint('saledetail');
		if(!preg_match('/^https:\/\/www\.2checkout\.com/i', $saledetail_url)){
			$saledetail_url = 'https://www.2checkout.com/api/sales/detail_sale';
		}
		
		// url
		$url = add_query_arg(array('sale_id'=>$sale_id), $saledetail_url);		
				
		// post
		$response = $this->_curl_post($url, NULL, $auth, array("Accept: application/json") );	
		
		// decode 	
		$response = json_decode($response);
		
		$lineitem_id = '';		
		if((string)$response->response_code == 'OK'){
			$lineitem_id = (string)$response->sale->invoices[0]->lineitems[0]->billing->lineitem_id;			
		}
		
		// set post
		$post_body = array('vendor_id'=>$this->setting['sid'],'lineitem_id'=>$lineitem_id);
						   
		// fields
		$fields = mgm_http_build_query($post_body);	
		
		// url
		$url =  $this->_get_endpoint('unsubscribe');	
				
		// post
		$response = $this->_curl_post($url, $fields, $auth, array("Accept: application/json") );	
		
		// decode 	
		$response = json_decode($response);
		
		// check
		if((string)$response->response_code == 'OK'){
			$this->_cancel_membership($user_id);	
		}else{
			wp_redirect('wp-admin/profile.php?page=mgm/profile&unsubscribe_errors='.urlencode($response->errors[0]->message));
		}		
	}
		
	// subscribe button api hook
	function get_button_subscribe($options=array()){	
		// 2co depends on product id, check for it before generating button
		if(!isset($options['pack']['product']['2checkout_product_id']) || intval($options['pack']['product']['2checkout_product_id'])==0){
			return '<div style="color:red; font-style:oblique; text-align:center; height:100px; padding:15px; vertical-align:middle"><b>Error in 2Checkout : No Product ID set.</b></div>';
			exit;
		}	
		// mgm_array_dump($options);
		$button_code     = $this->_get_button_code($options['pack']);
		$additional_code = do_action('mgm_additional_code');
		$html='<form action="'. $this->_get_endpoint() .'" method="post" class="mgm" name="' . $this->code . '_form" id="' . $this->code . '_form">
					'. $button_code .'				
					'. $additional_code .'
					<input type="image" src="' . mgm_fix_url($this->logo) . '" border="0" name="submit" alt="' . $this->name . '">
					<div class="mgm_paymod_description">'. $this->description .'</div>
				</form>';
		return $html;		
	}
	
	// buypost button api hook
	function get_button_buypost($options=array(), $return = false) {
		global $user;
		// 2co depends on product id, check for it before generating button
		if(!isset($options['pack']['product']['2checkout_product_id']) || intval($options['pack']['product']['2checkout_product_id'])==0){
			return '<div style="color:red; font-style:oblique; text-align:center; height:100px; padding:15px; vertical-align:middle"><b>Error in 2Checkout : No Product ID set.</b></div>';
			exit;
		}	
		// merge pack
		$options['pack'] = array_merge($options['pack'], array('duration'=>1, 'item_name'=>'Purchase Post - '.$options['pack']['title'], 'buypost'=>1));
		// button code		
		$button_code = $this->_get_button_code($options['pack']);
		$additional_code = do_action('mgm_additional_code');
		// html
		$html = '<table width="100%" border="0" cellpadding="0" cellspacing="0" align="center" class="form-table">
					<form action="'. $this->_get_endpoint() .'" method="post" class="mgm" name="' . $this->code . '_form" id="' . $this->code . '_form">
						 <tr>
							 <td align="center">
								 '. $button_code .'							 
								 '. $additional_code .'
								 <input type="image" src="' . mgm_fix_url($this->logo) . '" name="submit" alt="' . $this->name . '">
								 <div class="mgm_paymod_description">'. $this->description .'</div>
							 </td>
						 </tr>
					 </form>
				</table>';

		if ($return) {
			return $html;
		} else {
			echo $html;
		}
	}
	
	// dependency_check
	/*
	function dependency_check(){
		$this->dependency = array();
		if(!extension_loaded('curl') && !extension_loaded('curl')){
			$this->dependency[] = '<b style="color:#FF1F3D">CURL PHP extension must be loaded for PAYPAL.</b>';
		}
		// error		
		return (count($this->dependency)>0) ? true : false ;
	}
	*/
	
	/////////////////////////////////////////////// internal/private methods /////////////////////////////////////////////////
	
	// get button code	
	function _get_button_code($pack) {
		$data   = $this->_get_button_data($pack);
		$return = '';	
		foreach ($data as $key => $value) {
			$return .= '	<input type="hidden" name="'. $key .'" value="'. $value .'" />' . "\n";
		}	
		return $return;
	}

	// get button data
	function _get_button_data($pack) {
		// system setting
		$system  = mgm_get_option('mgm_system');			
		$user_id = mgm_get_user_id();
		$user    = get_userdata($user_id); 	
		// setup data array		
		$data = array(			
			'sid'          => $this->setting['sid'],
			//'product_name' => ($pack['item_name'] ? $pack['item_name'] : $system->setting['subscription_name']),
			//updated here on 2011 Feb 24 for issue: 289 					
			'product_name' => ($pack['item_name'] ? $pack['item_name'] : $system->get_subscription_name($pack)),					
			'tco_currency' => $this->setting['currency'],
			'lang'	       => $this->setting['lang'],
			'return_url'   => $this->setting['return_url'],
			'email'	       => $user->user_email,       
		);
		
		// address fields
		$this->_set_address_fields($user, $data, array('address'=>'street_address'));// see parent for all fields, only different given here
		
		// use product id
		if(isset($pack['product']['2checkout_product_id'])){
			$data['product_id'] = $pack['product']['2checkout_product_id'];	
			$data['quantity']   = 1;
		}else{
		// use total
			$data['total'] = $pack['cost'];
		} 
		// Purchase Post
		if ($pack['buypost'] == 1 ) {
			if (isset($pack['ppp_pack_id'])) {
				// get comma separated list of post ids					
				$pack['post_id'] = mgm_get_ppp_pack_post_csv($pack['ppp_pack_id']);
			} else {
				// single post
				$pack['post_id'] = get_the_ID();	
			}
		} 	
		
		// test flag
		if($this->status =='test'){
		 	$data['demo'] = 'Y';
		} 
		
		// remove the Continue Shopping button and lock the quantity fields.		
		$data['fixed'] = 'Y';
		// custom
		$data['custom'] = $this->_set_payment_type($pack, $this->setting['currency']);
		
		// return data
		return $data;
	}	
	
	// verify callback 
	function _verify_callback(){	
		
		// post
        $order_number = $_POST["order_number"];
        $order_total  = $_POST["total"];
			
		// If demo mode, the order number must be forced to 1
        if($this->status == "test" || $_POST['demo'] == 'Y')
        {
            $order_number = 1;
        }

        // Calculate md5 hash as 2co formula: md5(secret_word + vendor_number + order_number + total)
        $key = strtoupper(md5($this->setting['secret_word'] . $this->setting['sid'] . $order_number . $order_total));
		
		// verify if the key is accurate
        if($_POST['key'] == $key || $_POST['x_MD5_Hash'] == $key)
        {
            // success 
            return true;
        }
		// error
		return false;
	}	
	
	// buy post
	function _buy_post() {
		global $wpdb;

		$system = mgm_get_option('mgm_system');
		$dge  = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;
		
		list($duration, $cost, $currency, $user_id, $post_id, $user_id, $client_ip) = explode('_', preg_replace('/^buypost_/','', $_POST['custom']));

		// find user
		$user     = get_userdata($user_id);
		$blogname = get_option('blogname');
		$tran_success = false;
		switch ($_POST['credit_card_processed']) {
			case 'Y':
				$tran_success = true;
				$status_str = __('Last payment was successful','mgm');
				//$subject = sprintf(__('[%s] Payment receipt','mgm'),$blogname);
				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />This is a notification to inform you that your payment was successful and the post you purchased is now available to view.<br />For more information please contact %4$s','mgm');
				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $system->setting['admin_email']);
				 //issue#: 280 (2011 Feb 25)
				// subject
				$subject = $system->get_template('payment_success_email_template_subject', array('blogname'=>$blogname), true);
				// body
				$message = $system->get_template('payment_success_email_template_body', 
										array('blogname'=>$blogname, 'name'=>$user->display_name, 
											  'email'=>$user->user_email, 
											  'admin_email'=>$system->setting['admin_email']), true);
				// after succesful payment hook
				do_action('mgm_buy_post_transaction_success', array("post_id"=>$post_id));
			break;

			case 'K':			
				$status_str = __('Last payment was refunded or denied','mgm');
				//$subject = sprintf(__('[%s] Payment Failed','mgm'), $blogname);
				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />This is a notification to inform you that your post purchase failed for the following reason: %4$s.<br />For more information please contact %5$s.','mgm');
				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $status_str, $system->setting['admin_email']);
				 //issue#: 280 (2011 Feb 25)
				// subject
				$subject = $system->get_template('payment_failed_email_template_subject', array('blogname'=>$blogname), true);
				 
				// body			
				$message = $system->get_template('payment_failed_email_template_body', 
										array('blogname'=>$blogname, 'name'=>$user->display_name, 
											  'email'=>$user->user_email, 'payment_type'=>'post purchase payment','reason'=>$status_str,
											  'admin_email'=>$system->setting['admin_email']), true);
				break;

			case 'K':
				$reason = 'unknown';
				$status_str = sprintf(__('Last payment is pending. Reason: %s','mgm'), $reason);
				//$subject = "[" . $blogname . "] Payment receipt - Status Pending";
				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />This is a notification to inform you that you payment was received in pending status. Status: %4$s.<br />For more information please contact %5$s','mgm');
				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $status_str, $system->setting['admin_email']);
				 //issue#: 280 (2011 Feb 25)
				// subject
				$subject = $system->get_template('payment_pending_email_template_subject', array('blogname'=>$blogname), true);
				// body	
				$message = $system->get_template('payment_pending_email_template_body', 
										array('blogname'=>$blogname, 'name'=>$user->display_name, 
											  'email'=>$user->user_email, 'reason'=>$status_str,
											  'admin_email'=>$system->setting['admin_email']), true);
				break;

			default:
				$status_str = sprintf(__('Last payment status: %s','mgm'),$_POST['credit_card_processed']);
				//$subject = "[$blogname] Payment receipt";
				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />Status: %4$s.<br />For more information please contact %5$s','mgm');
				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $status_str, $system->setting['admin_email']);
				 //issue#: 280 (2011 Feb 25)
				// subject
				$subject = $system->get_template('payment_unknown_email_template_subject', array('blogname'=>$blogname), true);				
				// body	
				$message = $system->get_template('payment_unknown_email_template_body', array('blogname'=>$blogname, 'name'=>$user->display_name, 
				                                                                              'email'=>$user->user_email, 'reason'=>$status_str,
																							  'admin_email'=>$system->setting['admin_email']), true);
		}
		// notify user
		mgm_mail($user->user_email, $subject, $message); //send an email to the buyer

		$status = __('Failed join', 'mgm'); //overridden on a successful payment
		if ($tran_success) {
			$table_name = TBL_MGM_POSTS_PURCHASED;
			
			//if we are looking at a pack then explode the buy post item number and loop through it
			if (strpos($post_id, ',') !== false) {
				$posts = explode(',', $post_id);
			} else {
				$posts = array($post_id);
			}
			
			$posts = array_unique($posts);
			
			foreach ($posts as $post_id) {
				$sql = "INSERT INTO " . $table_name . " (user_id, post_id, unixtime)
					    VALUES (" . $user_id . ", " . $post_id . ", UNIX_TIMESTAMP())";
				$wpdb->query($sql); //insert the post purchased record
			}

			$status = __('The post was purchased successfully', 'mgm');
		}

		// notify admin, only if gateway emails on
		if (!$dge) {
			$subject = "[" . $blogname . "] Admin Notification: " . $user->user_email . " purchased post " . $post_id;
			$message = "User display name: {$user->display_name}<br />User email: {$user->user_email}<br />User ID: {$user->ID}<br />Status: " . $status . "<br />Action: Purchase post:" . $subject . "<br /><br />" . $message . "<br /><br /><pre>" . print_r($_POST, true) . '</pre>';
			mgm_mail($system->setting['admin_email'], $subject, $message);
		}
	}
	
	// buy membership
	function _buy_membership() {	
		// system	
		$system       = mgm_get_option('mgm_system');		
		$packs        = mgm_get_option('mgm_subscription_packs');
		$duration_str = $packs->duration_str;
		//$status_str   = $system->get_statuses();
		$dge          = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;
		// get custom field values
		list($duration, $amount, $currency, $user_id, $membership_type, $duration_type, $role, $client_ip, $hide_old_content, $pack_id) = explode('_', preg_replace('/^subscription_/','', $_POST['custom']));
		
		// currency
		if (!$currency) {
			$currency = $this->setting['currency'];
		}
		// find user
		$user       = get_userdata($user_id);
		$mgm_member = mgm_get_member($user_id);
		
		// mgm_log('user/member : '.print_r($user,true).print_r($mgm_member,true));
		
		$join_date = $mgm_member->join_date; // Get the current AC join date

		if (!$join_date) {
			$mgm_member->join_date = time(); // Set current AC join date
		}

		//if there is no duration set in the user object then run the following code
		if (empty($duration_type)) {
			//if there is no duration type then use Months
			$duration_type = 'm';
		}
		// membership type default
		if (empty($membership_type)) {
			//if there is no account type in the custom string then use the existing type
			$membership_type = md5($mgm_member->membership_type);
		}
		// validate parent method
		$membership_type_verified = $this->_validate_membership_type($membership_type, 'md5|plain');
		// verified
		if (!$membership_type_verified) {
			if (strtolower($mgm_member->membership_type) != 'free') {
				// notify admin, only if gateway emails on
				if(!$dge){
					$message = 'Could not read membership type in the following POST data. Please debug or contact magic members to fix the problem making sure to pass on the following data. <br /><br /><pre>' . "\n\n" . print_r($_POST, true) . '</pre>';
					mgm_mail($system->setting['admin_mail'], 'Error in 2Checkout membership verification', $message);
				}
				// abort
				return;
			} else {
				$membership_type_verified = $mgm_member->membership_type;
			}
		}
		// set
		$membership_type = $membership_type_verified;
		// duration
		$mgm_member->duration        = $duration;
		$mgm_member->duration_type   = strtolower($duration_type);
		$mgm_member->amount          = $amount;
		$mgm_member->currency        = $currency;
		$mgm_member->membership_type = $membership_type;	
		$mgm_member->pack_id         = $pack_id;	
		$mgm_member->payment_type    = 'subscription';
		// payment info for unsubscribe		
		$mgm_member->payment_info    = new stdClass;
		$mgm_member->payment_info->module = $this->code;
		if(isset($_POST['message_type'])){
			$mgm_member->payment_info->txn_type = $_POST['message_type'];
		}	
		if(isset($_POST['order_number'])){
			$mgm_member->payment_info->subscr_id = $_POST['order_number'];		
		}	
		if(isset($_POST['order_number'])){	
			$mgm_member->payment_info->txn_id = $_POST['order_number'];	
		}
		
		// process PayPal response
		$new_status = false;
		// status
		switch ($_POST['credit_card_processed']) {
			case 'Y':
				$new_status = MGM_STATUS_ACTIVE;
				$mgm_member->status_str = __('Last payment was successful','mgm');					
				
				$time = time();				
				$mgm_member->last_pay_date = date('Y-m-d', $time);				
				
				// THIS is causng double calculation
				/* ***********************************/
				if ($mgm_member->expire_date && $mgm_member->last_pay_date!=date('Y-m-d', $time)) {
					$expiry = strtotime($mgm_member->expire_date);
					if ($expiry > 0) {
						if ($expiry > $time) {
							$time = $expiry;
						}
					}
				}
				/*************************************/					
				
				// type expanded
				$duration_types = array('d'=>'DAY','m'=>'MONTH','y'=>'YEAR');
				// time
				$time = strtotime("+{$mgm_member->duration} {$duration_types[$mgm_member->duration_type]}", $time);							
				// formatted
				$time_str = date('Y-m-d', $time);				
				// date extended				
				if (!$mgm_member->expire_date || strtotime($time_str) > strtotime($mgm_member->expire_date)) {
					$mgm_member->expire_date = $time_str;										
				}
								
				// role
				if ($role) {
					$role_obj = new WP_User($user_id);
					$role_obj->set_role($role);
				}			
				
				// after succesful payment hook
				do_action('mgm_membership_transaction_success', array("user_id" =>$user_id));	

			break;
			case 'K':
			
				$new_status = MGM_STATUS_NULL;
				$mgm_member->status_str = __('Last payment was refunded or denied','mgm');
				break;

			case 'Pending':
				$new_status = MGM_STATUS_PENDING;

				$reason = 'Unknown';
				$mgm_member->status_str = sprintf(__('Last payment is pending. Reason: %s','mgm'), $reason);
				break;

			default:
				$new_status = MGM_STATUS_ERROR;
				$mgm_member->status_str = sprintf(__('Last payment status: %s','mgm'), $_POST['credit_card_processed']);
				break;
		}
				
		// set status
		$mgm_member->status = $new_status;
		// update option
		update_user_option($user_id, 'mgm_member', $mgm_member, true);				

		// return action
		do_action('mgm_return_2checkout');

		// send email notification to client
		$blogname = get_option('blogname');
		switch ($new_status) {
			case MGM_STATUS_ACTIVE:
				//$subject = sprintf(__('[%s] Payment receipt','mgm'),$blogname);
				//issue#: 280 (2011 Feb 25)
				// subject
				$subject = $system->get_template('payment_success_email_template_subject', array('blogname'=>$blogname), true);
				if ($mgm_member->payment_type == 'subscription') {
					//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your payment was successful for recurring subscription of %4$s %5$s every %6$s %7$s. For more information please contact %8$s','mgm');
					$payment_type = 'recurring subscription';
					$subscription = sprintf('%1$s %2$s every %3$s %4$s',$mgm_member->amount, $mgm_member->currency, $mgm_member->duration, 
					                                                    $duration_str[$mgm_member->duration_type]);
				} else {
					//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your payment was successful for a one-time payment of %4$s %5$s for %6$s %7$s. For more information please contact %8$s','mgm');
					$payment_type = 'one-time payment';
					$subscription = sprintf('%1$s %2$s for %3$s %4$s',$mgm_member->amount, $mgm_member->currency, $mgm_member->duration, 
					                                                  $duration_str[$mgm_member->duration_type]);
				}

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->amount, $mgm_member->currency, $mgm_member->duration, $duration_str[$mgm_member->duration_type], $system->setting['admin_email']);
				// body
				$message = $system->get_template('payment_success_subscription_email_template_body', 
													array('blogname'=>$blogname, 'name'=>$user->display_name, 
														  'email'=>$user->user_email, 'payment_type'=>$payment_type,
														  'subscription'=>$subscription,'admin_email'=>$system->setting['admin_email']), true);
				break;

			case MGM_STATUS_NULL:
				//issue#: 280 (2011 Feb 25)
				//$subject = sprintf(__('[%s] Account inactive','mgm'), $blogname);
				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your account is inactive for the following reason: %4$s. For more information please contact %5$s','mgm');
				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->status_str, $system->setting['admin_email']);
				// subject
				$subject = $system->get_template('payment_failed_email_template_subject', array('blogname'=>$blogname), true);				
				// message
				$message = $system->get_template('payment_failed_email_template_body', 
									array('blogname'=>$blogname, 'name'=>$user->display_name, 
										  'email'=>$user->user_email, 'payment_type'=>'subscription payment',
										  'reason'=>$mgm_member->status_str,
										  'admin_email'=>$system->setting['admin_email']), true);
				break;

			case MGM_STATUS_PENDING:
				//issue#: 280 (2011 Feb 25)
				//$subject = "[$blogname] Payment receipt - Status Pending";
				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that you payment was received in pending status. Status: %4$s. For more information please contact %5$s','mgm');
				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->status_str, $system->setting['admin_email']);
				// subject
				$subject = $system->get_template('payment_pending_email_template_subject', array('blogname'=>$blogname), true);
				// body
				$message = $system->get_template('payment_pending_email_template_body', 
										array('blogname'=>$blogname, 'name'=>$user->display_name, 
											  'email'=>$user->user_email, 'reason'=>$mgm_member->status_str,
											  'admin_email'=>$system->setting['admin_email']), true);
				break;

			case MGM_STATUS_ERROR:
				//issue#: 280 (2011 Feb 25)
				//$subject = "[$blogname] Error on payment";
				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that an error occurred while processing your payment. Details: %4$s. For more information please contact %5$s','mgm');
				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->status_str, $system->setting['admin_email']);
				// subject
				$subject = $system->get_template('payment_error_email_template_subject', array('blogname'=>$blogname), true);				
				// body	
				$message = $system->get_template('payment_error_email_template_body', 
									array('blogname'=>$blogname, 'name'=>$user->display_name, 
										  'email'=>$user->user_email, 'reason'=>$mgm_member->status_str,
										  'admin_email'=>$system->setting['admin_email']), true);
				break;
		}

		// notify user
		mgm_mail($user->user_email, $subject, $message);

		// notify admin, only if gateway emails on
		if (!$dge) {
			$subject = "[$blogname] {$user->user_email} - {$new_status}";
			$message = "	User display name: {$user->display_name}\n\n<br />
					User email: {$user->user_email}\n\n<br />
					User ID: {$user->ID}\n\n<br />
					Membership Type: {$membership_type}\n\n<br />
					New status: {$new_status}\n\n<br />
					Status message: {$mgm_member->status_str}\n\n<br />
					Subscription period: {$mgm_member->duration} ". $duration_str[$mgm_member->duration_type] ."\n\n<br />
					Subscription amount: {$mgm_member->amount} {$mgm_member->currency}\n<br />
					Payment Mode: {$mgm_member->payment_type}\n\n<br />
					POST Data was: \n\n<br /><br /><pre>" . print_r($_POST, true) . '</pre>';
			mgm_mail($system->setting['admin_email'], $subject, $message);
		}
	}
	
	// cancel membership
	function _cancel_membership($user_id=NULL){
		// system	
		$system       = mgm_get_option('mgm_system');		
		$packs        = mgm_get_option('mgm_subscription_packs');
		$duration_str = $packs->duration_str;
		//$status_str   = $system->get_statuses();
		$dge          = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;
		// get custom field values
		if(!$user_id){	
			list($duration, $amount, $currency, $user_id, $membership_type, $duration_type, $role, $client_ip, $hide_old_content, $pack_id) = explode('_', preg_replace('/^subscription_/','', $_POST['custom']));
		}	
		
		// find user
		$user       = get_userdata($user_id);
		$mgm_member = mgm_get_member($user_id);		
		
		// get pack
		if($mgm_member->pack_id){
			$subs_pack = $packs->get_pack($mgm_member->pack_id);
		}else{
			$subs_pack = $packs->validate_pack($mgm_member->amount, $mgm_member->duration, $mgm_member->duration_type, $mgm_member->membership_type);
		}
		
		// reset payment info
		if(isset($_POST['message_type'])){
			$mgm_member->payment_info->txn_type = $_POST['message_type'];
		}	
		if(isset($_POST['order_number'])){
			$mgm_member->payment_info->subscr_id = $_POST['order_number'];		
		}	
		if(isset($_POST['order_number'])){	
			$mgm_member->payment_info->txn_id = $_POST['order_number'];	
		}	
		
		// types
		$duration_types = array('d'=>'DAY','m'=>'MONTH','y'=>'YEAR');	
						
		// default expire date				
		$expire_date = $mgm_member->expire_date;					
		// if trial on 
		if ($subs_pack['trial_on']) {			
			// if cancel data is before trial end, set cancel on trial expire_date
			$trial_expire_date = strtotime("+{$subs_pack['trial_duration']} {$duration_types[$subs_pack['trial_duration_type']]}", $mgm_member->join_date);
			
			// if lower
			if(time() < $trial_expire_date){
				$expire_date = date('Y-m-d',$trial_expire_date);
			}
		}	
			
		// if today 
		if($expire_date == date('Y-m-d')){
			$new_status = MGM_STATUS_CANCELLED;
			$mgm_member->status_str = __('Subscription Cancelled','mgm');					
			$mgm_member->expire_date = date('Y-m-d');	
			// set status
			$mgm_member->status = $new_status;
		}else{
			$new_status = MGM_STATUS_AWAITING_CANCEL;			
			// reset on
			$mgm_member->status_reset_on = $expire_date;
			$mgm_member->status_reset_as = MGM_STATUS_CANCELLED;
		}
		
		// update user
		update_user_option($user_id, 'mgm_member', $mgm_member, true);		
			
		// send email notification to client
		$blogname = get_option('blogname');
		//issue#: 280 (2011 Feb 25)
		// email	
		//$subject = sprintf(__('[%s] Subscription Cancelled','mgm'),$blogname);				
		//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your subscription has been cancelled. For more information please contact %4$s','mgm');
		//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $system->setting['admin_email']);
		
		// subject
		$subject = $system->get_template('subscription_cancelled_email_template_subject', array('blogname'=>$blogname), true);				
		// body	
		$message = $system->get_template('subscription_cancelled_email_template_body', 
							array('blogname'=>$blogname, 'name'=>$user->display_name, 
								  'email'=>$user->user_email, 'admin_email'=>$system->setting['admin_email']), true);
								  
		// send email notification to user
		mgm_mail($user->user_email, $subject, $message);

		// notify admin, only if gateway emails on
		if (!$dge) {
			$subject = "[$blogname] {$user->user_email} - {$new_status}";
			$message = "	User display name: {$user->display_name}\n\n<br />
					User email: {$user->user_email}\n\n<br />
					User ID: {$user->ID}\n\n<br />
					Membership Type: {$membership_type}\n\n<br />
					New status: {$new_status}\n\n<br />
					Status message: {$mgm_member->status_str}\n\n<br />					
					Payment Mode: Cancelled\n\n<br />";
			mgm_mail($system->setting['admin_email'], $subject, $message);
		}
		
		// after cancellation hook
		do_action('mgm_membership_subscription_cancelled', array("user_id" =>$user_id));	
		
		// message
		$message = sprintf(__("You have successfully Unsubscribed. Your account is marked for Cancellation on %s", "mgm"), ($expire_date == date('Y-m-d') ? 'Today' : date(MGM_DATE_FORMAT_LONG, strtotime($expire_date)) ));
	
		// redirect 
		wp_redirect('wp-admin/profile.php?page=mgm/profile&unsubscribed=true&unsubscribe_errors='.urlencode($message));
	}
	
	// list fo available languages
	function _get_languages(){
		$languages = array(
						   'zh'    => __('Chinese','mgm'),	
						   'da'    => __('Danish','mgm'),	
						   'nl'    => __('Dutch','mgm'),
						   'en'    => __('English (default)','mgm'),
						   'fr'    => __('French','mgm'),
						   'gr'    => __('German','mgm'),						   
						   'el'    => __('Greek','mgm'),
						   'it'    => __('Italian','mgm'),
						   'jp'    => __('Japanese','mgm'),
						   'no'    => __('Norwegian','mgm'),
						   'pt'    => __('Portugese','mgm'),
						   'sl'    => __('Slovenian','mgm'),
						   'es_ib' => __('Spanish (es_ib)','mgm'),
						   'es_la' => __('Spanish (es_la)','mgm'),
						   'sv'    => __('Swedish','mgm'));		
		return $languages;
	}
	
	// default setting
	function _default_setting(){
		// 2checkout specific
		$this->setting['sid']         = '';	
		$this->setting['secret_word'] = '';	
		$this->setting['apiusername'] = '';
		$this->setting['apipassword'] = '';
		$this->setting['currency']    = mgm_get_option('mgm_system')->setting['currency'];
		$this->setting['lang']        = 'en';	
		// purchase price
		if(in_array('buypost', $this->supported_buttons)){
			$this->setting['purchase_price']  = 4.00;		
		}		
		// callback messages				
		$this->_setup_callback_messages();
		// callback urls
		$this->_setup_callback_urls();			
	}	
	
	// curl post
	function _curl_post($url, $post_fields=NULL, $auth, $http_header=array()){
		// init
		$ch = curl_init();		
		curl_setopt($ch, CURLOPT_URL, $url); 	
		// when set
		if(is_array($http_header)){	
			curl_setopt($ch, CURLOPT_HTTPHEADER, $http_header);	
		}		
		curl_setopt($ch, CURLOPT_HEADER, 0);	
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0); 
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0); 
		curl_setopt($ch, CURLOPT_NOPROGRESS, 1); 
		curl_setopt($ch, CURLOPT_VERBOSE, 1); 
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 0); 
		// post
		if($post_fields){
			curl_setopt($ch, CURLOPT_POST, 1); 
			curl_setopt($ch, CURLOPT_POSTFIELDS, $post_fields); 
		}
		curl_setopt($ch, CURLOPT_TIMEOUT, 30); 
		curl_setopt($ch, CURLOPT_USERAGENT, 'Magic Members Membership Software'); 
		curl_setopt($ch, CURLOPT_REFERER, get_option('siteurl')); 
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		// auth
		if($auth){
			curl_setopt($ch, CURLOPT_USERPWD, $auth);
			curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
		}	
		// buffer
		$buffer = curl_exec($ch);
		curl_close($ch);
		
		// return
		return $buffer;		
	}
}

// end file