<?php

// payment module

class mgm_alertpay extends mgm_payment{

	

	// construct

	function __construct(){

		// php4 construct

		$this->mgm_alertpay();

	}

	

	// php4 construct

	function mgm_alertpay(){

		// parent

		parent::__construct();

		// set code

		$this->code = __CLASS__; 

		// set name

		$this->name = 'AlertPay';

		// logo

		$this->logo = MGM_PLUGIN_MODULE_URL . 'payment/alertpay/assets/alertpay.png';

		// description

		$this->description = __('A comprehensive all-in-one solution for your payment needs.AlertPay is an account-based payment processor allowing just about 

		                         anyone with an email address to securely send and receive money with their credit card or bank account. .', 'mgm');

		// supported buttons types

	 	$this->supported_buttons = array('subscription', 'buypost');

		// trial support available ?

		$this->supports_trial= 'Y';		

		// cancellation support available ?

		$this->supports_cancellation= 'Y';	

		// do we depend on product mapping	

		$this->requires_product_mapping = 'N';

		// endpoints

		$this->_set_endpoint('test','https://www.alertpay.com/PayProcess.aspx'); // test

		$this->_set_endpoint('live','https://www.alertpay.com/PayProcess.aspx'); // live

		$this->_set_endpoint('unsubscribe','https://api.alertpay.com/svc/api.svc/CancelSubscription'); // cancel subscription

		

		// default settings

		$this->_default_setting();		

		// set path

		parent::set_tmpl_path();	

	}

	

	// settings

	function settings(){

		global $wpdb;

		// data

		$data = array();		

		// set 

		$data['module'] = mgm_get_option($this->code);

		// load template view

		$this->load_template('settings', array('data'=>$data, 'ajax'=>true));

	}	

	

	// settings box api hook

	function settings_box(){

		global $wpdb;

		// data

		$data = array();	

		// set 

		$data['module'] = mgm_get_option($this->code);	

		// load template view

		return $this->load_template('settings_box', array('data'=>$data), true);		

	}

	

	// settings update

	function settings_update(){

		// form type 

		switch($_POST['setting_form']){

			case 'box':

			// from box			

				switch($_POST['act']){

					case 'logo_update':

						// logo if uploaded

						if(isset($_POST['logo_new_'.$this->code]) && !empty($_POST['logo_new_'.$this->code])){

							$this->logo = $_POST['logo_new_'.$this->code];

							// update option

							update_option($this->code, $this);

						}

						// message

						$message = $this->name . ' logo updated';			

						$extra   = array();

					break;

					case 'status_update':

					default:

						// enable

						$enable_state = ($_POST['payment']['enable'] == 'Y') ? 'Y' : 'N';

						// enable

						if($enable_state == 'Y'){

							$this->install();

							$stat = ' enabled.';

						}else{

						// disable

							$this->uninstall();	

							$stat = ' disabled.';

						}	

						

						# message

						$message = __($this->name . ' module is '. $stat, 'mgm');							

						$extra   = array('enable' => $enable_state);		

					break;

				}							

				// print message

				echo json_encode(array_merge(array('status'=>'success','message'=>$message,'module'=>array('name'=>$this->name,'code'=>$this->code,'tab'=>$this->settings_tab)), $extra));

			break;

			case 'main':

			default:

			// from main				

				// alertpay specific

				$this->setting['ap_merchant']     = $_POST['setting']['ap_merchant'];

				$this->setting['ap_securitycode'] = $_POST['setting']['ap_securitycode'];

				$this->setting['ap_apipassword']  = $_POST['setting']['ap_apipassword'];

				$this->setting['currency']        = $_POST['setting']['currency'];												

				// purchase price

				if(isset($_POST['setting']['purchase_price'])){

					$this->setting['purchase_price']  = $_POST['setting']['purchase_price'];

				}

				// setup callback messages				

				$this->_setup_callback_messages($_POST['setting']);

				// re setup callback urls

				$this->_setup_callback_urls($_POST['setting']);

				// common

				$this->description = $_POST['description'];

				$this->status      = $_POST['status'];

				// logo if uploaded

				if(isset($_POST['logo_new_'.$this->code]) && !empty($_POST['logo_new_'.$this->code])){

					$this->logo = $_POST['logo_new_'.$this->code];

				}				

				// update option

				update_option($this->code, $this);

				//  message

				echo json_encode(array('status'=>'success','message'=> $this->name . ' settings updated'));

			break;

		}		

	}

	

	// return process api hook, link back to site after payment is made

	function process_return() {		

		// check and show message

		if(isset($_REQUEST['apc_1'])){

			// query arg

			$query_arg = array('status'=>'success');

			// is a post redirect?

			if(isset($_REQUEST['apc_1'])){

				$post_redirect = $this->_get_post_redirect($_REQUEST['apc_1']);

				// yes redirect argument passed

				if($post_redirect !== false){

					$query_arg['post_redirect'] = $post_redirect;

				}			

			}

			// redirect

			wp_redirect(add_query_arg($query_arg, $this->setting['processed_url']));

		}else{			

			wp_redirect(add_query_arg(array('status'=>'error'), $this->setting['processed_url']));

		}

	}	

	

	// notify process api hook, background IPN url

	function process_notify() {		

		// overwrite this		

		if (!isset($_POST['ap_referencenumber']) || !isset($_POST['apc_1']) ) {

			// Did not find expected POST variables. Possible access attempt from a non PayPal site.

			echo 'Error in IPN. Missing payment_status or custom.';

			exit;

		} else {			

			// set success for test

			if($_POST['ap_test'] == 1 ){

				$_POST['ap_status'] = 'Success';

			}

			// ipn

			$this->_verify_callback();			

			// payment type

			$payment_type = $this->_get_payment_type($_POST['apc_1']);

			// check

			switch($payment_type){

				// buypost 

				case 'buypost':

					$this->_buy_post(); //run the code to process a purchased post/page

				break;

				// subscription	

				case 'subscription':				

					$this->_buy_membership(); //run the code to process a new/extended membership						

				break;	

				// other		

				default:

					// error				

				break;							

			}			

		}

	}	

	

	// process cancel api hook 

	function process_cancel(){

		// redirect to cancel page

		wp_redirect(add_query_arg(array('status'=>'cancel'), $this->setting['processed_url']));

	}	

	

	// unsubscribe process, proxy for unsubscribe

	function process_unsubscribe(){

		// get user id

		$user_id = $_POST['user_id'];

		// get user

		$user = get_userdata($user_id); 		

		

		// compose post body 

		$post_body = array('USER'=>$this->setting['ap_merchant'],'PASSWORD'=>$this->setting['ap_apipassword'],

						   'SUBSCRIPTIONREFERENCE'=>$user->mgm_member->payment_info->subscr_id,

						   'NOTE'=>sprintf('Cancellation selected by member: "%s", ID: %d on: %s', $user->user_email, $user->ID, date(MGM_DATE_FORMAT)), 

						   'TESTMODE'=>( $this->status == 'test' ?  '1' : '0'));		

		// url

		$url =  $this->_get_endpoint('unsubscribe');

		

		// fields

		$fields = mgm_http_build_query($post_body);	

		

		// post		

		$response = mgm_remote_post($url, $fields);

		

		// parse

		parse_str($response, $data);

				

		// verify

		if(isset($data['REFERENCENUMBER']) && $data['RETURNCODE'] == 100){

			$this->_cancel_membership($user_id, $data);

		}else{

			wp_redirect('wp-admin/profile.php?page=mgm/profile&unsubscribe_errors='.urlencode($data['DESCRIPTION']));

		}

		

	}

		

	// subscribe button api hook

	function get_button_subscribe($options=array()){		

		$button_code     = $this->_get_button_code($options['pack']);

		$additional_code = do_action('mgm_additional_code');

		$html='<form action="'. $this->_get_endpoint() .'" method="post" class="mgm" name="' . $this->code . '_form" id="' . $this->code . '_form">

					'. $button_code .'

					'. $additional_code .'

					<input type="image" src="' . mgm_fix_url($this->logo) . '" border="0" name="submit" alt="' . $this->name . '">

					<div class="mgm_paymod_description">'. $this->description .'</div>

				</form>';

		return $html;		

	}

	

	// buypost button api hook

	function get_button_buypost($options=array(), $return = false) {

		global $user;

		// title

		$item_name = (isset($options['pack']['ppp_pack_id'])) ? ('Purchase Post Pack - '.$options['pack']['title']) : ('Purchase Post - '.$options['pack']['title']) ;

		// merge pack

		$options['pack'] = array_merge($options['pack'], array('duration'=>1, 'item_name'=>$item_name, 'buypost'=>1));

		// button code		

		$button_code = $this->_get_button_code($options['pack']);

		$additional_code = do_action('mgm_additional_code');

		// html

		$html = '<table width="100%" border="0" cellpadding="0" cellspacing="0" align="center" class="form-table">

					<form action="'. $this->_get_endpoint() .'" method="post" class="mgm" name="' . $this->code . '_form" id="' . $this->code . '_form">

						 <tr>

							 <td align="center">

								 '. $button_code .'								

								 '. $additional_code .'

								 <input type="image" src="' . mgm_fix_url($this->logo) . '" name="submit" alt="' . $this->name . '">

								 <div class="mgm_paymod_description">'. $this->description .'</div>

							 </td>

						 </tr>

					 </form>

				</table>';



		if ($return) {

			return $html;

		} else {

			echo $html;

		}

	}

	

	// dependency check

	/* ***********************************************************************

	function dependency_check(){

		$this->dependency = array();

		if(!extension_loaded('curl') && !extension_loaded('curl')){

			$this->dependency[] = '<b style="color:#FF1F3D">CURL PHP extension must be loaded for module.</b>';

		}

		// error		

		return (count($this->dependency)>0) ? true : false ;

	}

	***************************************************************************/

	

	/////////////////////////////////////////////// internal/private methods /////////////////////////////////////////////////

	

	// get button code	

	function _get_button_code($pack) {

		$data   = $this->_get_button_data($pack);

		$return = '';	

		foreach ($data as $key => $value) {

			$return .= '	<input type="hidden" name="'. $key .'" value="'. $value .'" />' . "\n";

		}	

		return $return;

	}



	// get button data

	function _get_button_data($pack) {

		// system setting

		$system  = mgm_get_option('mgm_system');	

		$user_id = mgm_get_user_id();

		$user    = get_userdata($user_id); 	

		// setup data array		

		$data = array(

			'ap_purchasetype'=>(isset($pack['num_cycles']) && $pack['num_cycles'] != 1 ? 'subscription':'item'),

			'ap_merchant'=>$this->setting['ap_merchant'],

			//'ap_itemname'=>($pack['item_name'] ? $pack['item_name'] : $system->setting['subscription_name']),		

			//updated here on 2011 Feb 24 for issue: 289	

			'ap_itemname'=>($pack['item_name'] ? $pack['item_name'] : $system->get_subscription_name($pack)),			

			'ap_currency'=>$this->setting['currency'],					

			'ap_cancelurl'=>$this->setting['cancel_url'],	

			'ap_amount'	=>$pack['cost']	,			

			'ap_contactemail'=>$user->user_email,

		);

		

		// address fields

		$this->_set_address_fields($user, $data, array('first_name'=>'ap_fname','last_name'=>'ap_lname','address'=>'ap_addressline1',

		                                               'city'=>'ap_city', 'state'=>'ap_stateprovince', 'zip'=>'ap_zippostalcode',

													   'country'=>'ap_country'));// see parent for all fields, only different given here			

		

		// 'modify'=>1, // 1 new, 2 upgrade

		// subscription payment

		if ($pack['num_cycles'] != 1 && $pack['duration_type']) { // ongoing(0) or 1-99 times

     	// types

			$unit_types = array('d'=>'Day', 'm'=>'Month', 'y'=>'Year');	// a

			// interval

			$data['ap_timeunit']   = $unit_types[$pack['duration_type']]; // day|month|year

			$data['ap_periodlength'] = $pack['duration'];

			

			// greater than 0

			if ($pack['num_cycles']) {

				$data['ap_periodcount'] = $pack['num_cycles'];

			}

			// trial

			if ($pack['trial_on']) {

				$data['ap_trialamount']       = $pack['trial_cost'];

				$data['ap_trialperiodlength'] = $pack['trial_duration'];

				$data['ap_trialtimeunit']     = $unit_types[$pack['trial_duration_type']];				

			}			

		} else {

			// Purchase Post

			if ($pack['buypost'] == 1 ) {

				if (isset($pack['ppp_pack_id'])) {

					// get comma separated list of post ids					

					$pack['post_id'] = mgm_get_ppp_pack_post_csv($pack['ppp_pack_id']);

				} else {

					// single post

					$pack['post_id'] = get_the_ID();	

				}								

			} 

		}

		

		// custom

		$data['apc_1'] = $this->_set_payment_type($pack, $this->setting['currency']);

		

		// set apc on request so that it can be tracked for post purchase

		$data['ap_returnurl'] = add_query_arg(array('apc_1'=>$data['apc_1']), $this->setting['return_url']);

		

		// return data

		return $data;

	}	

	

	// verify callback 

	function _verify_callback(){	

		// system

		$system = mgm_get_option('mgm_system');				

		$dge    = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;

	    // check

		if ($_POST['ap_securitycode'] == $this->setting['ap_securitycode']) {

        // valid

			return true;

	  	}else {

			// notify admin, only if gateway emails on

    	    if(!$dge){

				mgm_mail($system->setting['admin_email'], 'Verification failed in AlertPay IPN ', 'AlertPay IPN error'); 

		  	}

		  	// abort

	   		die;

		}	

	}	

	

	// buy post

	function _buy_post() {

		global $wpdb;



		$system = mgm_get_option('mgm_system');

		$dge  = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;

		

		list($duration, $cost, $currency, $user_id, $post_id, $user_id, $client_ip) = explode('_', preg_replace('/^buypost_/','', $_POST['apc_1']));



		// find user

		$user     = get_userdata($user_id);

		$blogname = get_option('blogname');

		$tran_success = false;

		switch ($_POST['ap_status']) {

			case 'Success':

  				$tran_success = true;

				$status_str = __('Last payment was successful','mgm');

				//$subject = sprintf(__('[%s] Payment receipt','mgm'),$blogname);

				//issue 280 : email template 

				//subject

				$subject = $system->get_template('payment_success_email_template_subject', array('blogname'=>$blogname), true);

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />This is a notification to inform you that your payment was successful and the post you purchased is now available to view.<br />For more information please contact %4$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $system->setting['admin_email']);

				//body

				$message = $system->get_template('payment_success_email_template_body', 

										array('blogname'=>$blogname, 'name'=>$user->display_name, 

											  'email'=>$user->user_email, 

											  'admin_email'=>$system->setting['admin_email']), true);

				// after succesful payment hook

				do_action('mgm_buy_post_transaction_success', array("post_id"=>$post_id));

			break;



			case 'Expired':

			case 'Failed':

			case 'Canceled':

				$status_str = __('Last payment was refunded or denied','mgm');

				//$subject = sprintf(__('[%s] Payment Failed','mgm'), $blogname);

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />This is a notification to inform you that your post purchase failed for the following reason: %4$s.<br />For more information please contact %5$s.','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $status_str, $system->setting['admin_email']);

				//issue 280 : email template 

				// subject

				$subject = $system->get_template('payment_failed_email_template_subject', array('blogname'=>$blogname), true);				 

				// body			

				$message = $system->get_template('payment_failed_email_template_body', 

										array('blogname'=>$blogname, 'name'=>$user->display_name, 

											  'email'=>$user->user_email, 'payment_type'=>'post purchase payment','reason'=>$status_str,

											  'admin_email'=>$system->setting['admin_email']), true);

				break;



			case 'Pending':

				$reason = 'Unknown';

				$status_str = sprintf(__('Last payment is pending. Reason: %s','mgm'), $reason);

				//$subject = "[" . $blogname . "] Payment receipt - Status Pending";

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />This is a notification to inform you that you payment was received in pending status. Status: %4$s.<br />For more information please contact %5$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $status_str, $system->setting['admin_email']);

				//issue 280 : email template 

				// subject

				$subject = $system->get_template('payment_pending_email_template_subject', array('blogname'=>$blogname), true);

				// body	

				$message = $system->get_template('payment_pending_email_template_body', 

										array('blogname'=>$blogname, 'name'=>$user->display_name, 

											  'email'=>$user->user_email, 'reason'=>$status_str,

											  'admin_email'=>$system->setting['admin_email']), true);

				

				break;



			default:

				$status_str = sprintf(__('Last payment status: %s','mgm'),$_POST['payment_status']);

				//$subject = "[$blogname] Payment receipt";

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />Status: %4$s.<br />For more information please contact %5$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $status_str, $system->setting['admin_email']);

				//issue 280 : email template

				// subject

				$subject = $system->get_template('payment_unknown_email_template_subject', array('blogname'=>$blogname), true);				

				// body	

				$message = $system->get_template('payment_unknown_email_template_body', array('blogname'=>$blogname, 'name'=>$user->display_name, 

				                                                                              'email'=>$user->user_email, 'reason'=>$status_str,

																							  'admin_email'=>$system->setting['admin_email']), true);

		}

		// notify user

		mgm_mail($user->user_email, $subject, $message); //send an email to the buyer		



		$status = __('Failed join', 'mgm'); //overridden on a successful payment

		if ($tran_success) {

			$table_name = TBL_MGM_POSTS_PURCHASED;

			

			//if we are looking at a pack then explode the buy post item number and loop through it

			if (strpos($post_id, ',') !== false) {

				$posts = explode(',', $post_id);

			} else {

				$posts = array($post_id);

			}

			

			$posts = array_unique($posts);

			

			foreach ($posts as $post_id) {

				$sql = "INSERT INTO " . $table_name . " (user_id, post_id, unixtime)

					    VALUES (" . $user_id . ", " . $post_id . ", UNIX_TIMESTAMP())";

				$wpdb->query($sql); //insert the post purchased record

			}



			$status = __('The post was purchased successfully', 'mgm');

		}



		// notify admin, only if gateway emails on

		if (!$dge) {

			$subject = "[" . $blogname . "] Admin Notification: " . $user->user_email . " purchased post " . $post_id;

			$message = "User display name: {$user->display_name}<br />User email: {$user->user_email}<br />User ID: {$user->ID}<br />Status: " . $status . "<br />Action: Purchase post:" . $subject . "<br /><br />" . $message . "<br /><br /><pre>" . print_r($_POST, true) . '</pre>';

			mgm_mail($system->setting['admin_email'], $subject, $message);

		}

	}

	

	// buy membership

	function _buy_membership() {	

		// system	

		$system       = mgm_get_option('mgm_system');		

		$packs        = mgm_get_option('mgm_subscription_packs');

		$duration_str = $packs->duration_str;

		//$status_str   = $system->get_statuses();

		$dge          = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;

		// get custom field values

		list($duration, $amount, $currency, $user_id, $membership_type, $duration_type, $role, $client_ip, $hide_old_content, $pack_id) = explode('_', preg_replace('/^subscription_/','', $_POST['apc_1']));

		

		// currency

		if (!$currency) {

			$currency = $this->setting['currency'];

		}

		// find user

		$user       = get_userdata($user_id);

		$mgm_member = mgm_get_member($user_id);

		

		$join_date = $mgm_member->join_date; // Get the current AC join date



		if (!$join_date) {

			$mgm_member->join_date = time(); // Set current AC join date

		}



		//if there is no duration set in the user object then run the following code

		if (empty($duration_type)) {

			//if there is no duration type then use Months

			$duration_type = 'm';

		}

		// membership type default

		if (empty($membership_type)) {

			//if there is no account type in the custom string then use the existing type

			$membership_type = md5($mgm_member->membership_type);

		}

		// validate parent method

		$membership_type_verified = $this->_validate_membership_type($membership_type, 'md5|plain');

		// verified

		if (!$membership_type_verified) {

			if (strtolower($mgm_member->membership_type) != 'free') {

				// notify admin, only if gateway emails on

				if(!$dge){

					$message = 'Could not read membership type in the following POST data. Please debug or contact magic members to fix the problem making sure to pass on the following data. <br /><br /><pre>' . "\n\n" . print_r($_POST, true) . '</pre>';

					mgm_mail($system->setting['admin_mail'], 'Error in AlertPay membership verification', $message);

				}

				// abort

				return;

			} else {

				$membership_type_verified = $mgm_member->membership_type;

			}

		}

		// set

		$membership_type             = $membership_type_verified;

		// sub pack

		$subs_pack                   = $packs->get_pack($pack_id);

		// if trial on		

		if ($subs_pack['trial_on']) {

			$mgm_member->trial_on            = $subs_pack['trial_on'];

			$mgm_member->trial_cost          = $subs_pack['trial_cost'];

			$mgm_member->trial_duration      = $subs_pack['trial_duration'];

			$mgm_member->trial_duration_type = $subs_pack['trial_duration_type'];

			$mgm_member->trial_num_cycles    = $subs_pack['trial_num_cycles'];

		}	

		// duration

		$mgm_member->duration        = $duration;

		$mgm_member->duration_type   = strtolower($duration_type);

		$mgm_member->amount          = $amount;

		$mgm_member->currency        = $currency;

		$mgm_member->membership_type = $membership_type;		

		$mgm_member->pack_id         = $pack_id;

		$mgm_member->payment_type    = ($_POST['ap_purchasetype']=='subscription' )?'subscription' : 'one-time';

		// payment info for unsubscribe		

		$mgm_member->payment_info    = new stdClass;

		$mgm_member->payment_info->module = $this->code;

		if(isset($_POST['ap_purchasetype'])){

			$mgm_member->payment_info->txn_type = $_POST['ap_purchasetype'];

		}	

		if(isset($_POST['ap_subscriptionreferencenumber'])){

			$mgm_member->payment_info->subscr_id = $_POST['ap_subscriptionreferencenumber'];

		}	

		if(isset($_POST['ap_referencenumber'])){

			$mgm_member->payment_info->txn_id = $_POST['ap_referencenumber'];

		}	

		// [txn_type] => subscr_signup

		// [txn_type] => subscr_payment

		// [subscr_id] => I-KV2G0LEU6RCD

		// [txn_id] => 3K2504430T514494Y

		

		// process PayPal response

		$new_status = false;

		// status

		switch ($_POST['ap_status']) {

			case 'Success':

			case 'Subscription-Payment-Success':

				$new_status = MGM_STATUS_ACTIVE;

				$mgm_member->status_str = __('Last payment was successful','mgm');					

				

				// old type match

				$old_membership_type = mgm_get_user_membership_type($user_id, 'code');

				if ($old_membership_type != $membership_type) {

					$mgm_member->join_date = time(); // type join date as different var

				}

				// old content hide

				$mgm_member->hide_old_content = $hide_old_content; 

				

				$time = time();				

				$mgm_member->last_pay_date = date('Y-m-d', $time);				

				

				// THIS is causng double calculation

				/* ***********************************/

				if ($mgm_member->expire_date && $mgm_member->last_pay_date!=date('Y-m-d', $time)) {

					$expiry = strtotime($mgm_member->expire_date);

					if ($expiry > 0) {

						if ($expiry > $time) {

							$time = $expiry;

						}

					}

				}

				/*************************************/					

				

				// type expanded

				$duration_types = array('d'=>'DAY','m'=>'MONTH','y'=>'YEAR');

				// time

				$time = strtotime("+{$mgm_member->duration} {$duration_types[$mgm_member->duration_type]}", $time);							

				// formatted

				$time_str = date('Y-m-d', $time);				

				// date extended				

				if (!$mgm_member->expire_date || strtotime($time_str) > strtotime($mgm_member->expire_date)) {

					$mgm_member->expire_date = $time_str;										

				}

								

				// role

				if ($role) {

					$role_obj = new WP_User($user_id);

					$role_obj->set_role($role);

				}			

				

				// after succesful payment hook

				do_action('mgm_membership_transaction_success', array("user_id" =>$user_id));	



			break;

			case 'Subscription-Expired':

			case 'Subscription-Payment-Failed':

			case 'Subscription-Canceled':

				$new_status = MGM_STATUS_NULL;

				$mgm_member->status_str = __('Last payment was refunded or denied','mgm');

				break;



			case 'Subscription-Payment-Rescheduled':

				$new_status = MGM_STATUS_PENDING;



				$reason = 'Unknown';

				$mgm_member->status_str = sprintf(__('Last payment is pending. Reason: %s','mgm'), $reason);

				break;



			default:

				$new_status = MGM_STATUS_ERROR;

				$mgm_member->status_str = sprintf(__('Last payment status: %s','mgm'), $_POST['payment_status']);

				break;

		}



		// handle exceptions from the subscription specific fields

		if ($new_status == MGM_STATUS_ACTIVE && in_array($_POST['txn_type'], array('subscr_failed', 'subscr_eot'))) {

			$new_status = MGM_STATUS_NULL;

			$mgm_member->status_str = __('The subscription is not active','mgm');

		}

		// set status

		$mgm_member->status = $new_status;

		// update option

		update_user_option($user_id, 'mgm_member', $mgm_member, true);				



		// return action

		do_action('mgm_return_alertpay');



		// send email notification to client

		$blogname = get_option('blogname');

		switch ($new_status) {

			case MGM_STATUS_ACTIVE:

				//$subject = sprintf(__('[%s] Payment receipt','mgm'),$blogname);

				$subject = $system->get_template('payment_success_email_template_subject', array('blogname'=>$blogname), true);



				if ($mgm_member->payment_type == 'subscription') {

					//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your payment was successful for recurring subscription of %4$s %5$s every %6$s %7$s. For more information please contact %8$s','mgm');

					//issue#: 280 (2011 Feb 25)

					$payment_type = 'recurring subscription';

					$subscription = sprintf('%1$s %2$s every %3$s %4$s',$mgm_member->amount, $mgm_member->currency, $mgm_member->duration, 

					                                                    $duration_str[$mgm_member->duration_type]);

				} else {

					//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your payment was successful for a one-time payment of %4$s %5$s for %6$s %7$s. For more information please contact %8$s','mgm');

					//issue#: 280 (2011 Feb 25)

					$payment_type = 'one-time payment';

					$subscription = sprintf('%1$s %2$s for %3$s %4$s',$mgm_member->amount, $mgm_member->currency, $mgm_member->duration, 

					                                                  $duration_str[$mgm_member->duration_type]);

				}



				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->amount, $mgm_member->currency, $mgm_member->duration, $duration_str[$mgm_member->duration_type], $system->setting['admin_email']);				

				//issue #: 280:

				// body				

				$message = $system->get_template('payment_success_subscription_email_template_body', 

													array('blogname'=>$blogname, 'name'=>$user->display_name, 

														  'email'=>$user->user_email, 'payment_type'=>$payment_type,

														  'subscription'=>$subscription,'admin_email'=>$system->setting['admin_email']), true);

				break;



			case MGM_STATUS_NULL:

				//$subject = sprintf(__('[%s] Account inactive','mgm'), $blogname);

				 //issue#: 280 (2011 Feb 25) 

				// subject

				$subject = $system->get_template('payment_failed_email_template_subject', array('blogname'=>$blogname), true);			

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your account is inactive for the following reason: %4$s. For more information please contact %5$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->status_str, $system->setting['admin_email']);

				$message = $system->get_template('payment_failed_email_template_body', 

									array('blogname'=>$blogname, 'name'=>$user->display_name, 

										  'email'=>$user->user_email, 'payment_type'=>'subscription payment',

										  'reason'=>$mgm_member->status_str,

										  'admin_email'=>$system->setting['admin_email']), true);

				break;



			case MGM_STATUS_PENDING:

				//issue#: 280 (2011 Feb 25)

				//$subject = "[$blogname] Payment receipt - Status Pending";

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that you payment was received in pending status. Status: %4$s. For more information please contact %5$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->status_str, $system->setting['admin_email']);

				//issue #: 280:

				// subject

				$subject = $system->get_template('payment_pending_email_template_subject', array('blogname'=>$blogname), true);

				// body

				$message = $system->get_template('payment_pending_email_template_body', 

										array('blogname'=>$blogname, 'name'=>$user->display_name, 

											  'email'=>$user->user_email, 'reason'=>$mgm_member->status_str,

											  'admin_email'=>$system->setting['admin_email']), true);

				break;



			case MGM_STATUS_ERROR:

				//issue#: 280 (2011 Feb 25)

				//$subject = "[$blogname] Error on payment";

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that an error occurred while processing your payment. Details: %4$s. For more information please contact %5$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->status_str, $system->setting['admin_email']);

				//issue #: 280:

				// subject

				$subject = $system->get_template('payment_error_email_template_subject', array('blogname'=>$blogname), true);				

				// body	

				$message = $system->get_template('payment_error_email_template_body', 

									array('blogname'=>$blogname, 'name'=>$user->display_name, 

										  'email'=>$user->user_email, 'reason'=>$mgm_member->status_str,

										  'admin_email'=>$system->setting['admin_email']), true);

				break;

		}



		// notify user

		mgm_mail($user->user_email, $subject, $message);		



		// send email notification to system administrator

		if (!$dge) {

			$subject = "[$blogname] {$user->user_email} - {$new_status}";

			$message = "	User display name: {$user->display_name}\n\n<br />

					User email: {$user->user_email}\n\n<br />

					User ID: {$user->ID}\n\n<br />

					Membership Type: {$membership_type}\n\n<br />

					New status: {$new_status}\n\n<br />

					Status message: {$mgm_member->status_str}\n\n<br />

					Subscription period: {$mgm_member->duration} ". $duration_str[$mgm_member->duration_type] ."\n\n<br />

					Subscription amount: {$mgm_member->amount} {$mgm_member->currency}\n<br />

					Payment Mode: {$mgm_member->payment_type}\n\n<br />

					POST Data was: \n\n<br /><br /><pre>" . print_r($_POST, true) . '</pre>';

			mgm_mail($system->setting['admin_email'], $subject, $message);

		}

	}

	

	// cancel membership

	function _cancel_membership($user_id, $data){

		// system	

		$system       = mgm_get_option('mgm_system');		

		$packs        = mgm_get_option('mgm_subscription_packs');

		$duration_str = $packs->duration_str;

		//$status_str   = $system->get_statuses();

		$dge          = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;

		

		// find user

		$user       = get_userdata($user_id);

		$mgm_member = mgm_get_member($user_id);	

		

		// get pack

		if($mgm_member->pack_id){

			$subs_pack = $packs->get_pack($mgm_member->pack_id);

		}else{

			$subs_pack = $packs->validate_pack($mgm_member->amount, $mgm_member->duration, $mgm_member->duration_type, $mgm_member->membership_type);

		}

				

		// reset payment info

		$mgm_member->payment_info->txn_type = 'subscription_cancel';

		// reference

		if(isset($data['REFERENCENUMBER'])){	

			$mgm_member->payment_info->txn_id = $data['REFERENCENUMBER'];	

		}		

		

		// types

		$duration_types = array('d'=>'DAY','m'=>'MONTH','y'=>'YEAR');	

						

		// default expire date				

		$expire_date = $mgm_member->expire_date;					

		// if trial on 

		if ($subs_pack['trial_on']) {			

			// if cancel data is before trial end, set cancel on trial expire_date

			$trial_expire_date = strtotime("+{$subs_pack['trial_duration']} {$duration_types[$subs_pack['trial_duration_type']]}", $mgm_member->join_date);

			

			// if lower

			if(time() < $trial_expire_date){

				$expire_date = date('Y-m-d',$trial_expire_date);

			}

		}	

			

		// if today 

		if($expire_date == date('Y-m-d')){

			$new_status = MGM_STATUS_CANCELLED;

			$mgm_member->status_str = __('Subscription Cancelled','mgm');					

			$mgm_member->expire_date = date('Y-m-d');	

			// set status

			$mgm_member->status = $new_status;

		}else{

			$new_status = MGM_STATUS_AWAITING_CANCEL;			

			// reset on

			$mgm_member->status_reset_on = $expire_date;

			$mgm_member->status_reset_as = MGM_STATUS_CANCELLED;

		}

		

		// update user

		update_user_option($user_id, 'mgm_member', $mgm_member, true);		

			

		// send email notification to client

		$blogname = get_option('blogname');

		//issue#: 280 (2011 Feb 25)

		// email	

		//$subject = sprintf(__('[%s] Subscription Cancelled','mgm'),$blogname);				

		//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your subscription has been cancelled. For more information please contact %4$s','mgm');

		//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $system->setting['admin_email']);

		

		 //issue#: 280 (2011 Feb 25)

		// subject

		$subject = $system->get_template('subscription_cancelled_email_template_subject', array('blogname'=>$blogname), true);				

		// body	

		$message = $system->get_template('subscription_cancelled_email_template_body', 

							array('blogname'=>$blogname, 'name'=>$user->display_name, 

								  'email'=>$user->user_email, 'admin_email'=>$system->setting['admin_email']), true);

		// send email notification to user

		mgm_mail($user->user_email, $subject, $message);		



		// notify admin, only if gateway emails on

		if (!$dge) {

			$subject = "[$blogname] {$user->user_email} - {$new_status}";

			$message = "	User display name: {$user->display_name}\n\n<br />

					User email: {$user->user_email}\n\n<br />

					User ID: {$user->ID}\n\n<br />

					Membership Type: {$membership_type}\n\n<br />

					New status: {$new_status}\n\n<br />

					Status message: {$mgm_member->status_str}\n\n<br />					

					Payment Mode: Cancelled\n\n<br />";

			mgm_mail($system->setting['admin_email'], $subject, $message);

		}

		

		// after cancellation hook

		do_action('mgm_membership_subscription_cancelled', array("user_id" =>$user_id));	

		

		// message

		$message = sprintf(__("You have successfully Unsubscribed. Your account is marked for Cancellation on %s", "mgm"), ($expire_date == date('Y-m-d') ? 'Today' : date(MGM_DATE_FORMAT_LONG, strtotime($expire_date)) ));

		

		// redirect 

		wp_redirect('wp-admin/profile.php?page=mgm/profile&unsubscribed=true&unsubscribe_errors='.urlencode($message));

	}

	

	// default setting

	function _default_setting(){

		// alertpay specific

		$this->setting['ap_merchant']      = get_option('admin_email');

		$this->setting['ap_securitycode']  = '';

		$this->setting['ap_apipassword']   = '';



		//$this->setting['locale']          = 'US';

		$this->setting['currency']        = mgm_get_option('mgm_system')->setting['currency'];

		// purchase price

		if(in_array('buypost', $this->supported_buttons)){

			$this->setting['purchase_price']  = 4.00;		

		}		

		// callback messages				

		$this->_setup_callback_messages();

		// callback urls

		$this->_setup_callback_urls();		

	}

}



// end file