<?php



// payment module

class mgm_authorizenet extends mgm_payment{

	// construct

	function __construct(){

		// php4 construct

		$this->mgm_authorizenet();

	}

	

	// construct

	function mgm_authorizenet(){

		// parent

		parent::__construct();

		// set code

		$this->code = __CLASS__; 

		// set name

		$this->name = 'Authorize.Net';

		// logo

		$this->logo = MGM_PLUGIN_MODULE_URL . 'payment/authorizenet/assets/authorizenet.jpg';

		// description

		$this->description = __('Authorize.Net. ARB and AIM integration for Recurring payments and Single Purchase.', 'mgm');

		// supported buttons types

	 	$this->supported_buttons = array('subscription', 'buypost');

		// trial support available ?

		$this->supports_trial= 'Y';	

		// cancellation support available ?

		$this->supports_cancellation= 'Y';	

		// do we depend on product mapping	

		$this->requires_product_mapping = 'N'; 

		// endpoints

		// SIM

		$this->_set_endpoint('test_sim','https://test.authorize.net/gateway/transact.dll'); // test SIM

		$this->_set_endpoint('live_sim','https://secure.authorize.net/gateway/transact.dll'); // live SIM

		// AIM

		$this->_set_endpoint('test_aim','https://test.authorize.net/gateway/transact.dll'); // test AIM

		$this->_set_endpoint('live_aim','https://secure.authorize.net/gateway/transact.dll'); // live AIM

		// ARB

		$this->_set_endpoint('test_arb','https://apitest.authorize.net/xml/v1/request.api'); // test ARB

		$this->_set_endpoint('live_arb','https://api.authorize.net/xml/v1/request.api'); // live ARB

		// default settings

		$this->_default_setting();

		// set path

		parent::set_tmpl_path();	

	}	

	

	// settings

	function settings(){

		global $wpdb;

		// data

		$data = array();		

		// set 

		$data['module'] = mgm_get_option($this->code);	

		// load template view

		$this->load_template('settings', array('data'=>$data, 'ajax'=>true));

	}	

	

	// settings_box

	function settings_box(){

		global $wpdb;

		// data

		$data = array();	

		// set 

		$data['module'] = mgm_get_option($this->code);

		// load template view

		return $this->load_template('settings_box', array('data'=>$data), true);

	}

	

	// update

	function settings_update(){

		// form type 

		switch($_POST['setting_form']){

			case 'box':

			// from box	

				switch($_POST['act']){

					case 'logo_update':

						// logo if uploaded

						if(isset($_POST['logo_new_'.$this->code]) && !empty($_POST['logo_new_'.$this->code])){

							$this->logo = $_POST['logo_new_'.$this->code];

							// update option

							update_option($this->code, $this);

						}

						// message

						$message = $this->name . ' logo updated';			

						$extra   = array();

					break;

					case 'status_update':

					default:

						// enable

						$enable_state = ($_POST['payment']['enable'] == 'Y') ? 'Y' : 'N';

						// enable

						if($enable_state == 'Y'){

							$this->install();

							$stat = ' enabled.';

						}else{

						// disable

							$this->uninstall();	

							$stat = ' disabled.';

						}	

						

						# message

						$message = __($this->name . ' module is '. $stat, 'mgm');							

						$extra   = array('enable' => $enable_state);	

					break;

				}							

				// print message

				echo json_encode(array_merge(array('status'=>'success','message'=>$message,'module'=>array('name'=>$this->name,'code'=>$this->code,'tab'=>$this->settings_tab)), $extra));

			break;

			case 'main':

			default:

			// from main						

				// authorize.net specific				

				$this->setting['loginid']  = $_POST['setting']['loginid'];

				$this->setting['tran_key'] = $_POST['setting']['tran_key'];				

				// purchase price

				if(isset($_POST['setting']['purchase_price'])){

					$this->setting['purchase_price']  = $_POST['setting']['purchase_price'];

				}

				// setup callback messages				

				$this->_setup_callback_messages($_POST['setting']);

				// re setup callback urls

				$this->_setup_callback_urls($_POST['setting']);

				// common

				$this->description = $_POST['description'];

				$this->status      = $_POST['status'];

				// logo if uploaded

				if(isset($_POST['logo_new_'.$this->code]) && !empty($_POST['logo_new_'.$this->code])){

					$this->logo = $_POST['logo_new_'.$this->code];

				}				

				// update option

				update_option($this->code, $this);

				//  message

				echo json_encode(array('status'=>'success','message'=> $this->name . ' settings updated'));

			break;

		}		

	}

	

	// return process api hook, link back to site after payment is made

	function process_return(){

		// check and show message

		if($this->response['response_status'] != 3 ){// 3 == Error

			// process notify, internally called

			$this->process_notify();

			// redirect as success if not already redirected

			// query arg

			$query_arg = array('status'=>'success');

			// is a post redirect?

			$post_redirect =$this->_get_post_redirect($_POST['x_custom']);

			// yes redirect argument passed

			if($post_redirect !== false){

				$query_arg['post_redirect'] = $post_redirect;

			}			

			// redirect

			wp_redirect(add_query_arg($query_arg, $this->setting['processed_url']));

		}else{

			// error

			wp_redirect(add_query_arg(array('status'=>'error','errors'=>urlencode($this->response['message_text'])), $this->setting['processed_url']));

		}		

	}

	

	// notify process api hook, background IPN url 

	function process_notify(){		

		// used as proxy IPN for this module	

		// check			

		if (isset($_POST['x_custom'])){	

			// payment type

			$payment_type = $this->_get_payment_type($_POST['x_custom']);

			// check

			switch($payment_type){

				// buypost 

				case 'buypost':

					$this->_buy_post(); //run the code to process a purchased post/page

				break;

				// subscription	

				case 'subscription':

					$this->_buy_membership(); //run the code to process a new/extended membership

				break;	

				// other		

				default:

					// error

					$error = 'error in payment type : '.$payment_type;

					// redirect to error

					wp_redirect(add_query_arg(array('status'=>'error','errors'=>$error), $this->setting['processed_url']));				

				break;							

			}

		}		

	}

	

	// process cancel api hook 

	function process_cancel(){

		// not used for this module

		// redirect to cancel page

		wp_redirect(add_query_arg(array('status'=>'cancel'), $this->setting['processed_url']));

	}

	

	// unsubscribe process, proxy for unsubscribe

	function process_unsubscribe(){

		// get user id

		$user_id = $_POST['user_id'];

		// get user

		$user = get_userdata($user_id); 		

		

		// set xml content											

		$content ='<ARBCancelSubscriptionRequest xmlns="AnetApi/xml/v1/schema/AnetApiSchema.xsd">

						<merchantAuthentication>

							<name>'.$this->setting['loginid'].'</name>

							<transactionKey>'.$this->setting['tran_key'].'</transactionKey>

						</merchantAuthentication>

						<refId>'.$user_id.'</refId>

						<subscriptionId>'.$user->mgm_member->payment_info->subscr_id.'</subscriptionId>

					</ARBCancelSubscriptionRequest>';

		// end  point

		$endpoint    = $this->_get_endpoint($this->status.'_arb') ; // test_arb, live_aim etc.		

		// create curl post				

		$buffer = $this->_curl_post($endpoint, $content, array("Content-Type: text/xml") );		

		

		// parse response		

		$this->_process_response('arb', $buffer);	

						

		// verify

		if(isset($this->response['response_status']) && $this->response['response_status']==1){

			$this->_cancel_membership($user_id);

		}else{

			wp_redirect('wp-admin/profile.php?page=mgm/profile&unsubscribe_errors='.urlencode($this->response['message_text']));

		}

	}

	

	// process proxy, proxy  for cc processing

	function process_proxy(){

		// post data filter		

		$post_data = $_POST;	

		// gateway

		$gateway_method = ($post_data['x_recurring_billing'] == 'TRUE') ? 'arb' : 'aim';		

		// add internal vars

		$secure =array(

					'x_login'    => $this->setting['loginid'],	

					'x_tran_key' => $this->setting['tran_key']								

				 );				 			

		// merge

		$post_data = array_merge($post_data, $secure);// overwrite post data array with secure params		

		// filter post data

		$post_string  = $this->_filter_postdata($gateway_method, $post_data);

		// header

		$http_header = ($gateway_method == 'arb') ? array("Content-Type: text/xml") : array();

		// end  point

		$endpoint    = $this->_get_endpoint($this->status.'_'.$gateway_method) ; // test_arb, live_aim etc.		

		// create curl post				

		$buffer = $this->_curl_post($endpoint, $post_string, $http_header );

		// parse response		

		$this->_process_response($gateway_method, $buffer);			

		// treat as return

		$this->process_return();			

	}	

	

	// subscribe button api hook

	function get_button_subscribe($options=array()){		

		// mgm_array_dump($options);

		$button_code     = $this->_get_button_code($options['pack']);

		$additional_code = do_action('mgm_additional_code');

		$cc_fields       = $this->_get_ccfields();

		$html='<form action="'. $this->_get_endpoint('proxy') .'" method="post" class="mgm" name="' . $this->code . '_form" id="' . $this->code . '_form">

				'. $button_code .'

				'. $additional_code .'

				<input type="image" src="' . mgm_fix_url($this->logo) . '" name="submit" alt="' . $this->name . '" border="0" onclick="return mgm_paymentform_toggle(\''.$this->code.'\')"">

				<div class="mgm_paymod_description">'. $this->description .'</div>

				'. $cc_fields .'

			  </form>';

		return $html;		

	}

	

	// buypost button api hook

	function get_button_buypost($options=array(), $return = false) {

		global $user;

		// merge pack

		$options['pack'] = array_merge($options['pack'], array('duration'=>1, 'item_name'=>'Purchase Post - '.$options['pack']['title'], 'buypost'=>1));

		// button code		

		$button_code     = $this->_get_button_code($options['pack']);

		$additional_code = do_action('mgm_additional_code');

		$cc_fields       = $this->_get_ccfields();

		// html

		$html = '<table width="100%" border="0" cellpadding="0" cellspacing="0" align="center" class="form-table">

					<form action="'. $this->_get_endpoint('proxy') .'" method="POST" class="mgm" name="' . $this->code . '_form" id="' . $this->code . '_form">

						 <tr>

							 <td align="center">

							 '. $button_code .'						

							 '. $additional_code .'	

							  <input type="image" src="' . mgm_fix_url($this->logo) . '" name="submit" alt="' . $this->name . '" border="0" onclick="return mgm_paymentform_toggle(\''.$this->code.'\')"">	

							  <div class="mgm_paymod_description">'. $this->description .'</div>

							  '. $cc_fields .'				

							 </td>

						 </tr>

					 </form>

				</table>';



		if ($return) {

			return $html;

		} else {

			echo $html;

		}

	}

	

	// dependency_check

	function dependency_check(){

		// not using SIM

		// return false;

		

		$this->dependency = array();

		// SIM dependency

		/*****************************

		if(!extension_loaded('mhash')){

			$this->dependency[] = '<b style="color:#FF1F3D">MHASH PHP extension must be loaded for Authorize.Net.</b>';

		}

		******************************/

		// mgm_log(print_r(get_loaded_extensions(), true));

		if(!extension_loaded('SimpleXML')){

			$this->dependency[] = '<b style="color:#FF1F3D">'.__('SimpleXML PHP extension must be loaded for Authorize.Net ARB','mgm').'.</b>';

		}

		// error		

		return (count($this->dependency)>0) ? true : false ;		

	}

	

	/////////////////////////////////////////////// internal/private methods /////////////////////////////////////////////////

	

	// get button code	

	function _get_button_code($pack) {

		$data   = $this->_get_button_data($pack);

		$return = '';	

		foreach ($data as $key => $value) {

			$return .= '	<input type="hidden" name="'. $key .'" value="'. $value .'" />' . "\n";

		}	

		return $return;

	}



	// get button data

	function _get_button_data($pack) {

		// system

		$system = mgm_get_option('mgm_system');	

		$currency   = $system->setting['currency'];

		// get user

		$user_id    = mgm_get_user_id();

		$user       = get_userdata($user_id);

		// set data

		$data = array(		

			'x_recurring_billing'=>(isset($pack['num_cycles']) && $pack['num_cycles'] != 1 ? 'TRUE':'FALSE'),					

			//'x_description'=>($pack['item_name'] ? $pack['item_name']:$system->setting['subscription_name']),	

			//updated here on 2011 Feb 24 for issue: 289		

			'x_description'=>($pack['item_name'] ? $pack['item_name']:$system->get_subscription_name($pack)),			

			'x_email'=>$user->user_email,			

			'x_amount'=>$pack['cost'] // base amount is always same for both type of payment

		);

		

		// additional fields

		$this->_set_address_fields($user, $data, array('first_name'=>'x_first_name','last_name'=>'x_last_name','address'=>'x_address',

		                                               'city'=>'x_city','state'=>'x_state','zip'=>'x_zip','country'=>'x_country'));	// see parent for all fields, only different given here	

		

		//Subscription Payment

		if ($pack['num_cycles'] != 1 && $pack['duration_type']) { // ongoing(0) or 1-99 times

			// cust id

			$data['x_cust_id'] = $user_id;

			// types

			$unit_types = array('d'=>'days', 'm'=>'months', 'y'=>'months');	// treat year a 12 x months	

			// interval

			$data['x_interval_unit']   = $unit_types[$pack['duration_type']]; // days|months

			$data['x_interval_length'] = ($pack['duration_type']=='y') ? ((int)$pack['duration'] * 12) : $pack['duration']; // 3|12|365 etc.

			

			// start date

			$data['x_start_date'] = date('Y-m-d') ;

			

			// arb ongoing =0 must be set as 9999, or integer 1-99

			// occurrences: greater than 0

			if ($pack['num_cycles']) {

				$data['x_total_occurrences'] = $pack['num_cycles'];

			}else{

				$data['x_total_occurrences'] = 9999;// ongoing for ARB

			}			

			

			// trial

			if ($pack['trial_on']) {

				$data['x_trial_occurrences'] = $pack['trial_num_cycles'];

				$data['x_trial_amount']      = $pack['trial_cost'];															

			}

		} else {	

			// invoice_num

			$data['x_invoice_num'] = rand();				

			// Purchase Post ?? 

			if ($pack['duration'] == 1 && !$pack['duration_type']) {

				if (isset($pack['ppp_pack_id'])) {

					// get comma separated list of post ids					

					$pack['post_id'] = mgm_get_ppp_pack_post_csv($pack['ppp_pack_id']);

				} else {				

					// single post	

					$pack['post_id'] = get_the_ID();					

				}										

			} 

		}

		

		// custom

		$data['x_custom'] = $this->_set_payment_type($pack, $currency);

		// return data		

		return $data;

	}	

	

	// buy post

	function _buy_post() {

		global $wpdb;



		$system = mgm_get_option('mgm_system');

		$dge = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;

		

		list($duration, $cost, $currency, $user_id, $post_id, $user_id, $client_ip) = explode('_', preg_replace('/^buypost_/','', $_POST['x_custom']));



		// find user

		$user     = get_userdata($user_id);

		$blogname = get_option('blogname');

		$tran_success = false;

		

		// errors

		$errors = array();

		// response code

		$response_code = $this->_get_response_code($this->response['response_status'], 'status');

		// process on response code

		switch ($response_code) {

			case 'Approved':

				$tran_success = true;

				$status_str = __('Last payment was successful','mgm');

				//$subject = sprintf(__('[%s] Payment receipt','mgm'),$blogname);

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />This is a notification to inform you that your payment was successful and the post you purchased is now available to view.<br />For more information please contact %4$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $system->setting['admin_email']);

				

				 //issue#: 280 (2011 Feb 25)

				// subject

				$subject = $system->get_template('payment_success_email_template_subject', array('blogname'=>$blogname), true);

				// body

				$message = $system->get_template('payment_success_email_template_body', 

										array('blogname'=>$blogname, 'name'=>$user->display_name, 

											  'email'=>$user->user_email, 

											  'admin_email'=>$system->setting['admin_email']), true);

				// after succesful payment hook

				do_action('mgm_buy_post_transaction_success', array("post_id"=>$post_id));

				break;



			case 'Declined':

			case 'Refunded':

			case 'Denied':

				$status_str = __('Last payment was refunded or denied','mgm');

				//$subject = sprintf(__('[%s] Payment Failed','mgm'), $blogname);

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />This is a notification to inform you that your post purchase failed for the following reason: %4$s.<br />For more information please contact %5$s.','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $status_str, $system->setting['admin_email']);				

				 //issue#: 280 (2011 Feb 25)

				// subject

				$subject = $system->get_template('payment_failed_email_template_subject', array('blogname'=>$blogname), true);

				 

				// body			

				$message = $system->get_template('payment_failed_email_template_body', 

										array('blogname'=>$blogname, 'name'=>$user->display_name, 

											  'email'=>$user->user_email, 'payment_type'=>'post purchase payment','reason'=>$status_str,

											  'admin_email'=>$system->setting['admin_email']), true);

				// error

				$errors[] = $status_str;	

			break;



			case 'Pending':

			case 'Held for Review':

				$reason = $this->response['message_text'];

				$status_str = sprintf(__('Last payment is pending. Reason: %s','mgm'), $reason);

				//$subject = "[" . $blogname . "] Payment receipt - Status Pending";

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />This is a notification to inform you that you payment was received in pending status. Status: %4$s.<br />For more information please contact %5$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $status_str, $system->setting['admin_email']);

				

				 //issue#: 280 (2011 Feb 25)

				// subject

				$subject = $system->get_template('payment_pending_email_template_subject', array('blogname'=>$blogname), true);

				// body	

				$message = $system->get_template('payment_pending_email_template_body', 

										array('blogname'=>$blogname, 'name'=>$user->display_name, 

											  'email'=>$user->user_email, 'reason'=>$status_str,

											  'admin_email'=>$system->setting['admin_email']), true);

				// error

				$errors[] = $status_str;

			break;



			default:

				//issue#: 280 (2011 Feb 25)

				$status_str = sprintf(__('Last payment status: %s','mgm'),$response_code);

				//$subject = "[$blogname] Payment receipt";

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />Status: %4$s.<br />For more information please contact %5$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $status_str, $system->setting['admin_email']);				

				// subject

				$subject = $system->get_template('payment_unknown_email_template_subject', array('blogname'=>$blogname), true);				

				// body	

				$message = $system->get_template('payment_unknown_email_template_body', array('blogname'=>$blogname, 'name'=>$user->display_name, 

				                                                                              'email'=>$user->user_email, 'reason'=>$status_str,

																							  'admin_email'=>$system->setting['admin_email']), true);

				// error

				$errors[] = $status_str;

		}

		

		// notify user

		mgm_mail($user->user_email, $subject, $message); //send an email to the buyer		



		$status = __('Failed join', 'mgm'); // overridden on a successful payment

		if ($tran_success) {

			$table_name = TBL_MGM_POSTS_PURCHASED;

			

			//if we are looking at a pack then explode the buy post item number and loop through it

			if (strpos($post_id, ',') !== false) {

				$posts = explode(',', $post_id);

			} else {

				$posts = array($post_id);

			}

			

			$posts = array_unique($posts);

			

			foreach ($posts as $post_id) {

				$sql = "INSERT INTO " . $table_name . " (user_id, post_id, unixtime)

					VALUES (" . $user_id . ", " . $post_id . ", UNIX_TIMESTAMP())";

				$wpdb->query($sql); //insert the post purchased record

			}



			$status = __('The post was purchased successfully', 'mgm');

		}

		

		// notify admin, only if gateway emails on 

		if (!$dge) {

			$subject = "[" . $blogname . "] Admin Notification: " . $user->user_email . " purchased post " . $post_id;

			$message = "User display name: {$user->display_name}<br />User email: {$user->user_email}<br />User ID: {$user->ID}<br />Status: " . $status . "<br />Action: Purchase post:" . $subject . "<br /><br />" . $message . "<br /><br /><pre>" . print_r($_POST, true) . '</pre>';

			mgm_mail($system->setting['admin_email'], $subject, $message);

		}

		

		// error condition redirect

		if(count($errors)>0){

			wp_redirect(add_query_arg(array('status'=>'error', 'errors'=>implode('|', $errors)), $this->setting['processed_url']));

		}

	}

	

	// buy membership

	function _buy_membership() {	

		// system	

		$system       = mgm_get_option('mgm_system');		

		$packs        = mgm_get_option('mgm_subscription_packs');

		$duration_str = $packs->duration_str;

		//$status_str   = $system->get_statuses();

		$dge          = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;

		// get custom field values

		list($duration, $amount, $currency, $user_id, $membership_type, $duration_type, $role, $client_ip, $hide_old_content, $pack_id) = explode('_', preg_replace('/^subscription_/','', $_POST['x_custom']));

		

		// currency

		if (!$currency) {

			$currency = $system->setting['currency'];

		}

		// find user

		$user       = get_userdata($user_id);

		$mgm_member = mgm_get_member($user_id);



		$join_date = $mgm_member->join_date; // Get the current AC join date



		if (!$join_date) {

			$mgm_member->join_date = time(); // Set current AC join date

		}



		//if there is no duration set in the user object then run the following code

		if (empty($duration_type)) {

			//if there is no duration type then use Months

			$duration_type = 'm';

		}

		// membership type default

		if (empty($membership_type)) {

			//if there is no account type in the custom string then use the existing type

			$membership_type = md5($mgm_member->membership_type);

		}

		// validate parent method

		$membership_type_verified = $this->_validate_membership_type($membership_type, 'md5|plain');

		// verified

		if (!$membership_type_verified) {

			if (strtolower($mgm_member->membership_type) != 'free') {

				// notify admin, only if gateway emails on

				if(!$dge){

					$message = 'Could not read membership type in the following POST data. Please debug or contact magic members to fix the problem making sure to pass on the following data. <br /><br /><pre>' . "\n\n" . print_r($_POST, true) . '</pre>';

					mgm_mail($system->setting['admin_mail'], 'Error in Authirize.Net membership verification', $message);

				}

				// abort

				return;

			} else {

				$membership_type_verified = $mgm_member->membership_type;

			}

		}		

		// set

		$membership_type             = $membership_type_verified;

		// sub pack

		$subs_pack                   = $packs->get_pack($pack_id);

		// if trial on		

		if ($subs_pack['trial_on']) {

			$mgm_member->trial_on            = $subs_pack['trial_on'];

			$mgm_member->trial_cost          = $subs_pack['trial_cost'];

			$mgm_member->trial_duration      = $subs_pack['trial_duration'];

			$mgm_member->trial_duration_type = $subs_pack['trial_duration_type'];

			$mgm_member->trial_num_cycles    = $subs_pack['trial_num_cycles'];

		}	

		// duration

		$mgm_member->duration        = $duration;

		$mgm_member->duration_type   = strtolower($duration_type);

		$mgm_member->amount          = $amount;

		$mgm_member->currency        = $currency;

		$mgm_member->membership_type = $membership_type;		

		$mgm_member->pack_id         = $pack_id;

		$mgm_member->payment_type    = 'subscription';

		// payment info for unsubscribe		

		$mgm_member->payment_info         = new stdClass;

		$mgm_member->payment_info->module = $this->code;

		/*

		$this->response['response_status'] = $x_response_code;	

		$this->response['message_code']    = $x_response_reason_code;

		$this->response['message_text']    = $x_response_reason_text;

		$this->response['transaction_id']  = $x_transaction_id;	

		$this->response['subscription_id']

		$this->response['transaction_type']

		*/

		// transaction type

		if(isset($this->response['transaction_type'])){	

			$mgm_member->payment_info->txn_type = $this->response['transaction_type'];	

		}

		// subscription

		if(isset($this->response['subscription_id'])){

			$mgm_member->payment_info->subscr_id = $this->response['subscription_id'];		

		}

		// transaction	

		if(isset($this->response['transaction_id'])){	

			$mgm_member->payment_info->txn_id = $this->response['transaction_id'];	

		}

		// process response

		$new_status = false;

		// errors

		$errors = array();	

		// response code

		$response_code = $this->_get_response_code($this->response['response_status'], 'status');

		// mgm_log($response_code);

		// process on response code

		switch ($response_code) {

			case 'Approved':

				$new_status = MGM_STATUS_ACTIVE;

				$mgm_member->status_str = __('Last payment was successful','mgm');					

				

				$time = time();				

				$mgm_member->last_pay_date = date('Y-m-d', $time);					

						

				// THIS is causing double calculation

				/* ***********************************/

				if ($mgm_member->expire_date && $mgm_member->last_pay_date!=date('Y-m-d', $time)) {

					$expiry = strtotime($mgm_member->expire_date);

					if ($expiry > 0) {

						if ($expiry > $time) {

							$time = $expiry;

						}

					}

				}

				/*************************************/

				

				// type expanded

				$duration_types = array('d'=>'DAY','m'=>'MONTH','y'=>'YEAR');				

				// time

				$time = strtotime("+{$mgm_member->duration} {$duration_types[$mgm_member->duration_type]}", $time);										

				// formatted

				$time_str = date('Y-m-d', $time);				

				// date extended				

				if (!$mgm_member->expire_date || strtotime($time_str) > strtotime($mgm_member->expire_date)) {

					$mgm_member->expire_date = $time_str;										

				}					

					

				// role

				if ($role) {

					$role_obj = new WP_User($user_id);

					$role_obj->set_role($role);

				}			

				

				// after succesful payment hook

				do_action('mgm_membership_transaction_success', array("user_id" =>$user_id));	

							

			break;



			case 'Declined':

			case 'Refunded':

			case 'Denied':

				$new_status = MGM_STATUS_NULL;

				$mgm_member->status_str = __('Last payment was refunded or denied','mgm');

				// error

				$errors[] = $mgm_member->status_str;

			break;

			

			case 'Pending':

			case 'Held for Review':

				$new_status = MGM_STATUS_PENDING;

				$reason = $this->response['message_text'];

				$mgm_member->status_str = sprintf(__('Last payment is pending. Reason: %s','mgm'), $reason);				

				// error

				$errors[] = $mgm_member->status_str;

			break;



			default:

				$new_status = MGM_STATUS_ERROR;

				$mgm_member->status_str = sprintf(__('Last payment status: %s','mgm'), $response_code.' - '.$this->response['message_text']);

				// error

				$errors[] = $mgm_member->status_str;

			break;

		}

		

		// set status

		$mgm_member->status = $new_status;

		// update member		

		update_user_option($user_id, 'mgm_member', $mgm_member, true);				



		//Do Return Action

		do_action('mgm_return_authorizenet');



		// send email notification to client

		$blogname = get_option('blogname');

		switch ($new_status) {

			case MGM_STATUS_ACTIVE:

				//$subject = sprintf(__('[%s] Payment receipt','mgm'),$blogname);

				//issue #: 280

				// subject

				$subject = $system->get_template('payment_success_email_template_subject', array('blogname'=>$blogname), true);	

				if ($mgm_member->payment_type == 'subscription') {

					//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your payment was successful for recurring subscription of %4$s %5$s every %6$s %7$s. For more information please contact %8$s','mgm');

					$payment_type = 'recurring subscription';

					$subscription = sprintf('%1$s %2$s every %3$s %4$s',$mgm_member->amount, $mgm_member->currency, $mgm_member->duration, 

					                                                    $duration_str[$mgm_member->duration_type]);

				} else {

					//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your payment was successful for a one-time payment of %4$s %5$s for %6$s %7$s. For more information please contact %8$s','mgm');

					$payment_type = 'one-time payment';

					$subscription = sprintf('%1$s %2$s for %3$s %4$s',$mgm_member->amount, $mgm_member->currency, $mgm_member->duration, 

					                                                  $duration_str[$mgm_member->duration_type]);

				}



				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->amount, $mgm_member->currency, $mgm_member->duration, $duration_str[$mgm_member->duration_type], $system->setting['admin_email']);

				$message = $system->get_template('payment_success_subscription_email_template_body', 

													array('blogname'=>$blogname, 'name'=>$user->display_name, 

														  'email'=>$user->user_email, 'payment_type'=>$payment_type,

														  'subscription'=>$subscription,'admin_email'=>$system->setting['admin_email']), true);

				break;



			case MGM_STATUS_NULL:

				//issue#: 280 (2011 Feb 25)

				//$subject = sprintf(__('[%s] Account inactive','mgm'), $blogname);

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your account is inactive for the following reason: %4$s. For more information please contact %5$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->status_str, $system->setting['admin_email']);

				// subject

				$subject = $system->get_template('payment_failed_email_template_subject', array('blogname'=>$blogname), true);				

				// message

				$message = $system->get_template('payment_failed_email_template_body', 

									array('blogname'=>$blogname, 'name'=>$user->display_name, 

										  'email'=>$user->user_email, 'payment_type'=>'subscription payment',

										  'reason'=>$mgm_member->status_str,

										  'admin_email'=>$system->setting['admin_email']), true);

				

				break;



			case MGM_STATUS_PENDING:

				//issue#: 280 (2011 Feb 25)

				//$subject = "[$blogname] Payment receipt - Status Pending";

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that you payment was received in pending status. Status: %4$s. For more information please contact %5$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->status_str, $system->setting['admin_email']);

				// subject

				$subject = $system->get_template('payment_pending_email_template_subject', array('blogname'=>$blogname), true);

				// body

				$message = $system->get_template('payment_pending_email_template_body', 

										array('blogname'=>$blogname, 'name'=>$user->display_name, 

											  'email'=>$user->user_email, 'reason'=>$mgm_member->status_str,

											  'admin_email'=>$system->setting['admin_email']), true);

				break;



			case MGM_STATUS_ERROR:

				//issue#: 280 (2011 Feb 25)

				//$subject = "[$blogname] Error on payment";

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that an error occurred while processing your payment. Details: %4$s. For more information please contact %5$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->status_str, $system->setting['admin_email']);

				// subject

				$subject = $system->get_template('payment_error_email_template_subject', array('blogname'=>$blogname), true);				

				// body	

				$message = $system->get_template('payment_error_email_template_body', 

									array('blogname'=>$blogname, 'name'=>$user->display_name, 

										  'email'=>$user->user_email, 'reason'=>$mgm_member->status_str,

										  'admin_email'=>$system->setting['admin_email']), true);

				break;

		}

		

		// notify user

		mgm_mail($user->user_email, $subject, $message);	



		// notify admin, only if gateway emails on

		if (!$dge) {

			$subject = "[$blogname] {$user->user_email} - {$new_status}";

			$message = "	User display name: {$user->display_name}\n\n<br />

					User email: {$user->user_email}\n\n<br />

					User ID: {$user->ID}\n\n<br />

					Membership Type: {$membership_type}\n\n<br />

					New status: {$new_status}\n\n<br />

					Status message: {$mgm_member->status_str}\n\n<br />

					Subscription period: {$mgm_member->duration} ". $duration_str[$mgm_member->duration_type] ."\n\n<br />

					Subscription amount: {$mgm_member->amount} {$mgm_member->currency}\n<br />

					Payment Mode: {$mgm_member->payment_type}\n\n<br />

					POST Data was: \n\n<br /><br /><pre>" . print_r($_POST, true) . '</pre>';

			mgm_mail($system->setting['admin_email'], $subject, $message);

		}

		

		// error condition redirect

		if(count($errors)>0){			

			wp_redirect(add_query_arg(array('status'=>'error', 'errors'=>implode('|', $errors)), $this->setting['processed_url']));

		}

	}

	

	// cancel membership

	function _cancel_membership($user_id){

		// system	

		$system       = mgm_get_option('mgm_system');		

		$packs        = mgm_get_option('mgm_subscription_packs');

		$duration_str = $packs->duration_str;

		//$status_str   = $system->get_statuses();

		$dge          = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;

		

		// find user

		$user       = get_userdata($user_id);

		$mgm_member = mgm_get_member($user_id);	

		

		// get pack

		if($mgm_member->pack_id){

			$subs_pack = $packs->get_pack($mgm_member->pack_id);

		}else{

			$subs_pack = $packs->validate_pack($mgm_member->amount, $mgm_member->duration, $mgm_member->duration_type, $mgm_member->membership_type);

		}

				

		// reset payment info

		$mgm_member->payment_info->txn_type = 'subscription_cancel';

		

		// types

		$duration_types = array('d'=>'DAY','m'=>'MONTH','y'=>'YEAR');	

						

		// default expire date				

		$expire_date = $mgm_member->expire_date;					

		// if trial on 

		if ($subs_pack['trial_on']) {			

			// if cancel data is before trial end, set cancel on trial expire_date

			$trial_expire_date = strtotime("+{$subs_pack['trial_duration']} {$duration_types[$subs_pack['trial_duration_type']]}", $mgm_member->join_date);

			

			// if lower

			if(time() < $trial_expire_date){

				$expire_date = date('Y-m-d',$trial_expire_date);

			}

		}	

			

		// if today 

		if($expire_date == date('Y-m-d')){

			$new_status = MGM_STATUS_CANCELLED;

			$mgm_member->status_str = __('Subscription Cancelled','mgm');					

			$mgm_member->expire_date = date('Y-m-d');	

			// set status

			$mgm_member->status = $new_status;

		}else{

			$new_status = MGM_STATUS_AWAITING_CANCEL;			

			// reset on

			$mgm_member->status_reset_on = $expire_date;

			$mgm_member->status_reset_as = MGM_STATUS_CANCELLED;

		}		

		

		// update user

		update_user_option($user_id, 'mgm_member', $mgm_member, true);		

			

		// send email notification to client

		$blogname = get_option('blogname');

		//issue#: 280 (2011 Feb 25)

		// email	

		//$subject = sprintf(__('[%s] Subscription Cancelled','mgm'),$blogname);				

		//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your subscription has been cancelled. For more information please contact %4$s','mgm');

		//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $system->setting['admin_email']);

		

		// subject

		$subject = $system->get_template('subscription_cancelled_email_template_subject', array('blogname'=>$blogname), true);				

		// body	

		$message = $system->get_template('subscription_cancelled_email_template_body', 

							array('blogname'=>$blogname, 'name'=>$user->display_name, 

								  'email'=>$user->user_email, 'admin_email'=>$system->setting['admin_email']), true);

		// send email notification to user

		mgm_mail($user->user_email, $subject, $message);		



		// notify admin, only if gateway emails on

		if (!$dge) {

			$subject = "[$blogname] {$user->user_email} - {$new_status}";

			$message = "	User display name: {$user->display_name}\n\n<br />

					User email: {$user->user_email}\n\n<br />

					User ID: {$user->ID}\n\n<br />

					Membership Type: {$membership_type}\n\n<br />

					New status: {$new_status}\n\n<br />

					Status message: {$mgm_member->status_str}\n\n<br />					

					Payment Mode: Cancelled\n\n<br />";

			mgm_mail($system->setting['admin_email'], $subject, $message);

		}

		

		// after cancellation hook

		do_action('mgm_membership_subscription_cancelled', array("user_id" =>$user_id));			

		

		// message

		$message = sprintf(__("You have successfully Unsubscribed. Your account is marked for Cancellation on %s", "mgm"), ($expire_date == date('Y-m-d') ? 'Today' : date(MGM_DATE_FORMAT_LONG, strtotime($expire_date)) ));

		

		// redirect 

		wp_redirect('wp-admin/profile.php?page=mgm/profile&unsubscribed=true&unsubscribe_errors='.urlencode($message));

	}

		

	// filter postdata

	function _filter_postdata($gateway_method, $post_data){	

		// card holder name

		list($ch_first_name, $ch_last_name) = explode(' ', $post_data['mgm_card_holder_name']);	

		// gateway method

		switch($gateway_method){

			case 'arb':

				// request xml

				$content =

						"<?xml version=\"1.0\" encoding=\"utf-8\"?>" .

							"<ARBCreateSubscriptionRequest xmlns=\"AnetApi/xml/v1/schema/AnetApiSchema.xsd\">" .

								"<merchantAuthentication>".

									"<name>" . $post_data['x_login'] . "</name>".

									"<transactionKey>" . $post_data['x_tran_key'] . "</transactionKey>".

								"</merchantAuthentication>".

								"<refId>" . $post_data['x_cust_id'] . "</refId>".

								"<subscription>".

									"<name>" . substr($post_data['x_description'],0,50) . "</name>". // iss#165, name overflow		

									"<paymentSchedule>".

										"<interval>".

											"<length>" . $post_data['x_interval_length'] . "</length>".

											"<unit>" . $post_data['x_interval_unit'] . "</unit>".

										"</interval>".	

										"<startDate>" . $post_data['x_start_date'] . "</startDate>".

										"<totalOccurrences>" . $post_data['x_total_occurrences'] . "</totalOccurrences>";

				$content .= ($post_data['x_trial_occurrences']) ? "<trialOccurrences>" . $post_data['x_trial_occurrences'] . "</trialOccurrences>": "";

				$content .=		

									"</paymentSchedule>".		

									"<amount>" . $post_data['x_amount'] . "</amount>";	

				$content .= ($post_data['x_trial_occurrences']) ? "<trialAmount>" . $post_data['x_trial_amount'] . "</trialAmount>" : "";

				$content .=	

									"<payment>".

										"<creditCard>".

											"<cardNumber>" . $post_data['mgm_card_number'] . "</cardNumber>".

											"<expirationDate>" . $post_data['mgm_expiry']['year'].'-'.$post_data['mgm_expiry']['month'] . "</expirationDate>".

										"</creditCard>".

									"</payment>".

									"<customer>".

										"<id>" . $post_data['x_cust_id'] . "</id>".

										"<email>" . $post_data['x_email'] . "</email>".

										/*"<phoneNumber>".$post_data['x_phone'] ."</phoneNumber>".*/	

									"</customer>".

									"<billTo>".

										"<firstName>". (($post_data['x_first_name']) ? $post_data['x_first_name'] : $ch_first_name) . "</firstName>".

										"<lastName>" . (($post_data['x_last_name']) ? $post_data['x_last_name'] : $ch_last_name) . "</lastName>";

										

										// address					

										if(isset($post_data['x_address'])){									

											$content .=	"<address>" . substr($post_data['x_address'], 0, 60) . "</address>";	

										}

										// city

										if(isset($post_data['x_city'])){	

											$content .="<city>" . substr($post_data['x_city'], 0, 40) . "</city>";

										}	

										// city

										if(isset($post_data['x_state']) && strlen($post_data['x_state'])==2){	

											$content .="<state>" . substr($post_data['x_state'], 0, 2) . "</state>";

										}

										// city

										if(isset($post_data['x_zip'])){	

											$content .="<zip>" . substr($post_data['x_zip'], 0, 20) . "</zip>";

										}

										// city

										if(isset($post_data['x_country'])){	

											$content .="<country>" . substr($post_data['x_country'],0, 60) . "</country>";

										}

										

				 $content .=		"</billTo>".

								"</subscription>".

							"</ARBCreateSubscriptionRequest>";	

				// return

				// mgm_log( $content );

				return $content;			

			break;

			case 'aim':

				// set delim

				$this->delim_char = '|';

				// custom set

				$aim_fields = array('x_version'        => '3.1',

									'x_type'           => 'AUTH_CAPTURE',

									'x_invoice_num'    => $post_data['x_invoice_num'],

									'x_delim_data'     => 'TRUE',

									'x_delim_char'     => $this->delim_char,

									'x_method'         => 'CC',	

									'x_relay_response' => 'FALSE',

									'x_email_customer' => 'TRUE',	

									'x_card_num'	   => $post_data['mgm_card_number'],

									'x_card_code'      => $post_data['mgm_card_code'],

									'x_exp_date'	   => $post_data['mgm_expiry']['month'].'-'.$post_data['mgm_expiry']['year'] // MM-YYYY	

							);

				// capture some as sent

				$fields_sent = array('x_login', 'x_tran_key', 'x_description', 'x_first_name', 'x_last_name', 'x_email', 'x_cust_id', 'x_amount');

				// first last name

				if($post_data['x_first_name'] == '' || $post_data['x_first_name']==$post_data['x_last_name']) {

					$post_data['x_first_name'] = $ch_first_name;

				}

				if($post_data['x_last_name'] == '' || $post_data['x_first_name']==$post_data['x_last_name']) {

					$post_data['x_last_name'] = $ch_last_name;

				}

				// set

				foreach($fields_sent as $field){

					// take only when set

					if(isset($post_data[$field]) && !empty($post_data[$field])){

						$aim_fields[$field] = $post_data[$field];

					}

				}

				// send filtered

				return  mgm_http_build_query($aim_fields);			

			break;

		}		

	}

	

	// process response

	function _process_response($gateway_method, $content){

		// gateway method

		switch($gateway_method){

			case 'arb':

				$xml = simplexml_load_string($content);				

				if($xml){

					$this->response['response_status'] = ((string)$xml->messages->resultCode == 'Ok') ? 1 : 3; // 1 success, 3 error

					$this->response['message_code']    = (string)$xml->messages->message->code ;	

					$this->response['message_text']    = (string)$xml->messages->message->text ;

					$this->response['subscription_id'] = (string)$xml->subscriptionId;					

				}else{

					$this->response['response_status'] = 3;

					$this->response['message_text']    = 'Error parsing XML';

					// log and report

					// mgm_log($content); 

				}

			break;

			case 'aim':

				// split

				$tmp_data = explode($this->delim_char, $content);

				// mgm_log(print_r($tmp_data, true));

				// error

				if(count($tmp_data)==0){

					$this->response['response_status'] = 3;

					$this->response['message_text']    = strip_tags($tmp_data[0]);

				}else{

					// pos params

					$fields = array(0=>"x_response_code", 1=>"x_response_subcode", 2=>"x_response_reason_code", 3=>"x_response_reason_text",

		                            4=>"x_authorization_code", 5=>"x_avs_response", 6=>"x_transaction_id", 9=>"x_amount", 10=>"x_method",

								    11=>"x_transaction_type", 37=>"x_md5_hash", 38=>"x_card_code_response");

					// store

					foreach($fields as $index=>$field){

						${$field} = $tmp_data[$index];			

					}					

					// set 

					$this->response['response_status']  = $x_response_code;	

					$this->response['message_code']     = $x_response_reason_code;

					$this->response['message_text']     = $x_response_reason_text;

					$this->response['transaction_id']   = $x_transaction_id;

					$this->response['transaction_type'] = $x_transaction_type;				

				}

			break;

		}		

	}	

	

	// get code

	function _get_response_code($key, $type='status'){

		// status

		$response_code['status']  = array(1 => "Approved", 2 => "Declined", 3 => "Error", 4 => "Held for Review");	

		// avs: address verification

		$response_code['avs']     = array("A" => "Address (Street) matches, ZIP does not",

										  "B" => "Address information not provided for AVS check",

										  "E" => "AVS error",

										  "G" => "Non-U.S. Card Issuing Bank",

										  "N" => "No Match on Address (Street) or ZIP",

										  "P" => "AVS not applicable for this transaction",

										  "R" => "Retry � System unavailable or timed out",

										  "S" => "Service not supported by issuer",

										  "U" => "Address information is unavailable",

										  "W" => "Nine digit ZIP matches, Address (Street) does not",

										  "X" => "Address (Street) and nine digit ZIP match",

										  "Y" => "Address (Street) and five digit ZIP match",

										  "Z" => "Five digit ZIP matches, Address (Street) does not)");

										 

		// cvv: card verification						 

		$response_code['cvv2']      = array("M" => "Match", "N" => "No Match", "P" => "Not Processed", "S" => "Should have been present", 

								           "U" => "Issuer unable to process request");									   

		

		// mgm_log(print_r($response_code[$type]). ' '.$response_code[$type][$key]);

		// check

		if(isset($response_code[$type][$key])){

			return $response_code[$type][$key];

		}				   

		// default

		return 'error';

	}

	// default setting

	function _default_setting(){

		// authorize.net specific

		$this->setting['loginid']  = '';

		$this->setting['tran_key'] = '';	

		// purchase price

		if(in_array('buypost', $this->supported_buttons)){

			$this->setting['purchase_price']  = 4.00;		

		}		

		// callback messages				

		$this->_setup_callback_messages();

		// callback urls

		$this->_setup_callback_urls();	

	}

	

	// curl post

	function _curl_post($url, $post, $http_header=array()){

		$ch = curl_init();		

		curl_setopt($ch, CURLOPT_URL, $url); 	

		// when set

		if(is_array($http_header)){	

			curl_setopt($ch, CURLOPT_HTTPHEADER, $http_header);	

		}		

		curl_setopt($ch, CURLOPT_HEADER, 0);	

		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0); 

		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0); 

		curl_setopt($ch, CURLOPT_NOPROGRESS, 1); 

		curl_setopt($ch, CURLOPT_VERBOSE, 1); 

		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 0); 

		curl_setopt($ch, CURLOPT_POST, 1); 

		curl_setopt($ch, CURLOPT_POSTFIELDS, $post); 

		curl_setopt($ch, CURLOPT_TIMEOUT, 30); 

		curl_setopt($ch, CURLOPT_USERAGENT, 'Magic Members Membership Software'); 

		curl_setopt($ch, CURLOPT_REFERER, get_option('siteurl')); 

		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

		$buffer = curl_exec($ch);

		curl_close($ch);

		

		// return

		return $buffer;

	}

}



// end file