<?php



// payment module

class mgm_authorizenet extends mgm_payment{

	// construct

	function __construct(){

		// php4 construct

		$this->mgm_authorizenet();

	}

	

	// construct

	function mgm_authorizenet(){

		// parent

		parent::__construct();

		// set code

		$this->code = __CLASS__; 

		// set name

		$this->name = 'Authorize.Net';

		// logo

		$this->logo = MGM_PLUGIN_MODULE_URL . 'payment/authorizenet.jpg';

		// description

		$this->description = __('Authorize.Net. ARB and AIM integration for Recurring payments and Single Purchase.', 'mgm');

		// supported buttons types

	 	$this->supported_buttons = array('subscription', 'buypost');

		// trial support available ?

		$this->supports_trial= 'Y';	

		// do we depend on product mapping	

		$this->requires_product_mapping = 'N'; 

		// endpoints

		$this->_set_endpoint('test','https://test.authorize.net/gateway/transact.dll'); // test

		$this->_set_endpoint('live','https://secure.authorize.net/gateway/transact.dll'); // live

		// default settings

		$this->_default_setting();

		// set path

		parent::set_tmpl_path();	

	}	

	

	// settings

	function settings(){

		global $wpdb;

		// data

		$data = array();		

		// set 

		$data['module'] = mgm_get_option($this->code);	

		// load template view

		$this->load_template('settings', array('data'=>$data, 'ajax'=>true));

	}	

	

	// settings_box

	function settings_box(){

		global $wpdb;

		// data

		$data = array();	

		// set 

		$data['module'] = mgm_get_option($this->code);

		// load template view

		return $this->load_template('settings_box', array('data'=>$data), true);

	}

	

	// update

	function settings_update(){

		// form type 

		switch($_POST['setting_form']){

			case 'box':

			// from box	

				switch($_POST['act']){

					case 'logo_update':

						// logo if uploaded

						if(isset($_POST['logo_new_'.$this->code]) && !empty($_POST['logo_new_'.$this->code])){

							$this->logo = $_POST['logo_new_'.$this->code];

							// update option

							update_option($this->code, $this);

						}

						// message

						$message = $this->name . ' logo updated';			

						$extra   = array();

					break;

					case 'status_update':

					default:

						// enable

						if($_POST['payment']['enable'] == 'Y'){

							$this->install();

							$stat = ' enabled.';

						}else{

						// disable

							$this->uninstall();	

							$stat = ' disabled.';

						}	

						

						# message

						$message = $this->name . ' module is '. $stat;			

						$extra   = array('enable' => $_POST['payment']['enable']);		

					break;

				}							

				// print message

				echo json_encode(array_merge(array('status'=>'success','message'=>$message,'module'=>array('name'=>$this->name,'code'=>$this->code,'tab'=>$this->settings_tab)), $extra));

			break;

			case 'main':

			default:

			// from main						

				// authorize.net specific				

				$this->setting['loginid']  = $_POST['setting']['loginid'];

				$this->setting['tran_key'] = $_POST['setting']['tran_key'];				

				// purchase price

				if(isset($_POST['setting']['purchase_price'])){

					$this->setting['purchase_price']  = $_POST['setting']['purchase_price'];

				}

				// setup callback messages				

				$this->_setup_callback_messages($_POST['setting']);

				// re setup callback urls

				$this->_setup_callback_urls($_POST['setting']);

				// common

				$this->description = $_POST['description'];

				$this->status      = $_POST['status'];

				// logo if uploaded

				if(isset($_POST['logo_new_'.$this->code]) && !empty($_POST['logo_new_'.$this->code])){

					$this->logo = $_POST['logo_new_'.$this->code];

				}				

				// update option

				update_option($this->code, $this);

				//  message

				echo json_encode(array('status'=>'success','message'=> $this->name . ' settings updated'));

			break;

		}		

	}

	

	// return process api hook, link back to site after payment is made

	function process_return(){

		// log

		// mgm_log('process_return: post values '.print_r($_POST, true));

		// check and show message

		if((isset($_POST['x_response_code'])) || isset($_POST['x_custom'])){

			// process notify, internally called

			$this->process_notify();

			// redirect as success if not already redirected

			// query arg

			$query_arg = array('status'=>'success');

			// is a post redirect?

			$post_redirect =$this->_get_post_redirect($_POST['x_custom']);

			// yes redirect argument passed

			if($post_redirect !== false){

				$query_arg['post_redirect'] = $post_redirect;

			}			

			// redirect

			wp_redirect(add_query_arg($query_arg, $this->setting['processed_url']));

		}else{

			// error

			wp_redirect(add_query_arg(array('status'=>'error'), $this->setting['processed_url']));

		}		

	}

	

	// notify process api hook, background IPN url 

	function process_notify(){

		// used as proxy for this module		

		// payment type

		$payment_type = $this->_get_payment_type($_POST['x_custom']);

		// check

		switch($payment_type){

			// buypost 

			case 'buypost':

				$this->_buy_post(); //run the code to process a purchased post/page

			break;

			// subscription	

			case 'subscription':

				$this->_buy_membership(); //run the code to process a new/extended membership

			break;	

			// other		

			default:

				// error

				$error = 'error in payment type : '.$payment_type;

				// bad payment type

				// mgm_log($error);

				// redirect to error

				wp_redirect(add_query_arg(array('status'=>'error','errors'=>$error), $this->setting['processed_url']));				

			break;							

		}	

	}

	

	// process cancel api hook 

	function process_cancel(){

		// not used for this module

		// redirect to cancel page

		wp_redirect(add_query_arg(array('status'=>'cancel'), $this->setting['processed_url']));

	}

	

	// subscribe button api hook

	function get_button_subscribe($options=array()){		

		// mgm_array_dump($options);

		$button_code     = $this->_get_button_code($options['pack']);

		$additional_code = do_action('mgm_additional_code');

		$html='<form action="'. $this->_get_endpoint() .'" method="post" class="mgm" name="' . $this->code . '_form" id="' . $this->code . '_form">

				'. $button_code .'

				'. $additional_code .'

				<input type="image" src="' . mgm_fix_url($this->logo) . '" name="submit" alt="' . $this->name . '" border="0">

				</form>';

		return $html;		

	}

	

	// buypost button api hook

	function get_button_buypost($options=array(), $return = false) {

		global $user;

		// merge pack

		$options['pack'] = array_merge($options['pack'], array('duration'=>1, 'item_name'=>'Purchase Post - '.$options['pack']['title'], 'buypost'=>1));

		// button code		

		$button_code = $this->_get_button_code($options['pack']);

		$additional_code = do_action('mgm_additional_code');

		// html

		$html = '<table width="100%" border="0" cellpadding="0" cellspacing="0" align="center" class="form-table">

					<form action="'. $this->_get_endpoint() .'" method="POST" class="mgm" name="' . $this->code . '_form">

						 <tr>

							 <td align="center">

							 '. $button_code .'						

							 '. $additional_code .'	

							  <input type="image" src="' . mgm_fix_url($this->logo) . '" name="submit" alt="' . $this->name . '" border="0">					

							 </td>

						 </tr>

					 </form>

				</table>';



		if ($return) {

			return $html;

		} else {

			echo $html;

		}

	}

	

	// dependency_check

	function dependency_check(){

		$this->dependency = array();

		if(!extension_loaded('mhash')){

			$this->dependency[] = '<b style="color:#FF1F3D">MHASH PHP extension must be loaded for Authorize.Net.</b>';

		}

		// error		

		return (count($this->dependency)>0) ? true : false ;

	}

	

	/////////////////////////////////////////////// internal/private methods /////////////////////////////////////////////////

	

	// get button code	

	function _get_button_code($pack) {

		$data   = $this->_get_button_data($pack);

		$return = '';	

		foreach ($data as $key => $value) {

			$return .= '	<input type="hidden" name="'. $key .'" value="'. $value .'" />' . "\n";

		}	

		return $return;

	}



	// get button data

	function _get_button_data($pack) {

		// system

		$system = mgm_get_option('mgm_system');	

		$currency   = $system->setting['currency'];

		// get user

		$user_id    = mgm_get_user_id();

		$user       = get_userdata($user_id);

		// set data

		$data = array(					

			'x_version'=>'3.1',

			'x_type'=>'AUTH_CAPTURE',

			'x_login'=>$this->setting['loginid'],			

			'x_amount'=>$pack['cost'],

			'x_show_form'=>'PAYMENT_FORM',

			'x_delim_data'=>'FALSE',

			'x_method'=>'CC',			

			'x_recurring_billing'=>(isset($pack['num_cycles']) && $pack['num_cycles'] != 1 ? 'TRUE':'FALSE'),					

			'x_description'=>($pack['item_name'] ? $pack['item_name']:$system->setting['subscription_name']),			

			'x_first_name'=>(isset($user->first_name)?$user->first_name:$user->display_name),

			'x_last_name'=>(isset($user->last_name)?$user->last_name:$user->display_name),

			'x_email'=>$user->user_email,

			'x_cust_id'=>$user_id,

			'x_receipt_link_method'=>'POST',

			'x_receipt_link_text'=>'Return to '.get_option('blogname'),

			'x_receipt_link_url'=>$this->setting['return_url'],

			'x_relay_response'=>'TRUE',

			'x_relay_url'=>$this->setting['return_url'],			

			'x_email_customer'=>'TRUE',

			'x_test_request'=>($this->status == 'live' ? 'FALSE' : 'TRUE')

		);

		

		// add signature

		$this->_add_signature($pack['cost'], $data);

		

		//Subscription Payment

		if ($pack['num_cycles'] != 1 && $pack['duration_type']) { // ongoing(0) or 1-99 times

			// nothing		

			// markit for arb ongoing =0 must be set as 9999, or integer 1-99

		} else {			

			$data['x_amount'] = $pack['cost'];

			

			// Purchase Post ?? 

			if ($pack['duration'] == 1 && !$pack['duration_type']) {

				if (isset($pack['ppp_pack_id'])) {

					// get comma separated list of post ids					

					$pack['post_id'] = mgm_get_ppp_pack_post_csv($pack['ppp_pack_id']);

				} else {				

					// single post	

					$pack['post_id'] = get_the_ID();					

				}						

			} 

		}

		

		// custom

		$data['x_custom'] = $this->_set_payment_type($pack, $currency);

		// return data		

		return $data;

	}	

	

	// add signature

	function _add_signature($amount, &$data){	

			

		srand(time());

		$sequence     = rand(1, 1000);			

		$tstamp       = time ();		

		$currency     = '';

		$finger_print = $this->_hmac($this->setting['tran_key'], $this->setting['loginid'] . "^" . $sequence . "^" . $tstamp . "^" . $amount . "^" . $currency);		

		$data         = array_merge($data, array('x_fp_sequence'=>$sequence,'x_fp_timestamp'=>$tstamp,'x_fp_hash'=>$finger_print));			

	}

	

	// compute HMAC-MD5



	// Uses PHP mhash extension. Pl sure to enable the extension

	

	function _hmac ($key, $data){

		return (bin2hex (mhash(MHASH_MD5, $data, $key)));

	}

	

	// Calculate and return fingerprint	

	// Use when you need control on the HTML output	

	function _calculate_finger_print($loginid, $x_tran_key, $amount, $sequence, $tstamp, $currency = ""){

		return ($this->hmac ($x_tran_key, $loginid . "^" . $sequence . "^" . $tstamp . "^" . $amount . "^" . $currency));

	}

	

	// verify callback 

	function _verify_callback(){	

		// not used	

	}	

	

	// buy post

	function _buy_post() {

		global $wpdb;



		$system = mgm_get_option('mgm_system');

		$dge = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;

		

		list($duration, $cost, $currency, $user_id, $post_id, $user_id, $client_ip) = explode('_', preg_replace('/^buypost_/','', $_POST['x_custom']));



		// find user

		$user     = get_userdata($user_id);

		$blogname = get_option('blogname');

		$tran_success = false;

		

		// errors

		$errors = array();

		// response code

		$response_code = $this->_get_response_code();

		// process on response code

		switch ($response_code) {

			case 'Approved':

				$tran_success = true;

				$status_str = __('Last payment was successful','mgm');

				$subject = sprintf(__('[%s] Payment receipt','mgm'),$blogname);

				$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />This is a notification to inform you that your payment was successful and the post you purchased is now available to view.<br />For more information please contact %4$s','mgm');

				$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $system->setting['admin_email']);

				// after succesful payment hook

				do_action('mgm_buy_post_transaction_success', array("post_id"=>$post_id));

				break;



			case 'Declined':

			case 'Refunded':

			case 'Denied':

				$status_str = __('Last payment was refunded or denied','mgm');

				$subject = sprintf(__('[%s] Payment Failed','mgm'), $blogname);

				$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />This is a notification to inform you that your post purchase failed for the following reason: %4$s.<br />For more information please contact %5$s.','mgm');

				$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $status_str, $system->setting['admin_email']);				

				// error

				$errors[] = $status_str;	

			break;



			case 'Pending':

				$reason = 'Unknown';

				$status_str = sprintf(__('Last payment is pending. Reason: %s','mgm'), $reason);

				$subject = "[" . $blogname . "] Payment receipt - Status Pending";

				$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />This is a notification to inform you that you payment was received in pending status. Status: %4$s.<br />For more information please contact %5$s','mgm');

				$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $status_str, $system->setting['admin_email']);

				// error

				$errors[] = $status_str;

			break;



			default:

				$status_str = sprintf(__('Last payment status: %s','mgm'),$response_code);

				$subject = "[$blogname] Payment receipt";

				$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />Status: %4$s.<br />For more information please contact %5$s','mgm');

				$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $status_str, $system->setting['admin_email']);

				

				// error

				$errors[] = $status_str;

		}

		

		// gateway emails enabled?

		if (!$dge) {

			mgm_mail($user->user_email, $subject, $message); //send an email to the buyer

		}



		$status = __('Failed join', 'mgm'); //overridden on a successful payment

		if ($tran_success) {

			$table_name = TBL_MGM_POSTS_PURCHASED;

			

			//if we are looking at a pack then explode the buy post item number and loop through it

			if (strpos($post_id, ',') !== false) {

				$posts = explode(',', $post_id);

			} else {

				$posts = array($post_id);

			}

			

			$posts = array_unique($posts);

			

			foreach ($posts as $post_id) {

				$sql = "INSERT INTO " . $table_name . " (user_id, post_id, unixtime)

					VALUES (" . $user_id . ", " . $post_id . ", UNIX_TIMESTAMP())";

				$wpdb->query($sql); //insert the post purchased record

			}



			$status = __('The post was purchased successfully', 'mgm');

		}

		

		// gateway emails enabled?

		if (!$dge) {

			//send admin member an email with details of transaction.

			$subject = "[" . $blogname . "] Admin Notification: " . $user->user_email . " purchased post " . $post_id;

			$message = "User display name: {$user->display_name}<br />User email: {$user->user_email}<br />User ID: {$user->ID}<br />Status: " . $status . "<br />Action: Purchase post:" . $subject . "<br /><br />" . $message . "<br /><br /><pre>" . print_r($_POST, true) . '</pre>';

			mgm_mail($system->setting['admin_email'], $subject, $message);

		}

		

		// error condition redirect

		if(count($errors)>0){

			wp_redirect(add_query_arg(array('status'=>'error', 'errors'=>implode('|', $errors)), $this->setting['processed_url']));

		}

	}

	

	// buy membership

	function _buy_membership() {	

		// system	

		$system             = mgm_get_option('mgm_system');		

		$packs              = mgm_get_option('mgm_subscription_packs');

		$duration_str       = $packs->duration_str;

		//$status_str         = $system->get_statuses();

		$dge                = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;

		// get custom field values

		list($duration, $amount, $currency, $user_id, $membership_type, $duration_type, $role, $client_ip, $hide_old_content, $pack_id) = explode('_', preg_replace('/^subscription_/','', $_POST['x_custom']));

		

		// currency

		if (!$currency) {

			$currency = $system->setting['currency'];

		}

		// find user

		$user    = get_userdata($user_id);

		$mgm_member = mgm_get_member($user_id);



		$join_date = $mgm_member->join_date; // Get the current AC join date



		if (!$join_date) {

			$mgm_member->join_date = time(); // Set current AC join date

		}



		//if there is no duration set in the user object then run the following code

		if (empty($duration_type)) {

			//if there is no duration type then use Months

			$duration_type = 'm';

		}

		// membership type default

		if (empty($membership_type)) {

			//if there is no account type in the custom string then use the existing type

			$membership_type = md5($mgm_member->membership_type);

		}

		// validate parent method

		$membership_type_verified = $this->_validate_membership_type($membership_type, 'md5|plain');

		// verified

		if (!$membership_type_verified) {

			if (strtolower($mgm_member->membership_type) != 'free') {

				$message = 'Could not read membership type in the following POST data. Please debug or contact magic members to fix the problem making sure to pass on the following data. <br /><br /><pre>' . "\n\n" . print_r($_POST, true) . '</pre>';

				mgm_mail($system->setting['admin_mail'], 'Error in Authirize.Net Data', $message);

				return;

			} else {

				$membership_type_verified = $mgm_member->membership_type;

			}

		}

		// set

		$membership_type = $membership_type_verified;

		// duration

		$mgm_member->duration        = $duration;

		$mgm_member->duration_type   = strtolower($duration_type);

		$mgm_member->amount          = $amount;

		$mgm_member->currency        = $currency;

		$mgm_member->membership_type = $membership_type;		

		$mgm_member->pack_id         = $pack_id;

		$mgm_member->payment_type    = 'subscription';//(isset($_POST['x_cust_id']) && intval($_POST['x_cust_id'])>0) ?'subscription' : 'one-time';

		// payment info for unsubscribe		

		$mgm_member->payment_info    = new stdClass;

		$mgm_member->payment_info->module = $this->code;

		/*if(isset($_POST['txn_type'])){

			$mgm_member->payment_info->txn_type = $_POST['txn_type'];

		}*/	

		if(isset($_POST['x_cust_id'])){

			$mgm_member->payment_info->subscr_id = $_POST['x_cust_id'];		

		}	

		if(isset($_POST['x_trans_id'])){	

			$mgm_member->payment_info->txn_id = $_POST['x_trans_id'];	

		}	

		// [txn_type] => subscr_signup

		// [txn_type] => subscr_payment

		// [subscr_id] => I-KV2G0LEU6RCD

		// [txn_id] => 3K2504430T514494Y

		

		// process response

		$new_status = false;

		// errors

		$errors = array();	

		// response code

		$response_code = $this->_get_response_code();

		// process on response code

		switch ($response_code) {

			case 'Approved':

				$new_status = MGM_STATUS_ACTIVE;

				$mgm_member->status_str = __('Last payment was successful','mgm');					

				

				$time = time();				

				$mgm_member->last_pay_date = date('Y-m-d', $time);					

						

				// THIS is causing double calculation

				/* ***********************************/

				if ($mgm_member->expire_date && $mgm_member->last_pay_date!=date('Y-m-d', $time)) {

					$expiry = strtotime($mgm_member->expire_date);

					if ($expiry > 0) {

						if ($expiry > $time) {

							$time = $expiry;

						}

					}

				}

				/*************************************/

				

				// type expanded

				$duration_types = array('d'=>'DAY','m'=>'MONTH','y'=>'YEAR');

				// time

				$time = strtotime("+{$mgm_member->duration} {$duration_types[$mgm_member->duration_type]}", $time);							

				// formatted

				$time_str = date('Y-m-d', $time);				

				// date extended				

				if (!$mgm_member->expire_date || strtotime($time_str) > strtotime($mgm_member->expire_date)) {

					$mgm_member->expire_date = $time_str;										

				}					

					

				// role

				if ($role) {

					$role_obj = new WP_User($user_id);

					$role_obj->set_role($role);

				}			

				

				// after succesful payment hook

				do_action('mgm_membership_transaction_success', array("user_id" =>$user_id));	

							

			break;



			case 'Declined':

			case 'Refunded':

			case 'Denied':

				$new_status = MGM_STATUS_NULL;

				$mgm_member->status_str = __('Last payment was refunded or denied','mgm');

				// error

				$errors[] = $mgm_member->status_str;

			break;

			

			case 'Pending':

			case 'Held for Review':

				$new_status = MGM_STATUS_PENDING;

				$reason = $_POST['x_response_reason_text'];

				$mgm_member->status_str = sprintf(__('Last payment is pending. Reason: %s','mgm'), $reason);				

				// error

				$errors[] = $mgm_member->status_str;

			break;



			default:

				$new_status = MGM_STATUS_ERROR;

				$mgm_member->status_str = sprintf(__('Last payment status: %s','mgm'), $response_code.' - '.$_POST['x_response_reason_text']);

				// error

				$errors[] = $mgm_member->status_str;

			break;

		}

		

		// set status

		$mgm_member->status = $new_status;

		// update member		

		update_user_option($user_id, 'mgm_member', $mgm_member, true);				



		//Do Return Action

		do_action('mgm_return_authorizenet');



		// send email notification to client

		$blogname = get_option('blogname');

		switch ($new_status) {

			case MGM_STATUS_ACTIVE:

				$subject = sprintf(__('[%s] Payment receipt','mgm'),$blogname);



				if ($mgm_member->payment_type == 'subscription') {

					$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your payment was successful for recurring subscription of %4$s %5$s every %6$s %7$s. For more information please contact %8$s','mgm');

				} else {

					$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your payment was successful for a one-time payment of %4$s %5$s for %6$s %7$s. For more information please contact %8$s','mgm');

				}



				$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->amount, $mgm_member->currency, $mgm_member->duration, $duration_str[$mgm_member->duration_type], $system->setting['admin_email']);

				break;



			case MGM_STATUS_NULL:

				$subject = sprintf(__('[%s] Account inactive','mgm'), $blogname);

				$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your account is inactive for the following reason: %4$s. For more information please contact %5$s','mgm');

				$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->status_str, $system->setting['admin_email']);

				break;



			case MGM_STATUS_PENDING:

				$subject = "[$blogname] Payment receipt - Status Pending";

				$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that you payment was received in pending status. Status: %4$s. For more information please contact %5$s','mgm');

				$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->status_str, $system->setting['admin_email']);

				break;



			case MGM_STATUS_ERROR:

				$subject = "[$blogname] Error on payment";

				$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that an error occurred while processing your payment. Details: %4$s. For more information please contact %5$s','mgm');

				$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->status_str, $system->setting['admin_email']);

				break;

		}

		

		// gateway emails enabled?	

		if (!$dge) {

			mgm_mail($user->user_email, $subject, $message);

		}



		// send email notification to system administrator

		if (!$dge) {

			$subject = "[$blogname] {$user->user_email} - {$new_status}";

			$message = "	User display name: {$user->display_name}\n\n<br />

					User email: {$user->user_email}\n\n<br />

					User ID: {$user->ID}\n\n<br />

					Membership Type: {$membership_type}\n\n<br />

					New status: {$new_status}\n\n<br />

					Status message: {$mgm_member->status_str}\n\n<br />

					Subscription period: {$mgm_member->duration} ". $duration_str[$mgm_member->duration_type] ."\n\n<br />

					Subscription amount: {$mgm_member->amount} {$mgm_member->currency}\n<br />

					Payment Mode: {$mgm_member->payment_type}\n\n<br />

					POST Data was: \n\n<br /><br /><pre>" . print_r($_POST, true) . '</pre>';

			mgm_mail($system->setting['admin_email'], $subject, $message);

		}

		

		// error condition redirect

		if(count($errors)>0){			

			wp_redirect(add_query_arg(array('status'=>'error', 'errors'=>implode('|', $errors)), $this->setting['processed_url']));

		}

	}

	

	// get response code

	function _get_response_code(){

		$codes  = array(1 => "Approved",2 => "Declined",3 => "Error",4 => "Held for Review");	

		$status = $codes[intval($_POST['x_response_code'])];

	    return $status;

	}

	

	// default setting

	function _default_setting(){

		// authorize.net specific

		$this->setting['loginid']    = '';

		$this->setting['tran_key']   = '';	

		// purchase price

		if(in_array('buypost', $this->supported_buttons)){

			$this->setting['purchase_price']  = 4.00;		

		}		

		// callback messages				

		$this->_setup_callback_messages();

		// callback urls

		$this->_setup_callback_urls();	

	}

}



// end file