<?php



// payment module

class mgm_epoch extends mgm_payment{

	// construct

	function __construct(){

		// php4 construct

		$this->mgm_epoch();

	}

	

	// construct

	function mgm_epoch(){

		// parent

		parent::__construct();

		// set code

		$this->code = __CLASS__; 

		// set name

		$this->name = 'Epoch';

		// logo

		$this->logo = MGM_PLUGIN_MODULE_URL . 'payment/epoch/assets/epoch.jpg';

		// desc

		$this->description = __('<p>Epoch is a secure online retail outlet for more than 10,000 digital product vendors and 100,000 active affiliate marketers.</p>','mgm');

		// supported buttons types

	 	$this->supported_buttons = array('subscription');

		// trial support available ?

		$this->supports_trial= 'N';	

		// do we depend on product mapping	

		$this->requires_product_mapping = 'Y';

		// endpoints

		$this->_set_endpoint('test',false); // test

		$this->_set_endpoint('live','https://wnu.com/secure/fpost.cgi'); // live

		// default settings

		$this->_default_setting();

		// set path

		parent::set_tmpl_path();	

	}

	

	// settings

	function settings(){

		global $wpdb;

		// data

		$data = array();		

		// set 

		$data['module'] = mgm_get_option($this->code);	

		// load template view

		$this->load_template('settings', array('data'=>$data, 'ajax'=>true));

	}	

	

	// settings_box

	function settings_box(){

		global $wpdb;

		// data

		$data = array();	

		// set 

		$data['module'] = mgm_get_option($this->code);	

		// load template view

		return $this->load_template('settings_box', array('data'=>$data), true);

	}

	

	// update

	function settings_update(){

		// form type 

		switch($_POST['setting_form']){

			case 'box':

			// from box	

				switch($_POST['act']){

					case 'logo_update':

						// logo if uploaded

						if(isset($_POST['logo_new_'.$this->code]) && !empty($_POST['logo_new_'.$this->code])){

							$this->logo = $_POST['logo_new_'.$this->code];

							// update option

							update_option($this->code, $this);

						}

						// message

						$message = $this->name . ' logo updated';			

						$extra   = array();

					break;

					case 'status_update':

					default:

						// enable

						$enable_state = ($_POST['payment']['enable'] == 'Y') ? 'Y' : 'N';

						// enable

						if($enable_state == 'Y'){

							$this->install();

							$stat = ' enabled.';

						}else{

						// disable

							$this->uninstall();	

							$stat = ' disabled.';

						}	

						

						# message

						$message = __($this->name . ' module is '. $stat, 'mgm');							

						$extra   = array('enable' => $enable_state);		

					break;

				}							

				// print message

				echo json_encode(array_merge(array('status'=>'success','message'=>$message,'module'=>array('name'=>$this->name,'code'=>$this->code,'tab'=>$this->settings_tab)), $extra));

			break;

			case 'main':

			default:

			// from main						

				// epoch specific				

				$this->setting['reseller']      = $_POST['setting']['reseller'];

				$this->setting['co_code']       = $_POST['setting']['co_code'];

				$this->setting['send_userpass'] = $_POST['setting']['send_userpass'];				

				// purchase price

				if(isset($_POST['setting']['purchase_price'])){

					$this->setting['purchase_price']  = $_POST['setting']['purchase_price'];

				}

				// setup callback messages				

				$this->_setup_callback_messages($_POST['setting']);

				// re setup callback urls

				$this->_setup_callback_urls($_POST['setting']);

				// common

				$this->description = $_POST['description'];

				$this->status      = $_POST['status'];

				// logo if uploaded

				if(isset($_POST['logo_new_'.$this->code]) && !empty($_POST['logo_new_'.$this->code])){

					$this->logo = $_POST['logo_new_'.$this->code];

				}				

				// update option

				update_option($this->code, $this);

				//  message

				echo json_encode(array('status'=>'success','message'=> $this->name . ' settings updated'));

			break;

		}		

	}

	

	/*// hook for post purchase setting

	function settings_post_purchase($data){

		// overwrite this

		$html=' <li>

					<label>'.__('Epoch Product Code','mgm').' <input type="text" style="width: 50px;" name="mgm_post[product][epoch_product_code]" value="'. $data->product['epoch_product_code'].'" /></label>

				</li>';

		// return

		return $html;		

	}*/

	

	// hook for subscription package setting

	function settings_subscription_package($data){

		// overwrite this

		$html=' <tr>

					<td colspan="3" align="left" height="30" valign="top"><div class="subscription-heading">'.__('Epoch Settings','mgm') .'</div></td>

				</tr>

				<tr>

					<td valign="top" align="left">'. __('Product Code','mgm').'</td>

					<td valign="top" align="center">:</td>

					<td valign="top" align="left">

						<input type="text" name="packs['.($data['pack_ctr']-1).'][product][epoch_product_code]" value="'.esc_html($data['pack']['product']['epoch_product_code']).'" />

					</td>

				</tr>';

		// return

		return $html;

	}	

	

	// return process api hook, link back to site after payment is made

	function process_return(){

		// log

		// mgm_log('process_return: '.print_r($_REQUEST, true));

		// check and show message

		if((isset($_REQUEST['ans']))){

			// process notify, internally called

			$this->process_notify();

			// redirect as success if not already redirected

			// query arg

			$query_arg = array('status'=>'success');

			// is a post redirect?

			$post_redirect =$this->_get_post_redirect($_REQUEST['x_custom']);

			// yes redirect argument passed

			if($post_redirect !== false){

				$query_arg['post_redirect'] = $post_redirect;

			}			

			// redirect

			wp_redirect(add_query_arg($query_arg, $this->setting['processed_url']));

		}else{

			// error

			wp_redirect(add_query_arg(array('status'=>'error'), $this->setting['processed_url']));

		}	

	}

	

	// notify process api hook, background IPN url 

	function process_notify(){

		// used as proxy for this module

		// payment type

		$payment_type = $this->_get_payment_type($_REQUEST['x_custom']);

		// check

		switch($payment_type){

			// buypost 

			case 'buypost':

				$this->_buy_post(); //run the code to process a purchased post/page

			break;

			// subscription	

			case 'subscription':

				$this->_buy_membership(); //run the code to process a new/extended membership

			break;	

			// other		

			default:				

				// error

				$error = 'error in payment type : '.$payment_type;

				// bad payment type

				// mgm_log($error);

				// redirect to error

				wp_redirect(add_query_arg(array('status'=>'error','errors'=>$error), $this->setting['processed_url']));				

			break;							

		}

	}

	

	// process cancel api hook 

	function process_cancel(){

		// not used for this module

		// redirect to cancel page

		wp_redirect(add_query_arg(array('status'=>'cancel'), $this->setting['processed_url']));

	}

	

	// subscribe button api hook

	function get_button_subscribe($options=array()){	

		// Epoch depends on product code, check for it before generating button

		if(!isset($options['pack']['product']['epoch_product_code']) || empty($options['pack']['product']['epoch_product_code'])){

			return '<div style="color:red; font-style:oblique; text-align:center; height:100px; padding:15px; vertical-align:middle"><b>Error in Epoch : No Product Code set.</b></div>';

			exit;

		}	

		

		// mgm_array_dump($options);

		$button_code     = $this->_get_button_code($options['pack']);

		$additional_code = do_action('mgm_additional_code');

		$html='<form action="'. $this->_get_endpoint() .'" method="post" class="mgm" name="' . $this->code . '_form" id="' . $this->code . '_form">

					'. $button_code .'				

					'. $additional_code .'	

					<input type="image" src="' . mgm_fix_url($this->logo) . '" border="0" name="submit" alt="' . $this->name . '">

					<div class="mgm_paymod_description">'. $this->description .'</div>			

			   </form>';

		return $html;		

	}

	

	// buypost button api hook

	function get_button_buypost($options=array(), $return = false) {

		// this is not supported, just blank implementation

	}

	

	/////////////////////////////////////////////// internal/private methods /////////////////////////////////////////////////

	

	// get button code	

	function _get_button_code($pack) {

		$data   = $this->_get_button_data($pack);

		$return = '';	

		foreach ($data as $key => $value) {

			$return .= '	<input type="hidden" name="'. $key .'" value="'. $value .'" />' . "\n";

		}	

		return $return;

	}



	// get button data

	function _get_button_data($pack) {

		// system

		$system      = mgm_get_option('mgm_system');		

		$membership_type = md5($pack['membership_type']);

		// get user

		$user_id         = mgm_get_user_id();

		$user            = get_userdata($user_id);

		$mgm_member      = mgm_get_member($user_id);

		// set data

		$data = array(			

			'co_code' => $this->setting['co_code'],

			'pi_code' => (isset($pack['product']['epoch_product_code']) ? $pack['product']['epoch_product_code'] : ''),

			'reseller' => $this->setting['reseller'], 

			'response_post' => 'Y',

			'pi_returnurl' => $this->setting['return_url'],

			'email' => $user->user_email

		);



		// username/password	

		if($this->setting['send_userpass']=='yes'){

			$data['name']     = (isset($user->first_name)?$user->first_name:$user->display_name);					

			$data['username'] = $user->user_login;			

			$data['password'] = $mgm_member->user_password; 	

		}else{

			$data['no_userpass']       = 1;

			$data['no_userpassverify'] = 1;

		}

		// custom

		$data['x_custom'] = $this->_set_payment_type($pack, $currency); // passthrough field prefixed with x_

		// return data

		return $data;

	}	

	

	// verify callback 

	function _verify_callback(){	

		// not used

	}	

	

	// buy post

	function _buy_post() {

		global $wpdb;



		$system = mgm_get_option('mgm_system');

		$dge = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;

		

		list($duration, $cost, $currency, $user_id, $post_id, $user_id, $client_ip) = explode('_', preg_replace('/^buypost_/','', $_REQUEST['x_custom']));



		// find user

		$user     = get_userdata($user_id);

		$blogname = get_option('blogname');

		$tran_success = false;

		

		// errors

		$errors = array();

		

		// response code

		$response = $this->_parse_response();

		// process on response code	

		switch ($response['code']) {

			case 'Approved':

				$tran_success = true;

				$status_str = __('Last payment was successful','mgm');

				//$subject = sprintf(__('[%s] Payment receipt','mgm'),$blogname);

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />This is a notification to inform you that your payment was successful and the post you purchased is now available to view.<br />For more information please contact %4$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $system->setting['admin_email']);

				 //issue#: 280 (2011 Feb 25)

				// subject

				$subject = $system->get_template('payment_success_email_template_subject', array('blogname'=>$blogname), true);

				// body

				$message = $system->get_template('payment_success_email_template_body', 

										array('blogname'=>$blogname, 'name'=>$user->display_name, 

											  'email'=>$user->user_email, 

											  'admin_email'=>$system->setting['admin_email']), true);

				// after succesful payment hook

				do_action('mgm_buy_post_transaction_success', array("post_id" =>$post_id));

				break;



			case 'DECLINED':

			case 'MYVSNOTACCEPTED':

			case 'DECLINEDCVV2':

			case 'CALLCENTER':

			case 'EXPIRED':

				$status_str = __('Last payment was refunded or denied','mgm');

				//$subject = sprintf(__('[%s] Payment Failed','mgm'), $blogname);

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />This is a notification to inform you that your post purchase failed for the following reason: %4$s.<br />For more information please contact %5$s.','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $status_str, $system->setting['admin_email']);

				 //issue#: 280 (2011 Feb 25)

				// subject

				$subject = $system->get_template('payment_failed_email_template_subject', array('blogname'=>$blogname), true);

				 

				// body			

				$message = $system->get_template('payment_failed_email_template_body', 

										array('blogname'=>$blogname, 'name'=>$user->display_name, 

											  'email'=>$user->user_email, 'payment_type'=>'post purchase payment','reason'=>$status_str,

											  'admin_email'=>$system->setting['admin_email']), true);

				// error

				$errors[] = $status_str;

			break;



			case 'Pending':

				$reason = 'Unknown';

				$status_str = sprintf(__('Last payment is pending. Reason: %s','mgm'), $reason);

				//$subject = "[" . $blogname . "] Payment receipt - Status Pending";

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />This is a notification to inform you that you payment was received in pending status. Status: %4$s.<br />For more information please contact %5$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $status_str, $system->setting['admin_email']);

				 //issue#: 280 (2011 Feb 25)

				// subject

				$subject = $system->get_template('payment_pending_email_template_subject', array('blogname'=>$blogname), true);

				// body	

				$message = $system->get_template('payment_pending_email_template_body', 

										array('blogname'=>$blogname, 'name'=>$user->display_name, 

											  'email'=>$user->user_email, 'reason'=>$status_str,

											  'admin_email'=>$system->setting['admin_email']), true);

				// error

				$errors[] = $status_str;

			break;



			default:

				$status_str = sprintf(__('Last payment status: %s','mgm'),$response['code']);

				//$subject = "[$blogname] Payment receipt";

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />Status: %4$s.<br />For more information please contact %5$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $status_str, $system->setting['admin_email']);

				 //issue#: 280 (2011 Feb 25)

				// subject

				$subject = $system->get_template('payment_unknown_email_template_subject', array('blogname'=>$blogname), true);				

				// body	

				$message = $system->get_template('payment_unknown_email_template_body', array('blogname'=>$blogname, 'name'=>$user->display_name, 

				                                                                              'email'=>$user->user_email, 'reason'=>$status_str,

																							  'admin_email'=>$system->setting['admin_email']), true);

		}



		// notify user

		mgm_mail($user->user_email, $subject, $message); //send an email to the buyer		



		$status = __('Failed join', 'mgm'); //overridden on a successful payment

		if ($tran_success) {

			$table_name = TBL_MGM_POSTS_PURCHASED;

			

			//if we are looking at a pack then explode the buy post item number and loop through it

			if (strpos($post_id, ',') !== false) {

				$posts = explode(',', $post_id);

			} else {

				$posts = array($post_id);

			}

			

			$posts = array_unique($posts);

			

			foreach ($posts as $post_id) {

				$sql = "INSERT INTO " . $table_name . " (user_id, post_id, unixtime)

					VALUES (" . $user_id . ", " . $post_id . ", UNIX_TIMESTAMP())";

				$wpdb->query($sql); //insert the post purchased record

			}



			$status = __('The post was purchased successfully', 'mgm');

		}



		// notify admin, only if gateway emails on

		if (!$dge) {

			$subject = "[" . $blogname . "] Admin Notification: " . $user->user_email . " purchased post " . $post_id;

			$message = "User display name: {$user->display_name}<br />User email: {$user->user_email}<br />User ID: {$user->ID}<br />Status: " . $status . "<br />Action: Purchase post:" . $subject . "<br /><br />" . $message . "<br /><br /><pre>" . print_r($_POST, true) . '</pre>';

			mgm_mail($system->setting['admin_email'], $subject, $message);

		}

		

		// error condition redirect

		if(count($errors)>0){

			wp_redirect(add_query_arg(array('status'=>'error', 'errors'=>implode('|', $errors)), $this->setting['processed_url']));

		}

	}

	

	// buy membership

	function _buy_membership() {	

		// system	

		$system             = mgm_get_option('mgm_system');		

		$packs              = mgm_get_option('mgm_subscription_packs');

		$duration_str       = $packs->duration_str;

		//$status_str         = $system->get_statuses();

		$dge                = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;

		// get custom field values

		list($duration, $amount, $currency, $user_id, $membership_type, $duration_type, $role, $client_ip, $hide_old_content, $pack_id) = explode('_', preg_replace('/^subscription_/','', $_REQUEST['x_custom']));

		// currency

		if (!$currency) {

			$currency = $system->setting['currency'];

		}

		// find user

		$user    = get_userdata($user_id);

		$mgm_member = mgm_get_member($user_id);

		

		// mgm_log('user/member : '.print_r($user,true).print_r($mgm_member,true));

		

		$join_date = $mgm_member->join_date; // Get the current AC join date



		if (!$join_date) {

			$mgm_member->join_date = time(); // Set current AC join date

		}



		//if there is no duration set in the user object then run the following code

		if (empty($duration_type)) {

			//if there is no duration type then use Months

			$duration_type = 'm';

		}

		// membership type default

		if (empty($membership_type)) {

			//if there is no account type in the custom string then use the existing type

			$membership_type = md5($mgm_member->membership_type);

		}

		// validate parent method

		$membership_type_verified = $this->_validate_membership_type($membership_type, 'md5|plain');

		// verified

		if (!$membership_type_verified) {

			if (strtolower($mgm_member->membership_type) != 'free') {

				// notify admin, only if gateway emails on

				if(!$dge){

					$message = 'Could not read membership type in the following POST data. Please debug or contact magic members to fix the problem making sure to pass on the following data. <br /><br /><pre>' . "\n\n" . print_r($_POST, true) . '</pre>';

					mgm_mail($system->setting['admin_mail'], 'Error in Epoch membership verification', $message);

				}

				// abort

				return;

			} else {

				$membership_type_verified = $mgm_member->membership_type;

			}

		}

		// set

		$membership_type = $membership_type_verified;

		// duration

		$mgm_member->duration        = $duration;

		$mgm_member->duration_type   = strtolower($duration_type);

		$mgm_member->amount          = $amount;

		$mgm_member->currency        = $currency;

		$mgm_member->membership_type = $membership_type;	

		$mgm_member->pack_id         = $pack_id;			

		$mgm_member->payment_type    = 'subscription';//($_POST['txn_type']=='subscr_signup' || $_POST['txn_type'] =='subscr_payment') ?'subscription' : 'one-time';

		// payment info for unsubscribe		

		$mgm_member->payment_info    = new stdClass;

		$mgm_member->payment_info->module = $this->code;

		//if(isset($_POST['txn_type'])){

			$mgm_member->payment_info->txn_type = 'subscription';//$_POST['txn_type'];

		//}	

		if(isset($_REQUEST['order_id'])){

			$mgm_member->payment_info->subscr_id = $_REQUEST['order_id'];		

		}	

		if(isset($_REQUEST['transaction_id'])){	

			$mgm_member->payment_info->txn_id = $_REQUEST['transaction_id'];	

		}	

		// [txn_type] => subscr_signup

		// [txn_type] => subscr_payment

		// [subscr_id] => I-KV2G0LEU6RCD

		// [txn_id] => 3K2504430T514494Y

		

		// process response

		$new_status = false;		

		// errors

		$errors = array();			

		// response code

		$response = $this->_parse_response();

		// process on response code	

		switch ($response['code']) {

			case 'Approved':

				$new_status = MGM_STATUS_ACTIVE;

				$mgm_member->status_str = __('Last payment was successful','mgm');				

				

				$time = time();				

				$mgm_member->last_pay_date = date('Y-m-d', $time);

				

				// THIS is causng double calculation

				/* ***********************************/

				if ($mgm_member->expire_date && $mgm_member->last_pay_date!=date('Y-m-d', $time)) {

					$expiry = strtotime($mgm_member->expire_date);

					if ($expiry > 0) {

						if ($expiry > $time) {

							$time = $expiry;

						}

					}

				}

				/*************************************/

				

				// type expanded

				$duration_types = array('d'=>'DAY','m'=>'MONTH','y'=>'YEAR');

				// time

				$time = strtotime("+{$mgm_member->duration} {$duration_types[$mgm_member->duration_type]}", $time);							

				// formatted

				$time_str = date('Y-m-d', $time);				

				// date extended				

				if (!$mgm_member->expire_date || strtotime($time_str) > strtotime($mgm_member->expire_date)) {

					$mgm_member->expire_date = $time_str;										

				}	

				

				// role

				if ($role) {

					$role_obj = new WP_User($user_id);

					$role_obj->set_role($role);

				}			

				

				// after succesful payment hook

				do_action('mgm_membership_transaction_success', array("user_id" =>$user_id));			

			break;



			case 'DECLINED':

			case 'MYVSNOTACCEPTED':

			case 'DECLINEDCVV2':

			case 'CALLCENTER':

			case 'EXPIRED':

				$new_status = MGM_STATUS_NULL;

				$mgm_member->status_str = __('Last payment was refunded or denied','mgm');

				// error

				$errors[] = $mgm_member->status_str;

			break;



			case 'Pending':// not avaiilable

				$new_status = MGM_STATUS_PENDING;



				$reason = 'Unnown';

				$mgm_member->status_str = sprintf(__('Last payment is pending. Reason: %s','mgm'), $reason);

				// error

				$errors[] = $mgm_member->status_str;

			break;



			default:

				$new_status = MGM_STATUS_ERROR;

				$mgm_member->status_str = sprintf(__('Last payment status: %s','mgm'), $response['code']);

				// error

				$errors[] = $mgm_member->status_str;

			break;

		}	

		

		// set status

		$mgm_member->status = $new_status;

		// update member

		update_user_option($user_id, 'mgm_member', $mgm_member, true);		



		//Do Return Action

		do_action('mgm_return_epoch');



		// send email notification to client

		$blogname = get_option('blogname');		

		switch ($new_status) {

			case MGM_STATUS_ACTIVE:

				//$subject = sprintf(__('[%s] Payment receipt','mgm'),$blogname);

				//issue#: 280 (2011 Feb 25)

				// subject

				$subject = $system->get_template('payment_success_email_template_subject', array('blogname'=>$blogname), true);

				if ($mgm_member->payment_type == 'subscription') {

					//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your payment was successful for recurring subscription of %4$s %5$s every %6$s %7$s. For more information please contact %8$s','mgm');

					$payment_type = 'recurring subscription';

					$subscription = sprintf('%1$s %2$s every %3$s %4$s',$mgm_member->amount, $mgm_member->currency, $mgm_member->duration, 

					                                                    $duration_str[$mgm_member->duration_type]);

				} else {

					//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your payment was successful for a one-time payment of %4$s %5$s for %6$s %7$s. For more information please contact %8$s','mgm');

					$payment_type = 'one-time payment';

					$subscription = sprintf('%1$s %2$s for %3$s %4$s',$mgm_member->amount, $mgm_member->currency, $mgm_member->duration, 

					                                                  $duration_str[$mgm_member->duration_type]);

				}



				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->amount, $mgm_member->currency, $mgm_member->duration, $duration_str[$mgm_member->duration_type], $system->setting['admin_email']);

				// body

				$message = $system->get_template('payment_success_subscription_email_template_body', 

													array('blogname'=>$blogname, 'name'=>$user->display_name, 

														  'email'=>$user->user_email, 'payment_type'=>$payment_type,

														  'subscription'=>$subscription,'admin_email'=>$system->setting['admin_email']), true);

				break;



			case MGM_STATUS_NULL:

				//issue#: 280 (2011 Feb 25)

				//$subject = sprintf(__('[%s] Account inactive','mgm'), $blogname);

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your account is inactive for the following reason: %4$s. For more information please contact %5$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->status_str, $system->setting['admin_email']);

				// subject

				$subject = $system->get_template('payment_failed_email_template_subject', array('blogname'=>$blogname), true);				

				// message

				$message = $system->get_template('payment_failed_email_template_body', 

									array('blogname'=>$blogname, 'name'=>$user->display_name, 

										  'email'=>$user->user_email, 'payment_type'=>'subscription payment',

										  'reason'=>$mgm_member->status_str,

										  'admin_email'=>$system->setting['admin_email']), true);

				

				

			break;



			case MGM_STATUS_PENDING:

				//issue#: 280 (2011 Feb 25)

				//$subject = "[$blogname] Payment receipt - Status Pending";

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that you payment was received in pending status. Status: %4$s. For more information please contact %5$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->status_str, $system->setting['admin_email']);

				// subject

				$subject = $system->get_template('payment_pending_email_template_subject', array('blogname'=>$blogname), true);

				// body

				$message = $system->get_template('payment_pending_email_template_body', 

										array('blogname'=>$blogname, 'name'=>$user->display_name, 

											  'email'=>$user->user_email, 'reason'=>$mgm_member->status_str,

											  'admin_email'=>$system->setting['admin_email']), true);

				break;



			case MGM_STATUS_ERROR:

				//issue#: 280 (2011 Feb 25)

				//$subject = "[$blogname] Error on payment";

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that an error occurred while processing your payment. Details: %4$s. For more information please contact %5$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->status_str, $system->setting['admin_email']);

				// subject

				$subject = $system->get_template('payment_error_email_template_subject', array('blogname'=>$blogname), true);				

				// body	

				$message = $system->get_template('payment_error_email_template_body', 

									array('blogname'=>$blogname, 'name'=>$user->display_name, 

										  'email'=>$user->user_email, 'reason'=>$mgm_member->status_str,

										  'admin_email'=>$system->setting['admin_email']), true);

				break;

		}



		// notify user

		mgm_mail($user->user_email, $subject, $message);		



		// notify admin, only if gateway emails on

		if (!$dge) {

			$subject = "[$blogname] {$user->user_email} - {$new_status}";

			$message = "	User display name: {$user->display_name}\n\n<br />

					User email: {$user->user_email}\n\n<br />

					User ID: {$user->ID}\n\n<br />

					Membership Type: {$membership_type}\n\n<br />

					New status: {$new_status}\n\n<br />

					Status message: {$mgm_member->status_str}\n\n<br />

					Subscription period: {$mgm_member->duration} ". $duration_str[$mgm_member->duration_type] ."\n\n<br />

					Subscription amount: {$mgm_member->amount} {$mgm_member->currency}\n<br />

					Payment Mode: {$mgm_member->payment_type}\n\n<br />

					POST Data was: \n\n<br /><br /><pre>" . print_r($_REQUEST, true) . '</pre>';

			mgm_mail($system->setting['admin_email'], $subject, $message);

		}

		

		// error condition redirect

		if(count($errors)>0){

			wp_redirect(add_query_arg(array('status'=>'error', 'errors'=>implode('|', $errors)), $this->setting['processed_url']));

		}

	}

	

	// parse response

	function _parse_response(){

		// init

		$response = array('status'=>'N','code'=>'Unknown');		

		// bank respone

		$ans_codes          = explode('|', $_REQUEST['ans']);// ans=YGOODTEST|1418464163		

		$response['status'] = substr($ans_codes[0], 0, 1); 

		// check

		if($response['status'] == 'Y'){ // success

			$response['code'] = 'Approved';

		}else{// N failure			

			$response['code'] = substr($ans_codes[0], 1); // after first char(Y/N), decline code form epoch

		}					

		// set test status

		if($this->status == 'test'){

			$response['status']  = 'Y';

			$response['code']    = 'Approved';

		}

		// return 

		return $response;

	}



	// default setting

	function _default_setting(){

		// epoch specific	

		$this->setting['reseller']      = 'a';

		$this->setting['co_code']       = '';

		$this->setting['send_userpass'] = 'no';

		// purchase price

		if(in_array('buypost', $this->supported_buttons)){

			$this->setting['purchase_price']  = 4.00;		

		}		

		// callback messages				

		$this->_setup_callback_messages();

		// callback urls

		$this->_setup_callback_urls();	

	}

}



// end file