<?php

// payment module

class mgm_free extends mgm_payment{

	// construct

	function __construct(){

		// php4 construct

		$this->mgm_free();

	}

	

	// construct

	function mgm_free(){

		// parent

		parent::__construct();

		// set code

		$this->code = __CLASS__; 

		// set name

		$this->name = 'Free';

		// logo

		$this->logo = MGM_PLUGIN_MODULE_URL . 'payment/free/assets/free.gif';

		// no option tab

		// $this->settings_tab = false;

		// description

		$this->description = __('Allow users to signup for a free account, this Payment Gateway must be enabled for Pay Per Post to work along with Paypal Gateway.', 'mgm');

		// supported buttons types

	 	$this->supported_buttons = array('subscription');

		// default settings

		$this->_default_setting();

		// set path

		parent::set_tmpl_path();

	}

	

	// settings

	function settings(){

		global $wpdb;

		// data

		$data = array();		

		// set 

		$data['module'] = mgm_get_option($this->code);	

		// load template view

		$this->load_template('settings', array('data'=>$data, 'ajax'=>true));

	}	

	

	// settings_box

	function settings_box(){

		global $wpdb;

		// data

		$data = array();	

		// set 

		$data['module'] = mgm_get_option($this->code);				

		// load template view

		return $this->load_template('settings_box', array('data'=>$data), true);

	}

	

	// update

	function settings_update(){

		// form type 

		switch($_POST['setting_form']){

			case 'box':

			// from box							

				switch($_POST['act']){

					case 'logo_update':

						// logo if uploaded

						if(isset($_POST['logo_new_'.$this->code]) && !empty($_POST['logo_new_'.$this->code])){

							$this->logo = $_POST['logo_new_'.$this->code];

							// update option

							update_option($this->code, $this);

						}

						// message

						$message = $this->name . ' logo updated';			

						$extra   = array();

					break;

					case 'status_update':

					default:

						// enable

						$enable_state = ($_POST['payment']['enable'] == 'Y') ? 'Y' : 'N';

						// enable

						if($enable_state == 'Y'){

							$this->install();

							$stat = ' enabled.';

						}else{

						// disable

							$this->uninstall();	

							$stat = ' disabled.';

						}	

						

						# message

						$message = __($this->name . ' module is '. $stat, 'mgm');							

						$extra   = array('enable' => $enable_state);	

					break;

				}							

				// print message

				echo json_encode(array_merge(array('status'=>'success','message'=>$message,'module'=>array('name'=>$this->name,'code'=>$this->code,'tab'=>$this->settings_tab)), $extra));

			break;

			case 'main':

			default:

			// from main						

				// setup callback messages				

				$this->_setup_callback_messages($_POST['setting']);

				// re setup callback urls

				$this->_setup_callback_urls($_POST['setting']);

				// common

				$this->description = $_POST['description'];

				// $this->status      = $_POST['status'];

				// logo if uploaded

				if(isset($_POST['logo_new_'.$this->code]) && !empty($_POST['logo_new_'.$this->code])){

					$this->logo = $_POST['logo_new_'.$this->code];

				}				

				// update option

				update_option($this->code, $this);

				//  message

				echo json_encode(array('status'=>'success','message'=> $this->name . ' settings updated'));

			break;

		}		

	}

	

	// return process api hook

	function process_return() {	

		// log

		// mgm_log('process_return free REQUEST : '.print_r($_REQUEST,true));

		// only save once success, there may be multiple try

		if(isset($_REQUEST['custom']) && !empty($_REQUEST['custom'])){

			// process 

			$this->process_notify();

			// query arg

			$query_arg = array('status'=>'success');

			// is a post redirect?

			$post_redirect =$this->_get_post_redirect($_REQUEST['custom']);

			// yes redirect argument passed

			if($post_redirect !==false){

				$query_arg['post_redirect'] = $post_redirect;

			}			

			// redirect

			wp_redirect(add_query_arg($query_arg, $this->setting['processed_url']));			

		}else{

			// teat as error			

			$errors = 'error in processing your request'; 	

			// redirect			

			wp_redirect(add_query_arg(array('status'=>'error','errors'=>$errors), $this->setting['processed_url']));

		}		

	}

	

	// notify process api hook, background IPN

	function process_notify() {

		// check			

		if (isset($_REQUEST['custom'])){

			// payment type

			$payment_type = $this->_get_payment_type($_REQUEST['custom']);

			// check

			switch($payment_type){				

				// subscription	

				case 'subscription':

				default:					

					$this->_buy_membership(); //run the code to process a new/extended membership						

				break;												

			}			

		}

	}

	

	// process cancel api hook: 

	function process_cancel(){		

		// redirect to cancel page	

		wp_redirect(add_query_arg(array('status'=>'cancel'), $this->setting['processed_url']));	

	}

	

	// buy membership

	function _buy_membership() {		

		list($user_id, $duration, $duration_type, $membership_type) = explode('_', $_REQUEST['custom']);

		if ($user = get_userdata($user_id)) {

			$mgm_member = mgm_get_member($user_id);

			if (!$mgm_member->duration) {

				$mgm_member->duration      = (($duration) ? $duration : 1); // one year

				$mgm_member->duration_type = (($duration_type) ? $duration_type : 'y');

				$mgm_member->amount        = 0.00;

				$mgm_member->currency      = 'USD';

				$mgm_member->membership_type = $membership_type;

			}

			

			// set status

			$mgm_member->status     = MGM_STATUS_ACTIVE;

			$mgm_member->account_desc = __('Free Account','mgm');				

			$mgm_member->last_pay_date = '';

			

			// join date

			$time = time();					

			// type expanded

			$duration_types = array('d'=>'DAY','m'=>'MONTH','y'=>'YEAR');

			// time

			$time = strtotime("+{$mgm_member->duration} {$duration_types[$mgm_member->duration_type]}", $time);							

			// formatted

			$time_str = date('Y-m-d', $time);				

			// date extended				

			if (!$mgm_member->expire_date || strtotime($time_str) > strtotime($mgm_member->expire_date)) {

				$mgm_member->expire_date = $time_str;										

			}		

			

			// update

			update_user_option($user_id, 'mgm_member', $mgm_member, true);

			

			// additional requests

			do_action('mgm_return_free');

		}		

		

	}

	

	// default setting

	function _default_setting(){				

		// callback messages				

		$this->_setup_callback_messages();

		// callback urls

		$this->_setup_callback_urls();	

	}

}



// end file