<?php

// payment module

class mgm_paypal extends mgm_payment{

	

	// construct

	function __construct(){

		// php4 construct

		$this->mgm_paypal();

	}

	

	// php4 construct

	function mgm_paypal(){

		// parent

		parent::__construct();

		// set code

		$this->code = __CLASS__; 

		// set name

		$this->name = 'Paypal Standard';	

		// logo

		$this->logo = MGM_PLUGIN_MODULE_URL . 'payment/paypal/assets/paypal.jpg';

		// description

		$this->description = __('PayPal is an e-money service allowing payments and money transfers to be made through the Internet. 

		                         PayPal operates with credit cards, debit cards, bank accounts and PayPal balance to make safe purchases online, 

								 without disclosing your credit card number or financial information.', 'mgm');

		// supported buttons types

	 	$this->supported_buttons = array('subscription', 'buypost');

		// trial support available ?

		$this->supports_trial= 'Y';		

		// cancellation support available ?

		$this->supports_cancellation= 'Y';		

		// do we depend on product mapping	

		$this->requires_product_mapping = 'N';

		// endpoints

		$this->_set_endpoint('test','https://www.sandbox.paypal.com/cgi-bin/webscr'); // test

		$this->_set_endpoint('live','https://www.paypal.com/cgi-bin/webscr'); // live

		// default settings

		$this->_default_setting();

		// message

		$this->paypal_msg = 'Make payments with PayPal - it\'s fast, free and secure!';

		// set path

		parent::set_tmpl_path();	

	}

	

	// settings

	function settings(){

		global $wpdb;

		// data

		$data = array();		

		// set 

		$data['module'] = mgm_get_option($this->code);

		// load template view

		$this->load_template('settings', array('data'=>$data, 'ajax'=>true));

	}	

	

	// settings box api hook

	function settings_box(){

		global $wpdb;

		// data

		$data = array();	

		// set 

		$data['module'] = mgm_get_option($this->code);	

		// load template view

		return $this->load_template('settings_box', array('data'=>$data), true);		

	}

	

	// settings update

	function settings_update(){

		// form type 

		switch($_POST['setting_form']){

			case 'box':

			// from box			

				switch($_POST['act']){

					case 'logo_update':

						// logo if uploaded

						if(isset($_POST['logo_new_'.$this->code]) && !empty($_POST['logo_new_'.$this->code])){

							$this->logo = $_POST['logo_new_'.$this->code];

							// update option

							update_option($this->code, $this);

						}

						// message

						$message = $this->name . ' logo updated';			

						$extra   = array();

					break;

					case 'status_update':

					default:

						// enable

						$enable_state = ($_POST['payment']['enable'] == 'Y') ? 'Y' : 'N';

						// enable

						if($enable_state == 'Y'){

							$this->install();

							$stat = ' enabled.';

						}else{

						// disable

							$this->uninstall();	

							$stat = ' disabled.';

						}	

						

						# message

						$message = __($this->name . ' module is '. $stat, 'mgm');							

						$extra   = array('enable' => $enable_state);		

					break;

				}							

				// print message

				echo json_encode(array_merge(array('status'=>'success','message'=>$message,'module'=>array('name'=>$this->name,'code'=>$this->code,'tab'=>$this->settings_tab)), $extra));

			break;

			case 'main':

			default:

			// from main				

				// paypal specific

				$this->setting['business_email']  = $_POST['setting']['business_email'];

				$this->setting['currency']        = $_POST['setting']['currency'];								

				$this->setting['locale']          = $_POST['setting']['locale'];

				// purchase price

				if(isset($_POST['setting']['purchase_price'])){

					$this->setting['purchase_price']  = $_POST['setting']['purchase_price'];

				}

				// setup callback messages				

				$this->_setup_callback_messages($_POST['setting']);

				// re setup callback urls

				$this->_setup_callback_urls($_POST['setting']);

				// common

				$this->description = $_POST['description'];

				$this->status      = $_POST['status'];

				// logo if uploaded

				if(isset($_POST['logo_new_'.$this->code]) && !empty($_POST['logo_new_'.$this->code])){

					$this->logo = $_POST['logo_new_'.$this->code];

				}				

				// update option

				update_option($this->code, $this);

				//  message

				echo json_encode(array('status'=>'success','message'=> $this->name . ' settings updated'));

			break;

		}		

	}

	

	// return process api hook, link back to site after payment is made

	function process_return() {

		// NOTE: as of ISSUE ID 152, no post data is sent back to server even if rm =2 is set

		// this works ok on paypal sandbox but not on live, treat success always for now

		// check and show message

		// if((isset($_POST['custom']) && !empty($_POST['custom'])) || (isset($_POST['auth']) && !empty($_POST['auth']))){

		if( isset($_REQUEST['custom']) && !empty($_REQUEST['custom']) ){

			// query arg

			$query_arg = array('status'=>'success');

			// is a post redirect?			

			$post_redirect = $this->_get_post_redirect($_REQUEST['custom']);

			// yes redirect argument passed

			if($post_redirect !== false){

				$query_arg['post_redirect'] = $post_redirect;

			}						

			// redirect

			wp_redirect(add_query_arg($query_arg, $this->setting['processed_url']));

		}else{			

			wp_redirect(add_query_arg(array('status'=>'error'), $this->setting['processed_url']));

		}

	}	

	

	// notify process api hook, background IPN url

	function process_notify() {		

		// log

		// mgm_log('process_notify:'.print_r($_POST, true));

		// verify needed post data		

		if (isset($_POST['test_ipn']) || isset($_POST['payment_status']) || isset($_POST['custom'])) {	// reversed for #298 logic gate failure					

			// ipn

			$this->_verify_callback(); // 	

			// log 

			// mgm_log('verified:');	

				

			// for test mode which automatically marks all ipns as paid

			if (isset($_POST['test_ipn'])) {

				$_POST['payment_status'] = 'Processed';

			}			

			

			// exit

			$exit_statuses = array('In-Progress', 'Partially-Refunded');



			// handle cases that the system must ignore

			if (isset($_POST['payment_status']) && in_array($_POST['payment_status'], $exit_statuses)) {

				exit;

			}		

				

			// payment type

			$payment_type = $this->_get_payment_type($_POST['custom']);		

			

			// log 

			// mgm_log('payment_type: '.$payment_type);

			

			// check

			switch($payment_type){

				// buypost 

				case 'buypost':

					$this->_buy_post(); //run the code to process a purchased post/page

				break;

				// subscription	

				case 'subscription':

					// cancellation

					if(isset($_POST['txn_type']) && $_POST['txn_type']=='subscr_cancel') {						

						$this->_cancel_membership(); //run the code to process a membership cancellation

					}elseif(isset($_POST['txn_type']) /*&& $_POST['txn_type']=='subscr_payment'*/){ // subscr_payment is not sent when trial is set as 0, #287

					// subscription 						

						$this->_buy_membership(); //run the code to process a new/extended membership						

					}	

				break;	

				// other		

				default:

					// error				

				break;							

			}	

		// otherwise			

		}else{

			// error

			$error=  'Error in IPN. Missing payment_status or custom.';

			// log

			// mgm_log('Error : '.$error);

			exit;

		} 

	}	

	

	// process cancel api hook 

	function process_cancel(){

		// redirect to cancel page

		wp_redirect(add_query_arg(array('status'=>'cancel'), $this->setting['processed_url']));

	}	

	

	// unsubscribe process, IPN for unsubscribe 

	function process_unsubscribe(){

		// overwrite this

		// Not implemented for PayPal

	}

		

	// subscribe button api hook

	function get_button_subscribe($options=array()){		

		$button_code     = $this->_get_button_code($options['pack']);

		$additional_code = do_action('mgm_additional_code');

		$html='<form action="'. $this->_get_endpoint() .'" method="post" class="mgm" name="' . $this->code . '_form" id="' . $this->code . '_form">

					'. $button_code .'

					<img alt="" border="0" src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1">

					'. $additional_code .'

					<input type="image" src="' . mgm_fix_url($this->logo) . '" border="0" name="submit" alt="' . $this->paypal_msg . '">

					<div class="mgm_paymod_description">'. $this->description .'</div>

				</form>';

		return $html;		

	}

	

	// buypost button api hook

	function get_button_buypost($options=array(), $return = false) {

		global $user;

		// title

		$item_name = (isset($options['pack']['ppp_pack_id'])) ? ('Purchase Post Pack - '.$options['pack']['title']) : ('Purchase Post - '.$options['pack']['title']) ;

		// merge pack

		$options['pack'] = array_merge($options['pack'], array('duration'=>1, 'item_name'=>$item_name, 'buypost'=>1));

		// button code		

		$button_code     = $this->_get_button_code($options['pack']);

		$additional_code = do_action('mgm_additional_code');

		// html

		$html = '<table width="100%" border="0" cellpadding="0" cellspacing="0" align="center" class="form-table">

					<form action="'. $this->_get_endpoint() .'" method="post" class="mgm" name="' . $this->code . '_form" id="' . $this->code . '_form">

						 <tr>

							 <td align="center">

								 '. $button_code .'

								 <img alt="" border="0" src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1">

								 '. $additional_code .'

								 <input type="image" src="' . mgm_fix_url($this->logo) . '" name="submit" alt="' . $this->paypal_msg . '">

								 <div class="mgm_paymod_description">'. $this->description .'</div>

							 </td>

						 </tr>

					 </form>

				</table>';



		if ($return) {

			return $html;

		} else {

			echo $html;

		}

	}

	

	// dependency_check	

	function dependency_check(){

		/*************************************************

		$this->dependency = array();

		if(!extension_loaded('curl') && !extension_loaded('curl')){

			$this->dependency[] = '<b style="color:#FF1F3D">CURL PHP extension must be loaded for PAYPAL.</b>';

		}

		// error		

		return (count($this->dependency)>0) ? true : false ;

		****************************************************/

	}	

	

	/////////////////////////////////////////////// internal/private methods ////////////////////////////////

	

	// get button code	

	function _get_button_code($pack) {

		$data   = $this->_get_button_data($pack);

		$return = '';	

		foreach ($data as $key => $value) {

			$return .= '	<input type="hidden" name="'. $key .'" value="'. $value .'" />' . "\n";

		}	

		return $return;

	}



	// get button data

	function _get_button_data($pack) {

		// system setting

		$system   = mgm_get_option('mgm_system');	

		$user_id  = mgm_get_user_id();

		$user     = get_userdata($user_id); 	

	

		// orderid

		$orderid = $this->_create_order($pack,$user_id);

		// setup data array		

		$data = array(

			'cmd'           => (isset($pack['num_cycles']) && $pack['num_cycles'] != 1 ? '_xclick-subscriptions':'_xclick'),

			'business'      => $this->setting['business_email'],

			'item_name'     => ($pack['item_name'] ? $pack['item_name'] : $system->get_subscription_name($pack)),

			'no_shipping'   => 1,

			'no_note'       => 1,

			'currency_code' => $this->setting['currency'],

			'lc'            => $this->setting['locale'],

			'notify_url'    => $this->setting['notify_url'],

			'cancel_return' => $this->setting['cancel_url'],

			'rm'            => 2,

			'cbt'           => 'Return to '.get_option('blogname'),					

			'email'         => $user->user_email

		);

		

		// address fields

		$this->_set_address_fields($user, $data, array('address'=>'address1'));// see parent for all fields, only different given here			

		

		// 'modify'=>1, // 1 new, 2 upgrade

		// subscription payment

		if ($pack['num_cycles'] != 1 && $pack['duration_type']) { // ongoing(0) or 1-99 times

			$data['a3'] = $pack['cost'];

			$data['p3'] = $pack['duration'];

			$data['t3'] = strtoupper($pack['duration_type']);

			$data['src'] = 1;

			$data['sra'] = 1;

			// greater than 0

			if ($pack['num_cycles']) {

				$data['srt'] = $pack['num_cycles'];

			}

			// trial

			if ($pack['trial_on']) {

				$data['a1'] = $pack['trial_cost'];

				$data['p1'] = $pack['trial_duration'];

				$data['t1'] = strtoupper($pack['trial_duration_type']);

			}			

		} else {

			$data['bn']     = 'PP-BuyNowBF';

			$data['amount'] = $pack['cost'];

			

			// Purchase Post

			if ($pack['buypost'] == 1 ) {

				if (isset($pack['ppp_pack_id'])) {

					// get comma separated list of post ids					

					$pack['post_id'] = mgm_get_ppp_pack_post_csv($pack['ppp_pack_id']);

				} else {

					// single post

					$pack['post_id'] = get_the_ID();	

				}

				$data['src'] = 0;

				$data['sra'] = 0;

								

			} else { // One time payment				

				$data['src'] = 1;

				$data['sra'] = 1;

			}

		}

		

		// custom

		$data['custom'] = $this->_set_payment_type($pack, $this->setting['currency']);

		

		// set apc on request so that it can be tracked for post purchase

		$data['return'] = add_query_arg(array('custom'=>$data['custom']), $this->setting['return_url']);

		

		// return data

		return $data;

	}	

	

	// verify callback 

	function _verify_callback(){	

		// system

		$system = mgm_get_option('mgm_system');				

		$dge    = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;		

		

		// parse the paypal URL

		$url_parsed = parse_url($this->_get_endpoint());  

		

		// domain/host

		$domain = $url_parsed['host']; // str_replace('https://', '', $this->_get_endpoint());

		

		// post vars

		$request = 'cmd=_notify-validate';

		// loop post

		foreach ($_POST as $key=>$value) {

			// strip

			if (get_magic_quotes_gpc()) {

				$value = stripslashes($value);

			}

			// request

			$request .= '&' . $key . '=' .urlencode($value);

		}

		

		// get conn

		@set_time_limit(60);

		// fosockopen

		if ($conn = @fsockopen("ssl://".$domain, 443, $errno, $errstr, 60)) {

			fputs($conn, "POST /cgi-bin/webscr HTTP/1.1\r\n");

			fputs($conn, "Host: " . $domain . "\r\n");

			fputs($conn, "Content-type: application/x-www-form-urlencoded\r\n");

			fputs($conn, "Content-length: ".strlen($request)."\r\n");

			fputs($conn, "Connection: close\r\n\r\n");

			fputs($conn, $request . "\r\n\r\n");

			// get response

			$response = '';

			while(!feof($conn)) {

				$response .= fgets($conn, 1024);

			}

			// close

			fclose($conn); // close connection		

			

			// log

			// mgm_log('verify response fsockopen: '.$response);

			

			// check

			if (!preg_match('/VERIFIED/i',$response)) {

				// notify admin, only if gateway emails on

				if(!$dge){

					mgm_mail($system->setting['admin_email'], 'callback failed', "sent a request to host: '" . $domain . "'. \n\n <br />response was: \n\n <br />" . $response . "\n\n <br />post vars: <br /><pre>\n" . print_r($_POST, true)) . '</pre>';

				}

				// abort

				die;

			}

			// valid

			return true;

		} elseif (extension_loaded('curl')) {

			// open

			$ch = curl_init();

			curl_setopt($ch, CURLOPT_URL            , $this->_get_endpoint());

			curl_setopt($ch, CURLOPT_USERAGENT      , 'Magic Members Membership Software');

			curl_setopt($ch, CURLOPT_RETURNTRANSFER , 1);

			curl_setopt($ch, CURLOPT_HTTPHEADER     , array("Content-Type: application/x-www-form-urlencoded"));	

			curl_setopt($ch, CURLOPT_POSTFIELDS     , $request);

			curl_setopt($ch, CURLOPT_POST           , 1);

			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER , 0);

			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST , 0);

			curl_setopt($ch, CURLOPT_NOPROGRESS     , 1); 

			curl_setopt($ch, CURLOPT_VERBOSE        , 1); 

			curl_setopt($ch, CURLOPT_FOLLOWLOCATION , 0); 

			curl_setopt($ch, CURLOPT_TIMEOUT        , 30); 

			curl_setopt($ch, CURLOPT_REFERER        , get_option('siteurl')); 

			curl_setopt($ch, CURLOPT_HEADER         , 0);	

			$response = curl_exec($ch); 

			

			// log

			// mgm_log('verify response curl : '.$response);

			

			// check

			if (!preg_match('/VERIFIED/i',$response)) {

				// notify admin, only if gateway emails on

				if(!$dge){

					mgm_mail($system->setting['admin_email'], 'callback failed', "sent a request to host: '" . $domain . "'. \n\n <br />response was: \n\n <br />" . $response . "\n\n <br />post vars: <br /><pre>\n" . print_r($_POST, true)) . '</pre>';

				}

				// abort

				die;

			}

			// valid

			return true;	

		} else {		

			// log

			// mgm_log('verify response curl : Nothing');	

			// notify admin, only if gateway emails on

			if(!$dge){

				mail($system->setting['admin_email'], 'callback failed', 'fsockopen/curl to ' . $domain . ' failed. Would have sent: ' . $request);

			}

			// abort

			die;

		}	

	}	

	

	// buy post

	function _buy_post() {

		global $wpdb;



		$system = mgm_get_option('mgm_system');

		$dge  = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;

		

		list($duration, $cost, $currency, $user_id, $post_id, $user_id, $client_ip) = explode('_', preg_replace('/^buypost_/','', $_POST['custom']));



		// find user

		$user     = get_userdata($user_id);

		$blogname = get_option('blogname');

		$tran_success = false;

		switch ($_POST['payment_status']) {

			case 'Completed':

			case 'Processed':

				// trans status

				$tran_success = true;

				// status

				$status_str = __('Last payment was successful','mgm');

				//issue#: 280 (2011 Feb 25)

				// subject

				$subject = $system->get_template('payment_success_email_template_subject', array('blogname'=>$blogname), true);

				// body

				$message = $system->get_template('payment_success_email_template_body', 

										array('blogname'=>$blogname, 'name'=>$user->display_name, 

											  'email'=>$user->user_email, 

											  'admin_email'=>$system->setting['admin_email']), true);

				

				// after succesful payment hook

				do_action('mgm_buy_post_transaction_success', array("post_id"=>$post_id));

			break;



			case 'Reversed':

			case 'Refunded':

			case 'Denied':

				// status

				$status_str = __('Last payment was refunded or denied','mgm');

				 //issue#: 280 (2011 Feb 25)

				// subject

				$subject = $system->get_template('payment_failed_email_template_subject', array('blogname'=>$blogname), true);

				 

				// body			

				$message = $system->get_template('payment_failed_email_template_body', 

										array('blogname'=>$blogname, 'name'=>$user->display_name, 

											  'email'=>$user->user_email, 'payment_type'=>'post purchase payment','reason'=>$status_str,

											  'admin_email'=>$system->setting['admin_email']), true);

				break;



			case 'Pending':

				// status

				$reason = 'Unknown';

				$status_str = sprintf(__('Last payment is pending. Reason: %s','mgm'), $reason);

				 //issue#: 280 (2011 Feb 25)

				// subject

				$subject = $system->get_template('payment_pending_email_template_subject', array('blogname'=>$blogname), true);

				// body	

				$message = $system->get_template('payment_pending_email_template_body', 

										array('blogname'=>$blogname, 'name'=>$user->display_name, 

											  'email'=>$user->user_email, 'reason'=>$status_str,

											  'admin_email'=>$system->setting['admin_email']), true);

				break;



			default:

				// status

				$status_str = sprintf(__('Last payment status: %s','mgm'),$_POST['payment_status']);

				 //issue#: 280 (2011 Feb 25)

				// subject

				$subject = $system->get_template('payment_unknown_email_template_subject', array('blogname'=>$blogname), true);				

				// body	

				$message = $system->get_template('payment_unknown_email_template_body', array('blogname'=>$blogname, 'name'=>$user->display_name, 

				                                                                              'email'=>$user->user_email, 'reason'=>$status_str,

																							  'admin_email'=>$system->setting['admin_email']), true);

				break;																			  

				

		}

		// notify user

		mgm_mail($user->user_email, $subject, $message); //send an email to the buyer		



		$status = __('Failed join', 'mgm'); //overridden on a successful payment

		if ($tran_success) {

			$table_name = TBL_MGM_POSTS_PURCHASED;

			

			//if we are looking at a pack then explode the buy post item number and loop through it

			if (strpos($post_id, ',') !== false) {

				$posts = explode(',', $post_id);

			} else {

				$posts = array($post_id);

			}

			

			$posts = array_unique($posts);

			

			foreach ($posts as $post_id) {

				$sql = "INSERT INTO " . $table_name . " (user_id, post_id, unixtime)

					    VALUES (" . $user_id . ", " . $post_id . ", UNIX_TIMESTAMP())";

				$wpdb->query($sql); //insert the post purchased record

			}



			$status = __('The post was purchased successfully', 'mgm');

		}



		// notify admin, only if gateway emails on

		if (!$dge) {

			$subject = "[" . $blogname . "] Admin Notification: " . $user->user_email . " purchased post " . $post_id;

			$message = "User display name: {$user->display_name}<br />User email: {$user->user_email}<br />User ID: {$user->ID}<br />

			           Status: " . $status . "<br />Action: Purchase post:" . $subject . "<br /><br />" . $message . "<br /><br />

					   <pre>" . print_r($_POST, true) . '</pre>';

			mgm_mail($system->setting['admin_email'], $subject, $message);

		}

	}

	

	// buy membership

	function _buy_membership() {			

		// system	

		$system       = mgm_get_option('mgm_system');		

		$packs        = mgm_get_option('mgm_subscription_packs');

		$duration_str = $packs->duration_str;

		//$status_str   = $system->get_statuses();

		$dge          = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;

		// get custom field values

		list($duration, $amount, $currency, $user_id, $membership_type, $duration_type, $role, $client_ip, $hide_old_content, $pack_id) = explode('_', preg_replace('/^subscription_/','', $_POST['custom']));

		

		// currency

		if (!$currency) {

			$currency = $this->setting['currency'];

		}

		// find user

		$user       = get_userdata($user_id);

		$mgm_member = mgm_get_member($user_id);

		

		$join_date = $mgm_member->join_date; // Get the current AC join date



		if (!$join_date) {

			$mgm_member->join_date = time(); // Set current AC join date

		}



		//if there is no duration set in the user object then run the following code

		if (empty($duration_type)) {

			//if there is no duration type then use Months

			$duration_type = 'm';

		}

		// membership type default

		if (empty($membership_type)) {

			//if there is no account type in the custom string then use the existing type

			$membership_type = md5($mgm_member->membership_type);

		}

		// validate parent method

		$membership_type_verified = $this->_validate_membership_type($membership_type, 'md5|plain');

		// verified

		if (!$membership_type_verified) {

			if (strtolower($mgm_member->membership_type) != 'free') {

				// notify admin, only if gateway emails on

				if(!$dge){

					$message = 'Could not read membership type in the following POST data. Please debug or contact magic members to fix the problem making sure to pass on the following data. <br /><br /><pre>' . "\n\n" . print_r($_POST, true) . '</pre>';

					mgm_mail($system->setting['admin_mail'], 'Error in Paypal membership verification', $message);

				}

				// abort

				return;

			} else {

				$membership_type_verified = $mgm_member->membership_type;

			}

		}

		// set

		$membership_type = $membership_type_verified;

		// sub pack

		$subs_pack = $packs->get_pack($pack_id);

		// if trial on		

		if ($subs_pack['trial_on']) {

			$mgm_member->trial_on            = $subs_pack['trial_on'];

			$mgm_member->trial_cost          = $subs_pack['trial_cost'];

			$mgm_member->trial_duration      = $subs_pack['trial_duration'];

			$mgm_member->trial_duration_type = $subs_pack['trial_duration_type'];

			$mgm_member->trial_num_cycles    = $subs_pack['trial_num_cycles'];

			

			// 0 cost trial does not send payment_status, make check here

			if($mgm_member->trial_cost == 0 && !isset($_POST['payment_status'])){				

				// when subscr_id present, treat it as Processed , #287 issue, with trial cost is 0, only subscr_signup is sent without payment_status

				// with trial cost > 0, subscr_signup and subscr_payment sent with payment_status

				if(isset($_POST['subscr_id'])){

					$_POST['payment_status'] = 'Processed';	

				}		

			}

		}		

		// duration

		$mgm_member->duration        = $duration;

		$mgm_member->duration_type   = strtolower($duration_type);

		$mgm_member->amount          = $amount;

		$mgm_member->currency        = $currency;

		$mgm_member->membership_type = $membership_type;		

		$mgm_member->pack_id         = $pack_id;

		$mgm_member->payment_type    = ($_POST['txn_type']=='subscr_signup' || $_POST['txn_type'] =='subscr_payment') ?'subscription' : 'one-time';

		// payment info for unsubscribe		

		$mgm_member->payment_info    = new stdClass;

		$mgm_member->payment_info->module = $this->code;

		if(isset($_POST['txn_type'])){

			$mgm_member->payment_info->txn_type = $_POST['txn_type'];

		}	

		if(isset($_POST['subscr_id'])){

			$mgm_member->payment_info->subscr_id = $_POST['subscr_id'];		

		}	

		if(isset($_POST['txn_id'])){	

			$mgm_member->payment_info->txn_id = $_POST['txn_id'];	

		}	

		// [txn_type]  => subscr_signup

		// [txn_type]  => subscr_payment

		// [subscr_id] => I-KV2G0LEU6RCD

		// [txn_id]    => 3K2504430T514494Y

		

		// process PayPal response

		$new_status = false;

		// status

		switch ($_POST['payment_status']) {

			case 'Completed':

			case 'Processed':

				// status

				$new_status = MGM_STATUS_ACTIVE;

				$mgm_member->status_str = __('Last payment was successful','mgm');					

				

				// old type match

				$old_membership_type = mgm_get_user_membership_type($user_id, 'code');

				if ($old_membership_type != $membership_type) {

					$mgm_member->join_date = time(); // type join date as different var

				}

				// old content hide

				$mgm_member->hide_old_content = $hide_old_content; 

				

				$time = time();				

				$mgm_member->last_pay_date = date('Y-m-d', $time);				

				

				// THIS will cause double calculation

				/* *********************************************************************************/

				if ($mgm_member->expire_date && $mgm_member->last_pay_date!=date('Y-m-d', $time)) {

					$expiry = strtotime($mgm_member->expire_date);

					if ($expiry > 0) {

						if ($expiry > $time) {

							$time = $expiry;

						}

					}

				}

				/***********************************************************************************/					

				

				// type expanded

				$duration_types = array('d'=>'DAY','m'=>'MONTH','y'=>'YEAR');

				// time

				$time = strtotime("+{$mgm_member->duration} {$duration_types[$mgm_member->duration_type]}", $time);							

				// formatted

				$time_str = date('Y-m-d', $time);				

				// date extended				

				if (!$mgm_member->expire_date || strtotime($time_str) > strtotime($mgm_member->expire_date)) {

					$mgm_member->expire_date = $time_str;										

				}

								

				// role

				if ($role) {

					$role_obj = new WP_User($user_id);

					$role_obj->set_role($role);

				}			

				

				// after succesful payment hook

				do_action('mgm_membership_transaction_success', array("user_id" =>$user_id));	



			break;

			case 'Reversed':

			case 'Refunded':

			case 'Denied':

				$new_status = MGM_STATUS_NULL;

				$mgm_member->status_str = __('Last payment was refunded or denied','mgm');

				break;



			case 'Pending':

				$new_status = MGM_STATUS_PENDING;



				$reason = 'Unknown';

				$mgm_member->status_str = sprintf(__('Last payment is pending. Reason: %s','mgm'), $reason);

				break;



			default:

				$new_status = MGM_STATUS_ERROR;

				$mgm_member->status_str = sprintf(__('Last payment status: %s','mgm'), $_POST['payment_status']);

				break;

		}



		// handle exceptions from the subscription specific fields

		if ($new_status == MGM_STATUS_ACTIVE && in_array($_POST['txn_type'], array('subscr_failed', 'subscr_eot'))) {

			$new_status = MGM_STATUS_NULL;

			$mgm_member->status_str = __('The subscription is not active','mgm');

		}

		

		// set status

		$mgm_member->status = $new_status;

		

		// update option

		update_user_option($user_id, 'mgm_member', $mgm_member, true);				



		// return action

		do_action('mgm_return_paypal');



		// send email notification to client

		$blogname = get_option('blogname');

		// on status

		switch ($new_status) {

			case MGM_STATUS_ACTIVE:

				//issue #: 280

				// subject

				$subject = $system->get_template('payment_success_email_template_subject', array('blogname'=>$blogname), true);

				// on type

				if ($mgm_member->payment_type == 'subscription') {

					$payment_type = 'recurring subscription';

					$subscription = sprintf('%1$s %2$s every %3$s %4$s',$mgm_member->amount, $mgm_member->currency, $mgm_member->duration, 

					                                                    $duration_str[$mgm_member->duration_type]);

				} else {

					$payment_type = 'one-time payment';

					$subscription = sprintf('%1$s %2$s for %3$s %4$s',$mgm_member->amount, $mgm_member->currency, $mgm_member->duration, 

					                                                  $duration_str[$mgm_member->duration_type]);					

				}

				// body

				$message = $system->get_template('payment_success_subscription_email_template_body', 

													array('blogname'=>$blogname, 'name'=>$user->display_name, 

														  'email'=>$user->user_email, 'payment_type'=>$payment_type,

														  'subscription'=>$subscription,'admin_email'=>$system->setting['admin_email']), true);

				break;



			case MGM_STATUS_NULL:

				// subject

				$subject = $system->get_template('payment_failed_email_template_subject', array('blogname'=>$blogname), true);				

				// message

				$message = $system->get_template('payment_failed_email_template_body', 

									array('blogname'=>$blogname, 'name'=>$user->display_name, 

										  'email'=>$user->user_email, 'payment_type'=>'subscription payment',

										  'reason'=>$mgm_member->status_str,

										  'admin_email'=>$system->setting['admin_email']), true);

				break;



			case MGM_STATUS_PENDING:

				// subject

				$subject = $system->get_template('payment_pending_email_template_subject', array('blogname'=>$blogname), true);

				// body

				$message = $system->get_template('payment_pending_email_template_body', 

										array('blogname'=>$blogname, 'name'=>$user->display_name, 

											  'email'=>$user->user_email, 'reason'=>$mgm_member->status_str,

											  'admin_email'=>$system->setting['admin_email']), true);

				break;



			case MGM_STATUS_ERROR:

				// subject

				$subject = $system->get_template('payment_error_email_template_subject', array('blogname'=>$blogname), true);				

				// body	

				$message = $system->get_template('payment_error_email_template_body', 

									array('blogname'=>$blogname, 'name'=>$user->display_name, 

										  'email'=>$user->user_email, 'reason'=>$mgm_member->status_str,

										  'admin_email'=>$system->setting['admin_email']), true);

				break;

		}



		// notify once

		if($_POST['txn_type'] == 'subscr_payment' || ( $_POST['txn_type'] == 'subscr_signup' && ($_POST['payment_status'] == 'Processed' || $_POST['payment_status'] == 'Completed'))){ 

			// notify user

			mgm_mail($user->user_email, $subject, $message);				



			// send email notification to system administrator

			if (!$dge) {

				$subject = "[$blogname] {$user->user_email} - {$new_status}";

				$message = "	User display name: {$user->display_name}\n\n<br />

						User email: {$user->user_email}\n\n<br />

						User ID: {$user->ID}\n\n<br />

						Membership Type: {$membership_type}\n\n<br />

						New status: {$new_status}\n\n<br />

						Status message: {$mgm_member->status_str}\n\n<br />

						Subscription period: {$mgm_member->duration} ". $duration_str[$mgm_member->duration_type] ."\n\n<br />

						Subscription amount: {$mgm_member->amount} {$mgm_member->currency}\n<br />

						Payment Mode: {$mgm_member->payment_type}\n\n<br />

						POST Data was: \n\n<br /><br /><pre>" . print_r($_POST, true) . '</pre>';

				mgm_mail($system->setting['admin_email'], $subject, $message);

			}		

		}

	}

	

	// cancel membership

	function _cancel_membership(){

		// system	

		$system       = mgm_get_option('mgm_system');		

		$packs        = mgm_get_option('mgm_subscription_packs');

		$duration_str = $packs->duration_str;

		//$status_str   = $system->get_statuses();

		$dge          = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;

		

		// get custom field values

		list($duration, $amount, $currency, $user_id, $membership_type, $duration_type, $role, $client_ip, $hide_old_content,$pack_id) = explode('_', preg_replace('/^subscription_/','', $_POST['custom']));

				

		// find user

		$user       = get_userdata($user_id);

		$mgm_member = mgm_get_member($user_id);		

				

		// get pack

		if($mgm_member->pack_id){

			$subs_pack = $packs->get_pack($mgm_member->pack_id);

		}else{

			$subs_pack = $packs->validate_pack($mgm_member->amount, $mgm_member->duration, $mgm_member->duration_type, $mgm_member->membership_type);

		}

						

		// reset payment info

		if(isset($_POST['txn_type'])){

			$mgm_member->payment_info->txn_type = $_POST['txn_type'];

		}	

		if(isset($_POST['subscr_id'])){

			$mgm_member->payment_info->subscr_id = $_POST['subscr_id'];		

		}	

		if(isset($_POST['txn_id'])){	

			$mgm_member->payment_info->txn_id = $_POST['txn_id'];	

		}	

		

		// types

		$duration_types = array('d'=>'DAY','m'=>'MONTH','y'=>'YEAR');	

						

		// default expire date				

		$expire_date = $mgm_member->expire_date;					

		// if trial on 

		if ($subs_pack['trial_on']) {			

			// if cancel data is before trial end, set cancel on trial expire_date

			$trial_expire_date = strtotime("+{$subs_pack['trial_duration']} {$duration_types[$subs_pack['trial_duration_type']]}", $mgm_member->join_date);

			

			// if lower

			if(time() < $trial_expire_date){

				$expire_date = date('Y-m-d',$trial_expire_date);

			}

		}	

			

		// if today 

		if($expire_date == date('Y-m-d')){

			$new_status = MGM_STATUS_CANCELLED;

			$mgm_member->status_str = __('Subscription cancelled','mgm');					

			$mgm_member->expire_date = date('Y-m-d');	

			// set status

			$mgm_member->status = $new_status;

		}else{

			$new_status = MGM_STATUS_AWAITING_CANCEL;			

			// reset on

			$mgm_member->status_reset_on = $expire_date;

			$mgm_member->status_reset_as = MGM_STATUS_CANCELLED;

		}

				

		// update user

		update_user_option($user_id, 'mgm_member', $mgm_member, true);		

			

		// send email notification to client

		$blogname = get_option('blogname');

		// email	

		//$subject = sprintf(__('[%s] Subscription Cancelled','mgm'),$blogname);				

		//$message = __('','mgm');

		//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $system->setting['admin_email']);

		

		// subject

		$subject = $system->get_template('subscription_cancelled_email_template_subject', array('blogname'=>$blogname), true);				

		// body	

		$message = $system->get_template('subscription_cancelled_email_template_body', 

							array('blogname'=>$blogname, 'name'=>$user->display_name, 

								  'email'=>$user->user_email, 'admin_email'=>$system->setting['admin_email']), true);

										  

		// send email notification to user

		mgm_mail($user->user_email, $subject, $message);		



		// notify admin, only if gateway emails on

		if (!$dge) {

			$subject = "[$blogname] {$user->user_email} - {$new_status}";

			$message = "	User display name: {$user->display_name}\n\n<br />

					User email: {$user->user_email}\n\n<br />

					User ID: {$user->ID}\n\n<br />

					Membership Type: {$membership_type}\n\n<br />

					New status: {$new_status}\n\n<br />

					Status message: {$mgm_member->status_str}\n\n<br />					

					Payment Mode: Cancelled\n\n<br />

					POST Data was: \n\n<br /><br /><pre>" . print_r($_POST, true) . '</pre>';

			mgm_mail($system->setting['admin_email'], $subject, $message);

		}

		

		// after cancellation hook

		do_action('mgm_membership_subscription_cancelled', array("user_id" =>$user_id));	

	}	

	

	// default setting

	function _default_setting(){

		// paypal specific

		$this->setting['business_email']  = get_option('admin_email');	

		$this->setting['locale']          = 'US';	

		$this->setting['currency']        = mgm_get_option('mgm_system')->setting['currency'];

		// purchase price

		if(in_array('buypost', $this->supported_buttons)){

			$this->setting['purchase_price']  = 4.00;		

		}		

		// callback messages				

		$this->_setup_callback_messages();

		// callback urls

		$this->_setup_callback_urls();		

	}

}



// end file