<?php

// payment module

class mgm_sagepay extends mgm_payment{

	

	// construct

	function __construct(){

		// php4 construct

		$this->mgm_sagepay();

	}

	

	// php4 construct

	function mgm_sagepay(){

		// parent

		parent::__construct();

		// set code

		$this->code = __CLASS__; 

		// set name

		$this->name = 'Sagepay';

		// logo

		$this->logo = MGM_PLUGIN_MODULE_URL . 'payment/sagepay/assets/sagepay.jpeg';

		// description

		$this->description = __('At Sagpay We process millions of secure payments each month for over 30,000 businesses.', 'mgm');

		// supported buttons types

	 	$this->supported_buttons = array('subscription','buypost');

		// trial support available ?

		$this->supports_trial= 'N';		

		// do we depend on product mapping	

		$this->requires_product_mapping = 'N';

		// endpoints

		$this->_set_endpoint('test','https://test.sagepay.com/gateway/service/vspform-register.vsp'); // test

		$this->_set_endpoint('live','https://live.sagepay.com/gateway/service/vspform-register.vsp'); // live

		// default settings

		$this->_default_setting();		

		// set path

		parent::set_tmpl_path();	

	}

	

	// settings

	function settings(){

		global $wpdb;

		// data

		$data = array();		

		// set 

		$data['module'] = mgm_get_option($this->code);

		// load template view

		$this->load_template('settings', array('data'=>$data, 'ajax'=>true));

	}	

	

	// settings box api hook

	function settings_box(){

		global $wpdb;

		// data

		$data = array();	

		// set 

		$data['module'] = mgm_get_option($this->code);	

		// load template view

		return $this->load_template('settings_box', array('data'=>$data), true);		

	}

	

	// settings update

	function settings_update(){

		// form type 

		switch($_POST['setting_form']){

			case 'box':

			// from box			

				switch($_POST['act']){

					case 'logo_update':

						// logo if uploaded

						if(isset($_POST['logo_new_'.$this->code]) && !empty($_POST['logo_new_'.$this->code])){

							$this->logo = $_POST['logo_new_'.$this->code];

							// update option

							update_option($this->code, $this);

						}

						// message

						$message = $this->name . ' logo updated';			

						$extra   = array();

					break;

					case 'status_update':

					default:

						// enable

						$enable_state = ($_POST['payment']['enable'] == 'Y') ? 'Y' : 'N';

						// enable

						if($enable_state == 'Y'){

							$this->install();

							$stat = ' enabled.';

						}else{

						// disable

							$this->uninstall();	

							$stat = ' disabled.';

						}	

						

						# message

						$message = __($this->name . ' module is '. $stat, 'mgm');							

						$extra   = array('enable' => $enable_state);		

					break;

				}							

				// print message

				echo json_encode(array_merge(array('status'=>'success','message'=>$message,'module'=>array('name'=>$this->name,'code'=>$this->code,'tab'=>$this->settings_tab)), $extra));

			break;

			case 'main':

			default:

			// from main				

				// sagepay specific

				$this->setting['vendor']         = $_POST['setting']['vendor'];

				$this->setting['encryption_key'] = $_POST['setting']['encryption_key'];

				$this->setting['currency']       = $_POST['setting']['currency'];								

				// purchase price

				if(isset($_POST['setting']['purchase_price'])){

					$this->setting['purchase_price']  = $_POST['setting']['purchase_price'];

				}

				// setup callback messages				

				$this->_setup_callback_messages($_POST['setting']);

				// re setup callback urls

				$this->_setup_callback_urls($_POST['setting']);

				// common

				$this->description = $_POST['description'];

				$this->status      = $_POST['status'];

				// logo if uploaded

				if(isset($_POST['logo_new_'.$this->code]) && !empty($_POST['logo_new_'.$this->code])){

					$this->logo = $_POST['logo_new_'.$this->code];

				}				

				// update option

				update_option($this->code, $this);

				//  message

				echo json_encode(array('status'=>'success','message'=> $this->name . ' settings updated'));

			break;

		}		

	}

	

	// return process api hook, link back to site after payment is made

	function process_return() {

		// parse crypt

		$_POST = $this->_crypt($_REQUEST['crypt']);

		// check and show message

		if((isset($_REQUEST['crypt']))){

			// process notify, internally called

			$this->process_notify();

			// query arg

			$query_arg = array('status'=>'success');

			// is a post redirect?

			if(isset($_REQUEST['custom'])){

				$post_redirect = $this->_get_post_redirect($_REQUEST['custom']);

				// yes redirect argument passed

				if($post_redirect !== false){

					$query_arg['post_redirect'] = $post_redirect;

				}			

			}

			// redirect

			wp_redirect(add_query_arg($query_arg, $this->setting['processed_url']));

		}else{			

			wp_redirect(add_query_arg(array('status'=>'error'), $this->setting['processed_url']));

		}

	}	

	

	// notify process api hook, background IPN url

	function process_notify() {		

		// overwrite this		

		if (!isset($_POST['VPSTxId']) && !isset($_POST['Status'])) {

			// Did not find expected POST variables. Possible access attempt from a non sagepay site.

			echo 'Error in IPN. Missing status.';

			exit;

		} else {	

			// payment type

			$payment_type = $this->_get_payment_type($_REQUEST['custom']);

			// check

			switch($payment_type){

				// buypost 

				case 'buypost':

					$this->_buy_post(); //run the code to process a purchased post/page

				break;

				// subscription	

				case 'subscription':

					// cancellation

					if(isset($_POST['txn_type']) && $_POST['txn_type']=='subscr_cancel') {						

						$this->_cancel_membership(); //run the code to process a membership cancellation

					}else{

						$this->_buy_membership(); //run the code to process a new/extended membership

					}	

				break;	

				// other		

				default:

					// error					

				break;							

			}			

		}

	}	

	

	// process cancel api hook 

	function process_cancel(){

		// redirect to cancel page

		wp_redirect(add_query_arg(array('status'=>'cancel'), $this->setting['processed_url']));

	}	

	

	// unsubscribe process, IPN for unsubscribe 

	function process_unsubscribe(){

		// overwrite this

	}

		

	// subscribe button api hook

	function get_button_subscribe($options=array()){	

		// sp depends on encryption_key, check for it before generating button

		if(!isset($this->setting['encryption_key']) || $this->setting['encryption_key']== ''){

			return '<div style="color:red; font-style:oblique; text-align:center; height:100px; padding:15px; vertical-align:middle"><b>Error in Sagepay : No encryption key set.</b></div>';

			exit;

		}

			

		$button_code     = $this->_get_button_code($options['pack']);

		$additional_code = do_action('mgm_additional_code');

		// $simulator = 'https://test.sagepay.com/Simulator/VSPFormGateway.asp';

		$html='<form action="'. $this->_get_endpoint() .'" method="post" class="mgm" name="' . $this->code . '_form" id="' . $this->code . '_form">

					'. $button_code .'					

					'. $additional_code .'

					<input type="image" src="' . mgm_fix_url($this->logo) . '" border="0" name="submit">

					<div class="mgm_paymod_description">'. $this->description .'</div>

				</form>';

		return $html;		

	}

	

	// buypost button api hook

	function get_button_buypost($options=array(), $return = false) {

		global $user;

		// sp depends on encryption_key, check for it before generating button

		if(!isset($this->setting['encryption_key']) || $this->setting['encryption_key']== ''){

			return '<div style="color:red; font-style:oblique; text-align:center; height:100px; padding:15px; vertical-align:middle"><b>Error in Sagepay : No encryption key set.</b></div>';

			exit;

		}

		// title

		$item_name = (isset($options['pack']['ppp_pack_id'])) ? ('Purchase Post Pack - '.$options['pack']['title']) : ('Purchase Post - '.$options['pack']['title']) ;

		// merge pack

		$options['pack'] = array_merge($options['pack'], array('duration'=>1, 'item_name'=>$item_name, 'buypost'=>1));

		// button code		

		$button_code = $this->_get_button_code($options['pack']);

		$additional_code = do_action('mgm_additional_code');

		// html

		$html = '<table width="100%" border="0" cellpadding="0" cellspacing="0" align="center" class="form-table">

					<form action="'. $this->_get_endpoint() .'" method="post" class="mgm" name="' . $this->code . '_form" id="' . $this->code . '_form">

						 <tr>

							 <td align="center">

								 '. $button_code .'

								 '. $additional_code .'

								 <input type="image" src="' . mgm_fix_url($this->logo) . '" name="submit" alt="">

								 <div class="mgm_paymod_description">'. $this->description .'</div>

							 </td>

						 </tr>

					 </form>

				</table>';



		if ($return) {

			return $html;

		} else {

			echo $html;

		}

	}

	

	// dependency_check

	/*

	function dependency_check(){

		$this->dependency = array();

		if(!extension_loaded('curl') && !extension_loaded('curl')){

			$this->dependency[] = '<b style="color:#FF1F3D">CURL PHP extension must be loaded for sagepay.</b>';

		}

		// error		

		return (count($this->dependency)>0) ? true : false ;

	}

	*/

	

	/////////////////////////////////////////////// internal/private methods /////////////////////////////////////////////////

	

	// get button code	

	function _get_button_code($pack) {

		$data   = $this->_get_button_data($pack);

		$return = '';	

		foreach ($data as $key => $value) {

			$return .= '	<input type="hidden" name="'. $key .'" value="'. $value .'" />' . "\n";

		}	

		return $return;

	}



	// get button data

	function _get_button_data($pack) {

		// system setting

		$system  = mgm_get_option('mgm_system');	

		$user_id = mgm_get_user_id();

		$user    = get_userdata($user_id);

		// setup data array	

		$data = array(

			'VPSProtocol'   => '2.23',

			'TxType'        => 'PAYMENT',

		  	'Vendor'        => $this->setting['vendor'],							

			'VendorTxCode'  => $this->_create_order($pack,$user_id),

			'Currency'      => $this->setting['currency'],			

			//'Description'   => ($pack['item_name'] ? $pack['item_name'] : $system->setting['subscription_name']),

			//updated here on 2011 Feb 24 for issue: 289

			'Description'   => ($pack['item_name'] ? $pack['item_name'] : $system->get_subscription_name($pack)),

			'Apply3DSecure' => 0,

			'ApplyAVSCV2'   => 0,

			'AllowGiftAid'  => 0,

			//'SuccessURL'    => $this->setting['return_url'],

			'FailureURL'    => $this->setting['return_url'],	

			'CustomerEMail' => $user->user_email,

			'Amount'        => $pack['cost']

		);

		

		// additional fields

		$this->_set_address_fields($user, $data);

		

		// 'modify'=>1, // 1 new, 2 upgrade

		// subscription payment

		if ($pack['num_cycles'] != 1 && $pack['duration_type']) { // ongoing(0) or 1-99 times

			// nothing for sagepay

		} else {

			// Purchase Post

			if ($pack['buypost'] == 1 ) {

				if (isset($pack['ppp_pack_id'])) {

					// get comma separated list of post ids					

					$pack['post_id'] = mgm_get_ppp_pack_post_csv($pack['ppp_pack_id']);

				} else {

					// single post

					$pack['post_id'] = get_the_ID();	

				}			

			} 

		}

		

		// custom/passthrough

		$custom = $this->_set_payment_type($pack, $this->setting['currency']);

		// set in success

		$data['SuccessURL'] = add_query_arg(array('custom'=>$custom),$this->setting['return_url']);

		

		// actual form data

		$fdata = array_slice($data,0,3);

		// generate crypt

		$fdata['Crypt'] = $this->_crypt($data);// with data create, with no data parse

		

		// return data

		return $fdata;

	}		

	

	// additional payment fields

	function _set_address_fields($user,&$data){

		// user fields on payment page

		$uf_on_paymentpage = mgm_get_option('mgm_member_custom_fields')->get_fields_where(array('on_payment'=>true));

		// founf some

		if($uf_on_paymentpage){

			foreach($uf_on_paymentpage as $uf){

				if($uf_value = $user->mgm_member->custom_fields->$uf['name']){

					// set appropiate fields

					switch($uf['name']){

						case 'first_name':

							$data['CustomerName']       = $uf_value;

							$data['BillingFirstnames']  = $uf_value;	

							$data['DeliveryFirstnames'] = $uf_value;									

						break;

						case 'last_name':

							$data['CustomerName']    .= ' '.$uf_value;

							$data['BillingSurname']   = $uf_value;	

							$data['DeliverySurname']  = $uf_value;	

						break;

						case 'address':

							$data['BillingAddress1']  = $uf_value;

							$data['DeliveryAddress1'] = $uf_value;

						break;

						case 'city':

							$data['BillingCity']  = $uf_value;

							$data['DeliveryCity'] = $uf_value;

						break;

						case 'state':

							$data['BillingState']  = $uf_value;

							$data['DeliveryState'] = $uf_value;

						break;

						case 'zip':

							$data['BillingPostCode']  = $uf_value;

							$data['DeliveryPostCode'] = $uf_value;

						break;

						case 'country':

							$data['BillingCountry']  = $uf_value;

							$data['DeliveryCountry'] = $uf_value;

						break;

						default:

							$data[$uf['name']] = $uf_value;

						break;

					}

				}

			}

		}	

	}

	

	// buy post

	function _buy_post() {

		global $wpdb;



		$system = mgm_get_option('mgm_system');

		$dge  = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;

		

		list($duration, $cost, $currency, $user_id, $post_id, $user_id, $client_ip) = explode('_', preg_replace('/^buypost_/','', $_REQUEST['custom']));



		// find user

		$user     = get_userdata($user_id);

		$blogname = get_option('blogname');

		$tran_success = false;

		$payment_status = $_POST['Status']; 

		switch ($payment_status) {

			case 'OK':

				$tran_success = true;

				$status_str = __('Last payment was successful','mgm');

				//$subject = sprintf(__('[%s] Payment receipt','mgm'),$blogname);

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />This is a notification to inform you that your payment was successful and the post you purchased is now available to view.<br />For more information please contact %4$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $system->setting['admin_email']);

				  //issue#: 280 (2011 Feb 25) (2011 Feb 25)

				// subject

				$subject = $system->get_template('payment_success_email_template_subject', array('blogname'=>$blogname), true);

				// body

				$message = $system->get_template('payment_success_email_template_body', 

										array('blogname'=>$blogname, 'name'=>$user->display_name, 

											  'email'=>$user->user_email, 

											  'admin_email'=>$system->setting['admin_email']), true);

				// after succesful payment hook

				do_action('mgm_buy_post_transaction_success', array("post_id"=>$post_id));

			break;

						

			case 'NOTAUTHED':

			case 'INVALID':

			case 'REJECTED':

				$status_str = __('Last payment was refunded or denied','mgm');

				//$subject = sprintf(__('[%s] Payment Failed','mgm'), $blogname);

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />This is a notification to inform you that your post purchase failed for the following reason: %4$s.<br />For more information please contact %5$s.','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $status_str, $system->setting['admin_email']);

				  //issue#: 280 (2011 Feb 25) (2011 Feb 25)

				// subject

				$subject = $system->get_template('payment_failed_email_template_subject', array('blogname'=>$blogname), true);

				 

				// body			

				$message = $system->get_template('payment_failed_email_template_body', 

										array('blogname'=>$blogname, 'name'=>$user->display_name, 

											  'email'=>$user->user_email, 'payment_type'=>'post purchase payment','reason'=>$status_str,

											  'admin_email'=>$system->setting['admin_email']), true);

				break;



			case 'ABORT':

				$reason = 'Unknown';

				$status_str = sprintf(__('Last payment is pending. Reason: %s','mgm'), $reason);

				//$subject = "[" . $blogname . "] Payment receipt - Status Pending";

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />This is a notification to inform you that you payment was received in pending status. Status: %4$s.<br />For more information please contact %5$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $status_str, $system->setting['admin_email']);

				  //issue#: 280 (2011 Feb 25) (2011 Feb 25)

				// subject

				$subject = $system->get_template('payment_pending_email_template_subject', array('blogname'=>$blogname), true);

				// body	

				$message = $system->get_template('payment_pending_email_template_body', 

										array('blogname'=>$blogname, 'name'=>$user->display_name, 

											  'email'=>$user->user_email, 'reason'=>$status_str,

											  'admin_email'=>$system->setting['admin_email']), true);

				break;



			default:

				$status_str = sprintf(__('Last payment status: %s','mgm'),$payment_status);

				//$subject = "[$blogname] Payment receipt";

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s).<br />Status: %4$s.<br />For more information please contact %5$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $status_str, $system->setting['admin_email']);

				  //issue#: 280 (2011 Feb 25) (2011 Feb 25)

				// subject

				$subject = $system->get_template('payment_unknown_email_template_subject', array('blogname'=>$blogname), true);				

				// body	

				$message = $system->get_template('payment_unknown_email_template_body', array('blogname'=>$blogname, 'name'=>$user->display_name, 

				                                                                              'email'=>$user->user_email, 'reason'=>$status_str,

																							  'admin_email'=>$system->setting['admin_email']), true);

		}

		// notify user

		mgm_mail($user->user_email, $subject, $message); //send an email to the buyer		



		$status = __('Failed join', 'mgm'); //overridden on a successful payment

		if ($tran_success) {

			$table_name = TBL_MGM_POSTS_PURCHASED;

			

			//if we are looking at a pack then explode the buy post item number and loop through it

			if (strpos($post_id, ',') !== false) {

				$posts = explode(',', $post_id);

			} else {

				$posts = array($post_id);

			}

			

			$posts = array_unique($posts);

			

			foreach ($posts as $post_id) {

				$sql = "INSERT INTO " . $table_name . " (user_id, post_id, unixtime)

					    VALUES (" . $user_id . ", " . $post_id . ", UNIX_TIMESTAMP())";

				$wpdb->query($sql); //insert the post purchased record

			}



			$status = __('The post was purchased successfully', 'mgm');

		}



		// notify admin, only if gateway emails on

		if (!$dge) {

			$subject = "[" . $blogname . "] Admin Notification: " . $user->user_email . " purchased post " . $post_id;

			$message = "User display name: {$user->display_name}<br />User email: {$user->user_email}<br />User ID: {$user->ID}<br />Status: " . $status . "<br />Action: Purchase post:" . $subject . "<br /><br />" . $message . "<br /><br /><pre>" . print_r($_POST, true) . '</pre>';

			mgm_mail($system->setting['admin_email'], $subject, $message);

		}

	}

	

	// buy membership

	function _buy_membership() {	

		// system	

		$system       = mgm_get_option('mgm_system');		

		$packs        = mgm_get_option('mgm_subscription_packs');

		$duration_str = $packs->duration_str;

		//$status_str   = $system->get_statuses();

		$dge          = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;

		// get custom field values

		list($duration, $amount, $currency, $user_id, $membership_type, $duration_type, $role, $client_ip, $hide_old_content, $pack_id) = explode('_', preg_replace('/^subscription_/','', $_REQUEST['custom']));

		

		// currency

		if (!$currency) {

			$currency = $this->setting['currency'];

		}

		// find user

		$user       = get_userdata($user_id);

		$mgm_member = mgm_get_member($user_id);

		

		$join_date = $mgm_member->join_date; // Get the current AC join date



		if (!$join_date) {

			$mgm_member->join_date = time(); // Set current AC join date

		}



		//if there is no duration set in the user object then run the following code

		if (empty($duration_type)) {

			//if there is no duration type then use Months

			$duration_type = 'm';

		}

		// membership type default

		if (empty($membership_type)) {

			//if there is no account type in the custom string then use the existing type

			$membership_type = md5($mgm_member->membership_type);

		}

		// validate parent method

		$membership_type_verified = $this->_validate_membership_type($membership_type, 'md5|plain');

		// verified

		if (!$membership_type_verified) {

			if (strtolower($mgm_member->membership_type) != 'free') {

				// notify admin, only if gateway emails on

				if(!$dge){

					$message = 'Could not read membership type in the following POST data. Please debug or contact magic members to fix the problem making sure to pass on the following data. <br /><br /><pre>' . "\n\n" . print_r($_POST, true) . '</pre>';

					mgm_mail($system->setting['admin_mail'], 'Error in sagepay membership verification', $message);

				}

				// abort

				return;

			} else {

				$membership_type_verified = $mgm_member->membership_type;

			}

		}

		// set

		$membership_type             = $membership_type_verified;

		// duration

		$mgm_member->duration        = $duration;

		$mgm_member->duration_type   = strtolower($duration_type);

		$mgm_member->amount          = $amount;

		$mgm_member->currency        = $currency;

		$mgm_member->membership_type = $membership_type;		

		$mgm_member->pack_id         = $pack_id;

		$mgm_member->payment_type    = 'subscription' ;

		// payment info for unsubscribe		

		$mgm_member->payment_info    = new stdClass;

		$mgm_member->payment_info->module = $this->code;

		if(isset($_POST['txn_type'])){

			$mgm_member->payment_info->txn_type = $_POST['txn_type'];

		}	

		if(isset($_POST['TxAuthNo'])){

			$mgm_member->payment_info->subscr_id = $_POST['TxAuthNo'];		

		}	

		if(isset($_POST['VPSTxId'])){	

			$mgm_member->payment_info->txn_id = $_POST['VPSTxId'];	

		}	

		// [txn_type] => subscr_signup

		// [txn_type] => subscr_payment

		// [subscr_id] => I-KV2G0LEU6RCD

		// [txn_id] => 3K2504430T514494Y

		

		// process sagepay response

		$new_status = false;

		// statusid to name

		$payment_status = $_POST['Status']; 

		// status

		switch ($payment_status) {

			case 'OK':			

				$new_status = MGM_STATUS_ACTIVE;

				$mgm_member->status_str = __('Last payment was successful','mgm');					

				

				// old type match

				$old_membership_type = mgm_get_user_membership_type($user_id, 'code');

				if ($old_membership_type != $membership_type) {

					$mgm_member->join_date = time(); // type join date as different var

				}

				// old content hide

				$mgm_member->hide_old_content = $hide_old_content; 

				

				$time = time();				

				$mgm_member->last_pay_date = date('Y-m-d', $time);				

				

				// THIS is causng double calculation

				/* ***********************************/

				if ($mgm_member->expire_date && $mgm_member->last_pay_date!=date('Y-m-d', $time)) {

					$expiry = strtotime($mgm_member->expire_date);

					if ($expiry > 0) {

						if ($expiry > $time) {

							$time = $expiry;

						}

					}

				}

				/*************************************/					

				

				// type expanded

				$duration_types = array('d'=>'DAY','m'=>'MONTH','y'=>'YEAR');

				// time

				$time = strtotime("+{$mgm_member->duration} {$duration_types[$mgm_member->duration_type]}", $time);							

				// formatted

				$time_str = date('Y-m-d', $time);				

				// date extended				

				if (!$mgm_member->expire_date || strtotime($time_str) > strtotime($mgm_member->expire_date)) {

					$mgm_member->expire_date = $time_str;										

				}

								

				// role

				if ($role) {

					$role_obj = new WP_User($user_id);

					$role_obj->set_role($role);

				}			

				

				// after succesful payment hook

				do_action('mgm_membership_transaction_success', array("user_id" =>$user_id));	



			break;

			case 'NOTAUTHED':

			case 'INVALID':

			case 'REJECTED':

				$new_status = MGM_STATUS_NULL;

				$mgm_member->status_str = __('Last payment was refunded or denied','mgm');

				break;



			case 'ABORT':

				$new_status = MGM_STATUS_PENDING;



				$reason = $_POST['StatusDetail'];

				$mgm_member->status_str = sprintf(__('Last payment is pending. Reason: %s','mgm'), $reason);

				break;



			default:

				$new_status = MGM_STATUS_ERROR;

				$mgm_member->status_str = sprintf(__('Last payment status: %s','mgm'), $_POST['StatusDetail']);

				break;

		}		

		// set status

		$mgm_member->status = $new_status;

		// update option

		update_user_option($user_id, 'mgm_member', $mgm_member, true);				



		// return action

		do_action('mgm_return_sagepay');



		// send email notification to client

		$blogname = get_option('blogname');

		switch ($new_status) {

			case MGM_STATUS_ACTIVE:

				//$subject = sprintf(__('[%s] Payment receipt','mgm'),$blogname);

				//issue#: 280 (2011 Feb 25)

				// subject

				$subject = $system->get_template('payment_success_email_template_subject', array('blogname'=>$blogname), true);

				if ($mgm_member->payment_type == 'subscription') {

					$payment_type = 'recurring subscription';

					$subscription = sprintf('%1$s %2$s every %3$s %4$s',$mgm_member->amount, $mgm_member->currency, $mgm_member->duration, 

					                                                    $duration_str[$mgm_member->duration_type]);

					//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your payment was successful for recurring subscription of %4$s %5$s every %6$s %7$s. For more information please contact %8$s','mgm');

				} else {

					$payment_type = 'one-time payment';

					$subscription = sprintf('%1$s %2$s for %3$s %4$s',$mgm_member->amount, $mgm_member->currency, $mgm_member->duration, 

					                                                  $duration_str[$mgm_member->duration_type]);	

					//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your payment was successful for a one-time payment of %4$s %5$s for %6$s %7$s. For more information please contact %8$s','mgm');

				}



				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->amount, $mgm_member->currency, $mgm_member->duration, $duration_str[$mgm_member->duration_type], $system->setting['admin_email']);

				// body

				$message = $system->get_template('payment_success_subscription_email_template_body', 

													array('blogname'=>$blogname, 'name'=>$user->display_name, 

														  'email'=>$user->user_email, 'payment_type'=>$payment_type,

														  'subscription'=>$subscription,'admin_email'=>$system->setting['admin_email']), true);

				break;



			case MGM_STATUS_NULL:

				//issue#: 280 (2011 Feb 25)

				//$subject = sprintf(__('[%s] Account inactive','mgm'), $blogname);

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your account is inactive for the following reason: %4$s. For more information please contact %5$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->status_str, $system->setting['admin_email']);

				// subject

				$subject = $system->get_template('payment_failed_email_template_subject', array('blogname'=>$blogname), true);				

				// message

				$message = $system->get_template('payment_failed_email_template_body', 

									array('blogname'=>$blogname, 'name'=>$user->display_name, 

										  'email'=>$user->user_email, 'payment_type'=>'subscription payment',

										  'reason'=>$mgm_member->status_str,

										  'admin_email'=>$system->setting['admin_email']), true);

				break;



			case MGM_STATUS_PENDING:

				//issue#: 280 (2011 Feb 25)

				//$subject = "[$blogname] Payment receipt - Status Pending";

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that you payment was received in pending status. Status: %4$s. For more information please contact %5$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->status_str, $system->setting['admin_email']);

				// subject

				$subject = $system->get_template('payment_pending_email_template_subject', array('blogname'=>$blogname), true);

				// body

				$message = $system->get_template('payment_pending_email_template_body', 

										array('blogname'=>$blogname, 'name'=>$user->display_name, 

											  'email'=>$user->user_email, 'reason'=>$mgm_member->status_str,

											  'admin_email'=>$system->setting['admin_email']), true);

				break;



			case MGM_STATUS_ERROR:

				//issue#: 280 (2011 Feb 25)

				//$subject = "[$blogname] Error on payment";

				//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that an error occurred while processing your payment. Details: %4$s. For more information please contact %5$s','mgm');

				//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $mgm_member->status_str, $system->setting['admin_email']);

				// subject

				$subject = $system->get_template('payment_error_email_template_subject', array('blogname'=>$blogname), true);				

				// body	

				$message = $system->get_template('payment_error_email_template_body', 

									array('blogname'=>$blogname, 'name'=>$user->display_name, 

										  'email'=>$user->user_email, 'reason'=>$mgm_member->status_str,

										  'admin_email'=>$system->setting['admin_email']), true);

				break;

		}



		// notify user

		mgm_mail($user->user_email, $subject, $message);		



		// send email notification to system administrator

		if (!$dge) {

			$subject = "[$blogname] {$user->user_email} - {$new_status}";

			$message = "	User display name: {$user->display_name}\n\n<br />

					User email: {$user->user_email}\n\n<br />

					User ID: {$user->ID}\n\n<br />

					Membership Type: {$membership_type}\n\n<br />

					New status: {$new_status}\n\n<br />

					Status message: {$mgm_member->status_str}\n\n<br />

					Subscription period: {$mgm_member->duration} ". $duration_str[$mgm_member->duration_type] ."\n\n<br />

					Subscription amount: {$mgm_member->amount} {$mgm_member->currency}\n<br />

					Payment Mode: {$mgm_member->payment_type}\n\n<br />

					POST Data was: \n\n<br /><br /><pre>" . print_r($_POST, true) . '</pre>';

			mgm_mail($system->setting['admin_email'], $subject, $message);

		}

	}	

	

	// cancel membership

	function _cancel_membership(){

		// system	

		$system       = mgm_get_option('mgm_system');		

		$packs        = mgm_get_option('mgm_subscription_packs');

		$duration_str = $packs->duration_str;

		//$status_str   = $system->get_statuses();

		$dge          = ($system->setting['disable_gateway_emails'] == 'Y') ? true : false;

		// get custom field values

		list($duration, $amount, $currency, $user_id, $membership_type, $duration_type, $role, $client_ip, $hide_old_content) = explode('_', preg_replace('/^subscription_/','', $_POST['custom']));

		// currency

		if (!$currency) {

			$currency = $this->setting['currency'];

		}

		// find user

		$user    = get_userdata($user_id);

		$mgm_member = mgm_get_member($user_id);		

		

		if(isset($_POST['txn_type'])){

			$mgm_member->payment_info->txn_type = $_POST['txn_type'];

		}	

		if(isset($_POST['subscr_id'])){

			$mgm_member->payment_info->subscr_id = $_POST['subscr_id'];		

		}	

		if(isset($_POST['txn_id'])){	

			$mgm_member->payment_info->txn_id = $_POST['txn_id'];	

		}	

		

		$new_status = MGM_STATUS_CANCELLED;

		$mgm_member->status_str = __('Subscription cancelled','mgm');					

		$mgm_member->expire_date = date('Y-m-d');	

		// set status

		$mgm_member->status = $new_status;

		// update user

		update_user_option($user_id, 'mgm_member', $mgm_member, true);		

			

		// send email notification to client

		$blogname = get_option('blogname');

		//issue#: 280 (2011 Feb 25)

		// email	

		//$subject = sprintf(__('[%s] Subscription Cancelled','mgm'),$blogname);				

		//$message = __('This is an automatic notification from %1$s to %2$s (%3$s). This is a notification to inform you that your subscription has been cancelled. For more information please contact %4$s','mgm');

		//$message = sprintf($message, $blogname, $user->display_name, $user->user_email, $system->setting['admin_email']);

		// subject

		$subject = $system->get_template('subscription_cancelled_email_template_subject', array('blogname'=>$blogname), true);				

		// body	

		$message = $system->get_template('subscription_cancelled_email_template_body', 

							array('blogname'=>$blogname, 'name'=>$user->display_name, 

								  'email'=>$user->user_email, 'admin_email'=>$system->setting['admin_email']), true);

		// send email notification to user

		mgm_mail($user->user_email, $subject, $message);		



		// notify admin, only if gateway emails on

		if (!$dge) {

			$subject = "[$blogname] {$user->user_email} - {$new_status}";

			$message = "	User display name: {$user->display_name}\n\n<br />

					User email: {$user->user_email}\n\n<br />

					User ID: {$user->ID}\n\n<br />

					Membership Type: {$membership_type}\n\n<br />

					New status: {$new_status}\n\n<br />

					Status message: {$mgm_member->status_str}\n\n<br />					

					Payment Mode: Cancelled\n\n<br />

					POST Data was: \n\n<br /><br /><pre>" . print_r($_POST, true) . '</pre>';

			mgm_mail($system->setting['admin_email'], $subject, $message);

		}

		

		// after cancellation hook

		do_action('mgm_membership_subscription_cancelled', array("user_id" =>$user_id));	

	}

	

	// default setting

	function _default_setting(){

		// sagepay specific

		$this->setting['vendor']         = '';

		$this->setting['encryption_key'] = '';		

		$this->setting['currency']       = mgm_get_option('mgm_system')->setting['currency'];		

		// purchase price

		if(in_array('buypost', $this->supported_buttons)){

			$this->setting['Amount']  = 4.00;

		}		

		// callback messages				

		$this->_setup_callback_messages();

		// callback urls

		$this->_setup_callback_urls();		

	}		

	

	// Filters unwanted characters out of an input string.  Useful for tidying up FORM field inputs.

	function _clean_input($strRawText,$strType) {

	

		if ($strType=="Number") {

			$strClean="0123456789.";

			$bolHighOrder=false;

		}

		else if ($strType=="VendorTxCode") {

			$strClean="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.";

			$bolHighOrder=false;

		}

		else {

			$strClean=" ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789.,'/{}@():?-_&�$=%~<>*+\"";

			$bolHighOrder=true;

		}

	

		$strCleanedText="";

		$iCharPos = 0;

	

		do

			{

				// Only include valid characters

				$chrThisChar=substr($strRawText,$iCharPos,1);

	

				if (strspn($chrThisChar,$strClean,0,strlen($strClean))>0) {

					$strCleanedText=$strCleanedText . $chrThisChar;

				}

				else if ($bolHighOrder==true) {

					// Fix to allow accented characters and most high order bit chars which are harmless

					if (bin2hex($chrThisChar)>=191) {

						$strCleanedText=$strCleanedText . $chrThisChar;

					}

				}

	

			$iCharPos=$iCharPos+1;

			}

		while ($iCharPos<strlen($strRawText));

	

		$cleanInput = ltrim($strCleanedText);

		return $cleanInput;

	

	}



	/* Base 64 Encoding function **

	** PHP does it natively but just for consistency and ease of maintenance, let's declare our own function **/

	

	function _base64_encode($plain) {

	

	  // Initialise output variable

	  $output = "";

	

	  // Do encoding

	  $output = base64_encode($plain);

	

	  // Return the result

	  return $output;

	}



	/* Base 64 decoding function **

	** PHP does it natively but just for consistency and ease of maintenance, let's declare our own function **/

	

	function _base64_decode($scrambled) {

	  // Initialise output variable

	  $output = "";

	

	  // Fix plus to space conversion issue

	  $scrambled = str_replace(" ","+",$scrambled);

	

	  // Do encoding

	  $output = base64_decode($scrambled);

	

	  // Return the result

	  return $output;

	}





	/*  The SimpleXor encryption algorithm                                                                                **

	**  NOTE: This is a placeholder really.  Future releases of Form will use AES or TwoFish.  Proper encryption      **

	**  This simple function and the Base64 will deter script kiddies and prevent the "View Source" type tampering        **

	**  It won't stop a half decent hacker though, but the most they could do is change the amount field to something     **

	**  else, so provided the vendor checks the reports and compares amounts, there is no harm done.  It's still          **

	**  more secure than the other PSPs who don't both encrypting their forms at all                                      */

	

	function _simpleXor($InString, $Key) {

	  // no key

	  if($Key==''){

	  	return '';

	  	// die(__('No key for Sagepay','mgm'));

	  }	

	  // Initialise key array

	  $KeyList = array();

	  // Initialise out variable

	  $output = "";

		

	  // Convert $Key into array of ASCII values

	  for($i = 0; $i < strlen($Key); $i++){

		$KeyList[$i] = ord(substr($Key, $i, 1));

	  }

	

	  // Step through string a character at a time

	  for($i = 0; $i < strlen($InString); $i++) {

		// Get ASCII code from string, get ASCII code from key (loop through with MOD), XOR the two, get the character from the result

		// % is MOD (modulus), ^ is XOR

		$output.= chr(ord(substr($InString, $i, 1)) ^ ($KeyList[$i % strlen($Key)]));

	  }

	

	  // Return the result

	  return $output;

	}

	

	// Function to check validity of email address entered in form fields

	function _is_valid_email($email) {

	  $result = TRUE;

	  if(!preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,4})$/i", $email)) {

		$result = FALSE;

	  }

	  return $result;

	}	

	

	// parse crypt

	function _get_token($thisString) {



	  // List the possible tokens

	  $Tokens = array(

		"Status",

		"StatusDetail",

		"VendorTxCode",

		"VPSTxId",

		"TxAuthNo",

		"Amount",

		"AVSCV2", 

		"AddressResult", 

		"PostCodeResult", 

		"CV2Result", 

		"GiftAid", 

		"3DSecureStatus", 

		"CAVV",

		"AddressStatus",

		"CardType",

		"Last4Digits",

		"PayerStatus","CardType");

		

	  // Initialise arrays

	  $output = array();

	  $resultArray = array();

	  

	  // Get the next token in the sequence

	  for ($i = count($Tokens)-1; $i >= 0 ; $i--){

		// Find the position in the string

		$start = strpos($thisString, $Tokens[$i]);

		// If it's present

		if ($start !== false){

		  // Record position and token name

		  $resultArray[$i]->start = $start;

		  $resultArray[$i]->token = $Tokens[$i];

		}

	  }

	  

	  // Sort in order of position

	  sort($resultArray);

		// Go through the result array, getting the token values

	  for ($i = 0; $i<count($resultArray); $i++){

		// Get the start point of the value

		$valueStart = $resultArray[$i]->start + strlen($resultArray[$i]->token) + 1;

		// Get the length of the value

		if ($i==(count($resultArray)-1)) {

		  $output[$resultArray[$i]->token] = substr($thisString, $valueStart);

		} else {

		  $valueLength = $resultArray[$i+1]->start - $resultArray[$i]->start - strlen($resultArray[$i]->token) - 2;

		  $output[$resultArray[$i]->token] = substr($thisString, $valueStart, $valueLength);

		}      

	

	  }

	

	  // Return the ouput array

	  return $output;

	}

	

	// generate crypt

	function _crypt($data=NULL){

		// if array : generate

		if(is_array($data)){

			$strdata = mgm_http_build_query($data,false);				

			return $this->_base64_encode($this->_simpleXor($strdata,$this->setting['encryption_key']));

		}elseif(is_string($data)){

			$strDecoded = $this->_simpleXor($this->_base64_decode($data),$this->setting['encryption_key']);

			$values     = $this->_get_token($strDecoded);

			// return

			return $values;

		}

	}

}



// end file